function dm00

% Menu principal

% Problemas Resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

% jlh: ene-nov 2006

% Ventana principal

fondo = [0 0 0];
colortit = [1 0.5 0];
colorcap = [0 0.2 0.6];
colornum = [0.9 0.9 0.9];

figure('Menubar','None',...
    'Color',fondo,...
    'Units','normalized', ...
    'Position',[0.05 0.1 0.9 0.8], ...
    'Numbertitle','off',...
    'Name','Problemas Resueltos de Mtodos Numricos');

% Plantilla
sep = 0.04;
fil = 3;
col = 4;
fc = fil*col;
ancho_ejes = (1-col*sep)/col;
alto_ejes = (1-fil*sep)/fil;
x_ejes = sep/2:sep+ancho_ejes:1;
y_ejes = sep/2:sep+alto_ejes:1;
y_ejes = fliplr(y_ejes);
[Y_ejes,X_ejes] = meshgrid(y_ejes,x_ejes);


%====================================

% Ttulo

ejes_pos = [X_ejes(6), Y_ejes(6), ancho_ejes, alto_ejes];
ax1 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

image(imread('prmn.jpg'))
axis equal off

ejes_pos = [X_ejes(7)-sep, Y_ejes(7), ancho_ejes, alto_ejes];
ax0 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

Titulo = [...
    'Problemas Resueltos '; ...
    'de Mtodos Numricos'];

tx1 = text( ...
    'String',Titulo, ...
    'Position', [0,0.6], ...
    'VerticalAlignment','bottom', ...
    'HorizontalAlignment','Left', ...
    'FontSize',18, ...
    'FontName','Arial', ...
    'FontWeight','demi', ...
    'Color',colortit);

Autores = [...
    'Alicia Cordero Barbero       ';...
    'Jos Luis Hueso Pagoaga      ';...
    'Eulalia Martnez Molada      ';...
    'Juan Ramn Torregrosa Snchez'];

tx2 = text( ...
    'String',Autores, ...
    'Position',[0,0.4], ...
    'FontName','verdana', ...
    'FontSize',8, ...
    'FontWeight','demi', ...
    'Color',colorcap, ...
    'VerticalAlignment','top', ...
    'HorizontalAlignment','Left');

%====================================

% Captulo 1
cap = 1;
enlace01 = 'addpath(''dm01''), dm01';
ax01 = axes;
ejes_pos = [X_ejes(cap)-sep, Y_ejes(cap)-2*sep, ...
    ancho_ejes+2*sep, alto_ejes+4.5*sep];

% Figura 1
s = -2:0.2:2;
t = 0:pi/20:2*pi;
[T,S] = meshgrid(t,s);
X = S.*cos(T);
Y = -S.*sin(T);
Z = T;
mes = mesh(X,Y,Z);
set(mes,'FaceColor',fondo)

% Ejes
set(ax01, ...
    'Position',ejes_pos, ...
    'Visible','off')

% Ttulo
Capitulo01 = [...
    'Introduccin'; ...
    '  a MATLAB  '];
text_pos = [-2 -3 8];
tx01 = text( ...
    'String',Capitulo01, ...
    'Position',text_pos, ...
    'HorizontalAlignment','Center', ...
    'VerticalAlignment','middle', ...
    'FontName','Arial', ...
    'Fontweight','demi', ...
    'FontSize',14, ...
    'Color','White');
set(get(ax01,'Children'), ...
    'ButtonDownFcn',enlace01);

% Fin captulo 1

%====================================

% Captulo 2
cap = 2;
ax02 = axes;
enlace02 = 'addpath(''dm02''), dm02';

% Figura 2
k = 0; a=0.8;b=1.1;
x = [a,b];
incr = b-a;
f02 = inline('x.^10-1');
fa = f02(a); fb = f02(b);
y = [fa,fb];
ae = a-0.04*incr;
be = b+0.04*incr;
n = 10;
hx =(be-ae)/n;
hy = abs(fb-fa)/n;
xg = linspace(ae,be);
yg = f02(xg);
plot(xg,yg)
hold on
plot([ae,be],[0 0],'g')
plot(a,0,'cx',[a a],[0 fa],'r:')
plot(b,0,'cx',[b b],[0 fb],'r:')
while  k<4
    c = (a*fb-b*fa)/(fb-fa);
    plot([a b],[fa fb],'y:')
    fc=f02(c);
    plot(c,0,'yx',[c c],[0 fc],'r:')
    a = c; fa = fc;
    k = k+1;
end

% Ejes
axis02 = axis;
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax02, ...
    'XTickLabel',[], ...
    'YTickLabel',[], ...
    'Box','off', ...
    'Color',fondo, ...
    'XColor',fondo, ...
    'YColor',fondo, ...
    'ZColor',fondo, ...
    'ButtonDownFcn',enlace02, ...
    'Position',ejes_pos)
axis(axis02);

% Ttulo
Capitulo02 = [...
    '  Resolucin '; ...
    'de Ecuaciones'];
lims = axis;
dlims = diff(axis)/2;
text_pos = [lims(1)+dlims(1) lims(3)+dlims(3)];
tx02 = text( ...
    'String',Capitulo02, ...
    'Position',text_pos, ...
    'HorizontalAlignment','Center', ...
    'VerticalAlignment','middle', ...
    'FontName','Arial', ...
    'Fontweight','demi', ...
    'FontSize',14, ...
    'Color',colornum);
set(get(gca,'Children'), ...
    'ButtonDownFcn',enlace02);

% Fin captulo 2

%====================================

% Captulo 3: Interpolacin polinmica
cap = 3;
ax03 = axes;
enlace03 = 'addpath(''dm03''), dm03';

% Figura 3: Funcin de Runge con nodos de Chebychef
xf=linspace(-5,5);
yf=1./(1+xf.^2);
n=12;
k=1:n+1;
x=5*cos(((2*(n-(k-1))+1)/(2*n+2))*pi);
y=1./(1+x.^2);;
p=polyfit(x,y,n);
yp=polyval(p,xf);
plot(x,y,'r*',xf,yf,'b',xf,yp,'g');

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax03, ...
    'XTickLabel',[], ...
    'YTickLabel',[], ...
    'Box','off', ...
    'Color',fondo, ...
    'XColor',fondo, ...
    'YColor',fondo, ...
    'ZColor',fondo, ...
    'ButtonDownFcn',enlace03, ...
    'Position',ejes_pos)

% Ttulo
Capitulo03 = [...
    'Interpolacin'; ...
    ' Polinmica  '];
lims = axis;
dlims = diff(axis)/2;
text_pos = [lims(1)+dlims(1) lims(3)+dlims(3)];
tx03 = text( ...
    'String',Capitulo03, ...
    'Position',text_pos, ...
    'HorizontalAlignment','Center', ...
    'VerticalAlignment','middle', ...
    'FontName','Arial', ...
    'Fontweight','demi', ...
    'FontSize',14, ...
    'Color',colornum);
set(get(gca,'Children'), ...
    'ButtonDownFcn',enlace03);

% Fin captulo 3

%====================================

% Captulo 4: Integracin numrica
cap = 4;
ax04 = axes;
enlace04 = 'addpath(''dm04''), dm04';

% Figura 4: Trapecios
a = 0; b = 2*pi;
f04 = inline('1+0.4*x+sin(x)');
n=5;
x=linspace(a,b,n+1);
y = f04(x);
incr = b-a;
ae = a-0.04*incr;
be = b+0.04*incr;
xg = linspace(ae,be);
yg = f04(xg);
plot(x,y,'y',xg,yg)
hold on
plot([ae,be],[0 0],'g')
for k=1:n+1;
    plot([x(k) x(k)],[0 y(k)],'r:')
end
hold off
axis04=axis;

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax04, ...
    'XTickLabel',[], ...
    'YTickLabel',[], ...
    'Box','off', ...
    'Color',fondo, ...
    'XColor',fondo, ...
    'YColor',fondo, ...
    'ZColor',fondo, ...
    'ButtonDownFcn',enlace04, ...
    'Position',ejes_pos)
axis(axis04);

% Ttulo
Capitulo04 = [...
    'Integracin'; ...
    ' Numrica  '];
dlims = diff(axis04)/2;
text_pos = [axis04(1)+dlims(1) axis04(3)+dlims(3)];
tx04 = text( ...
    'String',Capitulo04, ...
    'Position',text_pos, ...
    'HorizontalAlignment','Center', ...
    'VerticalAlignment','middle', ...
    'FontName','Arial', ...
    'Fontweight','demi', ...
    'FontSize',14, ...
    'Color',colornum);
set(get(gca,'Children'), ...
    'ButtonDownFcn',enlace04);

% Fin captulo 4

%====================================

% Captulo 5: Problemas de valor inicial
cap = 5;
ax05 = axes;
enlace05 = 'addpath(''dm05''), dm05';

% Figura 5: Campo de direcciones
f05 = inline(['-1/(2.1*1.1)*I+1/2.1*exp(-0.06*pi*t)',...
    '.*(-0.06*pi*sin(2+t-pi)+2*cos(2*t-pi))'],'t','I');
n = 20;
h = 2/n;
t = 0:h:2;
I = 0:.1:1;
[tt,II] = meshgrid(t(1:2:end),I);
uno =ones(size(tt)); dI = f05(tt,II);
quiver(tt,II,uno,dI,'m')
hold on
for j=0:0.3:2
    y(1) = j;
    for k=1:n
        k1 = f05(t(k),y(k));
        yp = y(k)+h*k1;
        k2 = f05(t(k+1),yp);
        y(k+1) = y(k) + h/2*(k1+k2);
    end
    plot(t,y,'g')
end
axis([0 2 0 1])
hold off
axis05 = axis;

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax05, ...
    'XTickLabel',[], ...
    'YTickLabel',[], ...
    'Box','off', ...
    'Color',fondo, ...
    'XColor',fondo, ...
    'YColor',fondo, ...
    'ZColor',fondo, ...
    'ButtonDownFcn',enlace05, ...
    'Position',ejes_pos)

% Ttulo
Capitulo05 = [...
    'Problemas de '; ...
    'Valor Inicial'];
dlims = diff(axis05)/2;
text_pos = [axis05(1)+dlims(1) axis05(3)+dlims(3)];
tx05 = text( ...
    'String',Capitulo05, ...
    'Position',text_pos, ...
    'HorizontalAlignment','Center', ...
    'VerticalAlignment','middle', ...
    'FontName','Arial', ...
    'Fontweight','demi', ...
    'FontSize',14, ...
    'Color','White');
set(get(gca,'Children'), ...
    'ButtonDownFcn',enlace05);

% Fin captulo 5

%====================================

% Captulo 6: Sistemas de Ecuaciones lineales
cap = 8;
ax06 = axes;
enlace06 = 'addpath(''dm06''), dm06';

% Figura 6: Planos
x = 0:0.2:2;
y = x;
[X,Y] = meshgrid(x,y);
m1 = mesh(X,Y,-X-Y+3);
hold on
m2 = mesh(X,Y,2*X-Y-1);
m3 = mesh(X,Y,-X+2*Y);
set([m1 m2 m3], ...
    'FaceColor',fondo)
view(-37.5,10)
axis06=axis;

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
ejes_pos = [X_ejes(cap), ...
    Y_ejes(cap)-2*sep, ...
    ancho_ejes, ...
    alto_ejes+2.5*sep];
set(ax06, ...
    'XTickLabel',[], ...
    'YTickLabel',[], ...
    'Box','off', ...
    'Color',fondo, ...
    'XColor',fondo, ...
    'YColor',fondo, ...
    'ZColor',fondo, ...
    'ButtonDownFcn',enlace06, ...
    'Position',ejes_pos)

% Ttulo
Capitulo06 = [...
    '  Sistemas   '; ...
    'de Ecuaciones'; ...
    '  Lineales   '];
dlims = diff(axis06)/2;
text_pos = [0.2 0 1];
tx06 = text( ...
    'String',Capitulo06, ...
    'Position',text_pos, ...
    'HorizontalAlignment','Center', ...
    'VerticalAlignment','middle', ...
    'FontName','Arial', ...
    'Fontweight','demi', ...
    'FontSize',14, ...
    'Color','White');
set(get(gca,'Children'), ...
    'ButtonDownFcn',enlace06);

% Fin captulo 6

%====================================


% Captulo 7: Teora de Aproximacin
cap = 9;
ax07 = axes;
enlace07 = 'addpath(''dm07''), dm07';

% Figura 7: Ajuste minimo cuadratico
x=linspace(-2,2,50);
y=x.^3-0.5*x+2*randn(size(x));
p=polyfit(x,y,3);
z=polyval(p,x);
plot(x,y,'.',x,z)
axis07=axis;

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax07, ...
    'XTickLabel',[], ...
    'YTickLabel',[], ...
    'Box','off', ...
    'Color',fondo, ...
    'XColor',fondo, ...
    'YColor',fondo, ...
    'ZColor',fondo, ...
    'ButtonDownFcn',enlace07, ...
    'Position',ejes_pos)

% Ttulo
Capitulo07 = [...
    ' Teora de  '; ...
    'Aproximacin'];
dlims = diff(axis07)/2;
text_pos = [axis07(1)+dlims(1) axis07(3)+dlims(3)];
tx07 = text( ...
    'String',Capitulo07, ...
    'Position',text_pos, ...
    'HorizontalAlignment','Center', ...
    'VerticalAlignment','middle', ...
    'FontName','Arial', ...
    'Fontweight','demi', ...
    'FontSize',14, ...
    'Color',colornum);
set(get(gca,'Children'), ...
    'ButtonDownFcn',enlace07);

% Fin captulo 7

%====================================

% Captulo 8: Sistemas no lineales
cap = 10;
ax08 = axes;
enlace08 = 'addpath(''dm08''), dm08';

% Figura 8: Punto fijo en 2 variables
xp = linspace(-1.5,1.5);
yp = xp.^2-0.5;
s = linspace(0,2*pi);
xe = 1.99*cos(s);
ye = sin(s);
f08 = inline('[0.5*(x(1)^2 - x(2) + 0.5), (-x(1)^2 - 4*x(2)^2 + 4 + 8*x(2))/8]','x');
x = [2,2];
for k=1:10
    x(k+1,:)=f08(x(k,:));
end
plot(xp+1,yp,xe,ye,x(:,1),x(:,2),x(:,1),x(:,2),'r.')
axis08=axis;

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax08, ...
    'XTickLabel',[], ...
    'YTickLabel',[], ...
    'Box','off', ...
    'Color',fondo, ...
    'XColor',fondo, ...
    'YColor',fondo, ...
    'ZColor',fondo, ...
    'ButtonDownFcn',enlace08, ...
    'Position',ejes_pos)
axis(axis08);

% Ttulo
Capitulo08 = [...
    '   Sistemas  '; ...
    'de Ecuaciones'; ...
    ' no Lineales '];
dlims = diff(axis08)/2;
text_pos = [axis08(1)+dlims(1) axis08(3)+dlims(3)];
tx08 = text( ...
    'String',Capitulo08, ...
    'Position',text_pos, ...
    'HorizontalAlignment','Center', ...
    'VerticalAlignment','middle', ...
    'FontName','Arial', ...
    'Fontweight','demi', ...
    'FontSize',14, ...
    'Color',colornum);
set(get(gca,'Children'), ...
    'ButtonDownFcn',enlace08);

% Fin captulo 8

%====================================

% Captulo 9: Problemas de Frontera
cap = 11;
ax09 = axes;
enlace09 = 'addpath(''dm09''), dm09';

% Figura 9: Disparo secante
f09 = inline('[y(2);(32 + 2*x^3 - y(1)*y(2))/8]','x','y');
n = 20;
h = 2/n;
t = 1:h:3;
alfa = 17;
beta = 43/3;
dy0 = -10;
y = [alfa;dy0];
for k = 1:n
    k1 = f09(t(k),y(:,k));
    yp = y(:,k)+h*k1;
    k2 = f09(t(k+1),yp);
    y(:,k+1) = y(:,k) + h/2*(k1+k2);
end
Y = -y(1,:);
yb(1) = y(1,end);

% Segundo tiro
dy(2) = -20;
y = [alfa;dy(2)];
for k = 1:n
    k1 = f09(t(k),y(:,k));
    yp = y(:,k)+h*k1;
    k2 = f09(t(k+1),yp);
    y(:,k+1) = y(:,k) + h/2*(k1+k2);
end
Y = [Y;-y(1,:)];
yb(2) = y(1,end);

% Ajuste por la secante
for j=3:8
    dy(j)=dy(j-1) -(dy(j-1)-dy(j-2))/(yb(j-1)-yb(j-2))*(yb(j-1)-beta);
    y = [alfa;dy(j)];
    for k = 1:n
        k1 = f09(t(k),y(:,k));
        yp = y(:,k)+h*k1;
        k2 = f09(t(k+1),yp);
        y(:,k+1) = y(:,k) + h/2*(k1+k2);
    end
    Y = [Y;-y(1,:)];
    yb(j) = y(1,end);
end
plot(t,Y')
hold on
plot(t(end),Y(:,end),'*')
hold off
axis09=axis;

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax09, ...
    'XTickLabel',[], ...
    'YTickLabel',[], ...
    'Box','off', ...
    'Clipping','off', ...
    'Color',fondo, ...
    'XColor',fondo, ...
    'YColor',fondo, ...
    'ZColor',fondo, ...
    'ButtonDownFcn',enlace09, ...
    'Position',ejes_pos)

% Ttulo
Capitulo09 = [...
    ' Problemas '; ...
    'de Frontera'];
dlims = diff(axis09)/2;
text_pos = [axis09(1)+dlims(1) axis09(3)+dlims(3)];
tx09 = text( ...
    'String',Capitulo09, ...
    'Position',text_pos, ...
    'HorizontalAlignment','Center', ...
    'VerticalAlignment','middle', ...
    'FontName','Arial', ...
    'Fontweight','demi', ...
    'FontSize',14, ...
    'Color',colornum);
set(get(gca,'Children'), ...
    'ButtonDownFcn',enlace09);

% Fin captulo 9

%====================================

% Captulo 10: Ecuaciones en Derivadas Parciales
cap = 12;
ax10 = axes;
enlace10 = 'addpath(''dm10''), dm10';

% Figura 10: Ecuacion de ondas
x = linspace(0,3*pi,60);
y = linspace(0,pi,20);
[X,Y] = meshgrid(x,y);
Z = sin(Y).*cos(X);
m = mesh(X,Y,Z);
set(m,'FaceColor',fondo)
axis10=axis;

% Ejes
ejes_pos = [X_ejes(cap)-sep Y_ejes(cap) ancho_ejes+sep alto_ejes];
ejes_pos = [X_ejes(cap)-0.5*sep, ...
    Y_ejes(cap)-sep, ...
    ancho_ejes+sep, ...
    alto_ejes+3*sep];
set(ax10, ...
    'XTickLabel',[], ...
    'YTickLabel',[], ...
    'Box','off', ...
    'Color',fondo, ...
    'XColor',fondo, ...
    'YColor',fondo, ...
    'ZColor',fondo, ...
    'ButtonDownFcn',enlace10, ...
    'Position',ejes_pos)

% Ttulo
Capitulo10 = [...
    ' Ecuaciones '; ...
    'en Derivadas'; ...
    ' Parciales  '];
dlims = diff(axis10)/2;
text_pos = [0 -0.8 0.7];
tx10 = text( ...
    'String',Capitulo10, ...
    'Position',text_pos, ...
    'HorizontalAlignment','Center', ...
    'VerticalAlignment','middle', ...
    'FontName','Arial', ...
    'Fontweight','demi', ...
    'FontSize',14, ...
    'Color','White');
set(get(gca,'Children'), ...
    'ButtonDownFcn',enlace10);

% Fin captulo 10

%====================================
