function dm01

% Capitulo 1
% Introduccin a MATLAB

% Problemas Resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

% jlh: ene-2006

% Ventana principal
fondo = [0 0 0];
colortit = [1 0.5 0];
colorcap = [0 0.3 0.9];
colornum = [0.9 0.9 0.9];

figure('Menubar','None',...
    'Color',fondo,...
    'Units','normalized', ...
    'Position',[0.05 0.1 0.9 0.8], ...
    'Numbertitle','off',...
    'Name','Captulo 1. Introduccin a MATLAB');

% Plantilla
sep = 0.04;
fil = 3;
col = 4;
fc = fil*col;
ancho_ejes = (1-col*sep)/col;
alto_ejes = (1-fil*sep)/fil;
x_ejes = sep/2:sep+ancho_ejes:1;
y_ejes = sep/2:sep+alto_ejes:1;
y_ejes = fliplr(y_ejes);
[Y_ejes,X_ejes] = meshgrid(y_ejes,x_ejes);

%====================================

% Titulo

ejes_pos = [X_ejes(6), Y_ejes(6), ancho_ejes, alto_ejes];
ax1 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

image(imread('prmn.jpg'))
axis equal off

ejes_pos = [X_ejes(7)-sep, Y_ejes(7), ancho_ejes, alto_ejes];
ax0 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

Capitulo = [...
        'Introduccin';...
        '  a MATLAB  '];

tx1 = text( ...
    'String',Capitulo, ...
    'Position', [0.5,0.5], ...
    'VerticalAlignment','middle', ...
    'HorizontalAlignment','Center', ...
    'FontSize',22, ...
    'FontName','Arial', ...
    'FontWeight','demi', ...
    'Color',colortit);

%====================================

% Problema 1.1
cap = 1;
ax01 = axes;
ejes_pos = [X_ejes(cap), Y_ejes(cap), ancho_ejes, alto_ejes];
enlace01 = ['menupcn(1,1)'];

% Figura 1: Triangulo de Tartaglia hasta la fila n
n = 6;
T = zeros(n,n+1);
v = [1 1];
T(1,1:2)=v;
for k = 2:n
    v = [v 0] + [0 v];
    T(k,1:k+1) = v;
end
R = num2str(T);         % Convierte la matriz numerica a matriz de caracteres
L = size(R,2);          % Numero de columnas de la matriz de caracteres
m = (L-1)/n;            % Espaciado entre las columnas de caracteres
S = [];
for k = 1:n
    bk = ceil((n-k)*m/2);           % Aade espacios en blanco
    Sk = [blanks(bk),R(k,1:k*m+1)];
    S = strvcat(S,Sk);              % Aade la fila k
end
set(ax01, ...
    'Position',ejes_pos, ...
    'Color',fondo, ...
    'XColor',fondo, ...
    'YColor',fondo, ...
    'ZColor',fondo, ...
    'ButtonDownFcn',enlace01);
Problema01 = S;
lims = axis;
dlims = diff(axis)/2;
text_pos = [lims(1)+dlims(1) lims(3)+dlims(3)];
tx01 = text( ...
    'String',Problema01, ...
    'Position',text_pos, ...
    'HorizontalAlignment','Center', ...
    'FontName','times', ...
    'Fontweight','bold', ...
    'FontSize',12, ...
    'Color','red');
num_pos = [lims(1) lims(4)];
pr01 = text( ...
    'String','1. Tringulo de Tartaglia', ...
    'Position',num_pos, ...
    'HorizontalAlignment','left', ...
    'VerticalAlignment','top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);

set(get(ax01,'Children'), ...
    'ButtonDownFcn',enlace01);

% Fin Problema 1.1
   
%====================================

% Problema 1.2
cap = 2;
ax02 = axes;
enlace02 = ['menupcn(1,2)'];
ejes_pos = [X_ejes(cap), Y_ejes(cap), ancho_ejes, alto_ejes];
set(ax02, ...
    'XTickLabel',[], ...
    'YTickLabel',[], ...
    'Box','off', ...
    'Color',fondo, ...
    'XColor',fondo, ...
    'YColor',fondo, ...
    'ZColor',fondo, ...
    'ButtonDownFcn',enlace02, ...
    'Position',ejes_pos)

% Ttulo
lims = axis;
dlims = diff(axis)/2;
num_pos = [lims(1) lims(4)];
Problema02 = '2. Sucesin de Fibonacci';
pr02 = text( ...
    'String',Problema02, ...
    'Position',num_pos, ...
    'HorizontalAlignment','left', ...
    'VerticalAlignment','top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);
set(get(gca,'Children'), ...
    'ButtonDownFcn',enlace02);
% Ejes 2
ax022=axes;
n=11;
X=zeros(4,n);
Y=X;
F(1)=1;
F(2)=1;
x = [0 1];
y = x;
X(:,1:2)=[0 1;1 1;1 0;0 0];
Y(:,1:2)=[0 1;0 2;1 2;1 1];
for k = 3:n
    F(k) = F(k-2)+F(k-1);
    dx = (-1)^floor(k/2)*F(k);
    dy = (-1)^floor((k-1)/2)*F(k);
    X(1,k)=X(3,k-1);
    X(3,k)=X(3,k-1)+dx;
    X(2,k)=X(3,k);
    X(4,k)=X(1,k);
    Y(1,k)=Y(3,k-1);
    Y(3,k)=Y(3,k-1)+dy;
    Y(2,k)=Y(1,k);
    Y(4,k)=Y(3,k);
end
fill(X,Y,(1:n))
axis equal
axis off
set(ax022, 'Position',ejes_pos)
set(get(gca,'Children'), ...
    'ButtonDownFcn',enlace02);

% Fin Problema 1.2
   
%====================================

% Problema 1.3: Polinomios de Taylor
cap = 3;
ax03 = axes;
enlace03 = ['menupcn(1,3)'];

% Figura 3: Polinomios de Taylor del logaritmo
x = (-0.99:0.01:1)';
y = x;
for k = 2:7
    y(:,k) = y(:,k-1) + (-1)^(k+1)*x.^k/k;
end
plot(x,log(1+x),':',x,y)
axis([-1 1 -3 1.4])


% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax03, ...
    'XTickLabel',[], ...
    'YTickLabel',[], ...
    'Box','off', ...
    'Color',fondo, ...
    'XColor',fondo, ...
    'YColor',fondo, ...
    'ZColor',fondo, ...
    'ButtonDownFcn',enlace03, ...
    'Position',ejes_pos)

% Ttulo
lims = axis;
dlims = diff(axis)/2;
num_pos = [lims(1) lims(4)];
pr03 = text( ...
    'String','3. Polinomios de Taylor', ...
    'Position',num_pos, ...
    'HorizontalAlignment','left', ...
    'VerticalAlignment','top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);
set(get(gca,'Children'), ...
    'ButtonDownFcn',enlace03);

% Fin Problema 1.3
   
%====================================

% Problema 1.4: Aproximacin del nmero pi
cap = 4;
ax04 = axes;
enlace04 = ['menupcn(1,4)'];

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax04, ...
    'XTickLabel',[], ...
    'YTickLabel',[], ...
    'Box','off', ...
    'Color',fondo, ...
    'XColor',fondo, ...
    'YColor',fondo, ...
    'ZColor',fondo, ...
    'ButtonDownFcn',enlace04, ...
    'Position',ejes_pos)
%axis(axis04);
% Ttulo
lims = axis;
dlims = diff(axis)/2;
num_pos = [lims(1) lims(4)];
Problema04 = '4. Aproximacin al nmero pi';
pr03 = text( ...
    'String',Problema04, ...
    'Position',num_pos, ...
    'HorizontalAlignment','left', ...
    'VerticalAlignment','top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);
text_pos = [0.5 0.6];
tx04 = text( ...
    'String','p', ...
    'Position',text_pos, ...
    'HorizontalAlignment','Center', ...
    'VerticalAlignment','middle', ...
    'FontName','symbol', ...
    'FontSize',144, ...
    'Color','yellow');
set(get(gca,'Children'), ...
    'ButtonDownFcn',enlace04);

% Fin Problema 1.4
   
%====================================

% Problema 1.5: Divisin de polinomios
cap = 5;
ax05 = axes;
enlace05 = ['menupcn(1,5)'];

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax05, ...
    'XTickLabel',[], ...
    'YTickLabel',[], ...
    'Box','off', ...
    'Color',fondo, ...
    'XColor',fondo, ...
    'YColor',fondo, ...
    'ZColor',fondo, ...
    'ButtonDownFcn',enlace05, ...
    'Position',ejes_pos)
%axis(axis05);
% Ttulo
lims = axis;
dlims = diff(axis)/2;
num_pos = [lims(1) lims(4)];
Problema05 = '5. Divisin de polinomios';
pr05 = text( ...
    'String',Problema05, ...
    'Position',num_pos, ...
    'HorizontalAlignment','left', ...
    'VerticalAlignment','top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);
text05 = [ ...
        ' x^3     -2x-5     x-2     ';...
        '-x^3+2x^2          x^2+2x+2';...
        '     2x^2-2x               ';...
    	'    -2x^2+4x               ';...
		'          2x-5             ';...
		'         -2x+4             ';...
		'            -1             '];
    
    
text_pos = [0.5 0.5];
tx05 = text( ...
    'String',text05, ...
    'Position',text_pos, ...
    'HorizontalAlignment','Center', ...
    'VerticalAlignment','middle', ...
    'FontName','courier', ...
    'FontSize',10, ...
    'Color','yellow');
%set(texto05 
set(get(gca,'Children'), ...
    'ButtonDownFcn',enlace05);

% Fin Problema 1.5
   
%====================================

% Problema 1.6: Cambio de base de polinomios
cap = 8;
ax06 = axes;
enlace06 = ['menupcn(1,6)'];

% Figura 
x = linspace(-1,2);
y = polyval([5 14 16 8],x-1);
plot(x,y,':',x,[8*ones(size(x)); 16*(x-1); 14*(x-1).^2; 5*(x-1).^3])
axis([-1 2 -40 80])
% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax06, ...
    'Color',fondo, ...
    'YTickLabel',[], ...
    'YAxisLocation','right', ...
    'Box','off', ...
    'XColor','White', ...
    'YColor','White', ...
    'ButtonDownFcn',enlace06, ...
    'Position',ejes_pos)
% Ttulo
lims = axis;
dlims = diff(axis)/2;
num_pos = [lims(1) lims(4)];
Problema06 = [...
        '6. Cambio de base';
        '   de polimonios '];
pr06 = text( ...
    'String',Problema06, ...
    'Position',num_pos, ...
    'HorizontalAlignment','left', ...
    'VerticalAlignment','top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);
set(get(gca,'Children'), ...
    'ButtonDownFcn',enlace06);

% Fin Problema 1.6
   
%====================================
   

% Problema 1.7: Campo elctrico creado por un dipolo
cap = 9;
ax07 = axes;
enlace07 = ['menupcn(1,7)'];

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax07, ...
    'XTickLabel',[], ...
    'YTickLabel',[], ...
    'Box','off', ...
    'Color',fondo, ...
    'XColor',fondo, ...
    'YColor',fondo, ...
    'ZColor',fondo, ...
    'ButtonDownFcn',enlace07, ...
    'Position',ejes_pos)

% Ttulo
lims = axis;
dlims = diff(axis)/2;
num_pos = [lims(1) lims(4)];
Problema07 = [...
        '7. Campo elctrico creado';
        '   por un dipolo         '];
pr07 = text( ...
    'String',Problema07, ...
    'Position',num_pos, ...
    'HorizontalAlignment','left', ...
    'VerticalAlignment','top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);

% Ejes 3D
ax073D = axes;
q = 2e-6; k = 9e9;
a = 1.5; b = -1.5;
x = -4 : 1/3 : 4;
y = -4 : 1/3 : 4;
[X,Y] = meshgrid(x,y);
rp = sqrt((X-a).^2+(Y-b).^2);
rn = sqrt((X+a).^2+(Y+b).^2);
V = q*k*(1./rp-1./rn);
surf(X,Y,V)
view(-37.5,20)
%shading flat
axis off
set(ax073D,...
    'Position',ejes_pos)
set(get(gca,'Children'), ...
    'ButtonDownFcn',enlace07);

% Fin Problema 1.7

%====================================

% Problema 1.8: Generacin de superficies
cap = 10;

% Ejes 2D
ax08 = axes;
enlace08 = ['menupcn(1,8)'];
axis08=axis;
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax08, ...
    'XTickLabel',[], ...
    'YTickLabel',[], ...
    'Box','off', ...
    'Color',fondo, ...
    'XColor',fondo, ...
    'YColor',fondo, ...
    'ZColor',fondo, ...
    'ButtonDownFcn',enlace08, ...
    'Position',ejes_pos)
axis(axis08);
% Ttulo
lims = axis;
dlims = diff(axis)/2;
num_pos = [lims(1) lims(4)];
Problema08 = '8. Generacin de superficies';
pr08 = text( ...
    'String',Problema08, ...
    'Position',num_pos, ...
    'HorizontalAlignment','left', ...
    'VerticalAlignment','top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);
set(get(gca,'Children'), ...
    'ButtonDownFcn',enlace08);
% Ejes 3D
ax083D = axes;
s = -2:0.2:2;
t = 0:pi/20:2*pi;
[T,S] = meshgrid(t,s);
X = S.*cos(T);
Y = -S.*sin(T);
Z = T;
surf(X,Y,Z)
set(ax083D,...
    'Position',ejes_pos)
axis off
set(get(gca,'Children'), ...
    'ButtonDownFcn',enlace08);
% Fin Problema 1.8
   
%====================================

% Problema 1.9: La cicloide
cap = 11;
ax09 = axes;
enlace09 = ['menupcn(1,9)'];

% Figura 9: Generacin de la cicloide
t = linspace(0,2*pi);
x = t-sin(t);
y = 1-cos(t);
s = 2*pi/3;
Px = s-sin(s);
Py = 1-cos(s);
Cx = s + cos(t);
Cy = 1 + sin(t);
plot([0 2*pi],[0 0],...
    'Color','w',...
    'LineWidth',2)
hold on
plot(x,y,'y',Cx,Cy,'c',Px,Py,'r*')
axis([0 2*pi -pi+1 pi+1])
axis square
hold off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax09, ...
    'XTickLabel',[], ...
    'Box','off', ...
    'Clipping','off', ...
    'Color',fondo, ...
    'XColor',fondo, ...
    'YColor',fondo, ...
    'ZColor',fondo, ...
    'ButtonDownFcn',enlace09, ...
    'Position',ejes_pos)

% Ttulo
lims = axis;
dlims = diff(axis)/2;
num_pos = [lims(1) lims(4)];
Problema09 = '9. La cicloide';
pr09 = text( ...
    'String',Problema09, ...
    'Position',num_pos, ...
    'HorizontalAlignment','left', ...
    'VerticalAlignment','top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);
set(get(gca,'Children'), ...
    'ButtonDownFcn',enlace09);
% Fin Problema 1.9
   
%====================================

% Problema 1.10: Distribucin normal de probabilidad
cap = 12;
ax10 = axes;
enlace10 = ['menupcn(1,10)'];

% Figura
t = -4:0.1:4;
y = 1/sqrt(2*pi)*exp(-t.^2/2);
plot(t,y,...
    'LineWidth',2,...
    'color','g')
axis([-4 4 0 0.6])
% Ejes
ejes_pos = [X_ejes(cap)-sep Y_ejes(cap) ancho_ejes+sep alto_ejes];

set(ax10, ...
    'XTickLabel',[], ...
    'YTickLabel',[], ...
    'Box','off', ...
    'Color',fondo, ...
    'XColor',fondo, ...
    'YColor',fondo, ...
    'ZColor',fondo, ...
    'ButtonDownFcn',enlace10, ...
    'Position',ejes_pos)
%axis(axis10);
% Ttulo
lims = axis;
dlims = diff(axis)/2;
num_pos = [lims(1) lims(4)];
Problema10 = [...
        '10. Distribucin normal';
        '    de probabilidad    '];
pr10 = text( ...
    'String',Problema10, ...
    'Position',num_pos, ...
    'HorizontalAlignment','left', ...
    'VerticalAlignment','top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);
set(get(gca,'Children'), ...
    'ButtonDownFcn',enlace10);

% Fin Problema 1.10
   
%====================================
