function dibu(ap)

% Imagenes de dm0101

switch ap
    case 1
        n = 4;
        f = factorial(n);
        P = perms(1:n) % Genera todas las permutaciones de 4 elementos
        imagesc(P)
        title(['Permutaciones de ', num2str(n), ' colores'])
        xlabel('Color'), ylabel('Permutacin')
        for k = 0 : f-1
            line([0.5, f+0.5], [k+0.5, k+0.5], 'Color', 'k')
        end
        set(gca, ...
            'XTick', [], ...
            'YTick', 1:f, ...
            'TickDir', 'out', ...
            'Box', 'off', ...
            'Color', 'k')
        colormap hot
    case 2
        C = nchoosek(1:5, 2);   % Combinaciones de 5 elementos tomados de 2 en 2
        plot(exp(2*pi/5*i*C'))  % Diagonales de un pentgono
        xlabel('Diagonales de un pentgono: C^5_2')
        axis equal
        axis([-1.1 1.2 -1.15 1.15])
        set(gca, 'Color', 'k', 'XTickLabel', [], 'YTickLabel', [])
    case 3
        cla, hold on, axis ij off equal, axis([0 6 0 11])
        fill([0 0 6 6],[0 11 11 0],[0.4 0.8 0.4])
        N= randperm(49);
        for k=1:49
            q=floor((N(k))/10);c=q+1;f=N(k)-q*10+1;
            text(c,f,num2str(N(k)),'FontSize',14,'FontWeight','Demi','Color','w','HorizontalAlign','center')
            if k<=6
                plot(c,f,'rx','MarkerSize',20,'linewidth',3)
            end
        end
        hold off
    case 4
        n=6; T=zeros(n,n+1); v=[1 1]; T(1,1:2)=v;
        for k=2:n
            v=[v 0]+[0 v]; T(k,1:k+1)=v;
        end
        R=num2str(T); L=size(R,2); m=(L-1)/n; S=[];
        for k=1:n
            bk=ceil((n-k)*m/2); Sk=[blanks(bk),R(k,1:k*m+1)]; S=strvcat(S,Sk);
        end
        cla
        set(gca,'color','k','XTickLabel',[],'YTickLabel',[])
        lims = axis;
        dlims = diff(axis)/2;
        text_pos = [lims(1)+dlims(1) lims(3)+dlims(3)];
        text( ...
            'String',S, ...
            'Position',text_pos, ...
            'HorizontalAlignment','Center', ...
            'FontName','times', ...
            'Fontweight','bold', ...
            'FontSize',18, ...
            'Color','white');
end