%% 1.1. Tringulo de Tartaglia
% 
% Este problema muestra diversas formas de 
% calcular factoriales y nmeros combinatorios.
%
% 
% Tema 1, Problema 1
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%% 
%
% a) Programa para el clculo del factorial mediante un bucle
%
% function f = buclefact(n)
% f = 1
% for k = 2:n
%     f = f*k
% end
% 
% Para hallar el factorial de 5, 5!=120, hacemos:

buclefact(5)

CM = colormap;
dibu(1)


%%
%
% b) Clculo del factorial mediante PROD
%
% El mismo resultado puede obtenerse generando un vector con los factores 
% y utilizando la funcin PROD de MATLAB

N = 1:5
prod(N)


%%
%
% c) Programa para el clculo de nmeros combinatorios como cocientes de factoriales
%
% function C = combifact(n,k)
% C = prod(1:n)/prod(1:k)/prod(1:(n-k));
%
% Por ejemplo, 
combifact(5,2)

colormap(CM);
dibu(2)


%%
%
% d) Programa para la evaluacin de un nmero combinatorio mediante la frmula 
%
%    Cn,k = n/1*(n-1)/2* ... *(n-k+1)/k
%
% function C = buclecoc(n,k)
% C = 1
% for j = 1:k
%     C = C*(n-j+1)/j
% end
% 
% Por ejemplo,

buclecoc(9,4)


%%
%
% e) Programa para obtener una fila del tringulo de Tataglia
%
% function C = coeffila(n)
% C = 1;
% for j = 1:n
%     C(j+1) = C(j)*(n-j+1)/j;
% end
% 
% La fila 8 se obtiene con 

C = coeffila(8)

bar(C,'r')


%%
%
% f) Programa para obtener las n primeras filas del tringulo de Tartaglia
% 
% function tartaglia(n)
% v = [1 1];
% disp(v) 
% for k = 2:n
%     v = [v 0] + [0 v];
%     disp(v)
% end
% 
% Probamos 

tartaglia(6)

dibu(4)


%%
%
% g) Programa para obtener un nmero combinatorio a base de sumas
%
% function C = cuadraglia(n,k)
% v = ones(1,k+1);
% for j = 2:n-k+1
% v = cumsum(v);
% end
% C = v(k+1);
%
% Ejemplo:

cuadraglia(5,2)

dibu(2)


%%
%
% h) Clculo de las combinaciones de la primitiva por distintos mtodos con
% las funciones que hemos programado y con la funcin especifica de MATLAB.

buclecoc(49,6)
combifact(49,6)
cuadraglia(49,6)
nchoosek(49,6)

dibu(3)


%%
%
% FIN del Problema 1.1
