function [T,S] = matartaglia(n,str)

% Triangulo de Tartaglia hasta la fila n
% n ha de ser un entero positivo

T = zeros(n,n+1);
v = [1 1];
T(1,1:2)=v;

for k = 2:n
    v = [v 0] + [0 v];
    T(k,1:k+1) = v;
end

if nargin>1
    R = num2str(T);       % Convierte la matriz numerica a matriz de caracteres
    L = size(R,2);          % Numero de columnas de la matriz de caracteres
    m = (L-1)/n;            % Espaciado entre las columnas de caracteres
    S = [];
    for k = 1:n
        bk = ceil((n-k)*m/2);           % Aade espacios en blanco
        Sk = [blanks(bk),R(k,1:k*m+1)];
        S = strvcat(S,Sk);              % Aade la fila k
    end
end
