%% Triangulo de Tartaglia
% 
% Este problema muestra diversas formas de 
% calcular factoriales y numeros combinatorios.
% 
% Tema 1, Problema 1
% Problemas resueltos de Mtodos Numricos
% Cordero, Hueso, Martnez, Torregrosa
% Ed. Thomson

%% 
%
% a) Programa para el calculo del factorial mediante un bucle
%
% function f = buclefact(n)
% f = 1
% for k = 2:n
%     f = f*k
% end
% 
% Para hallar 5! hacemos:

buclefact(5)
    
%%
%
% Calculo del factorial mediante PROD
%
% El mismo resultado puede obtenerse generando un vector con los factores 
% y utilizando la funcion PROD de MATLAB
N = 1:n
prod(N)

%%
%
% Asimismo, los productos parciales se obtienen mediante CUMPROD
%
cumprod(N)

%%
%
% Los coeficientes de una fila del binomio de Newton pueden calcularse
% mediante un bucle que en cada paso hace una multiplicacion y una division
C = 1;
for j = 1:n
    C(j+1) = C(j)*(n-j+1)/j;
end
C

%%
%
% Tambien se pueden obtener sin bucle
D = n:-1:1
C = [1 cumprod(D./N)]

%%
%
% Aunque lo mejor es hacerlo solo con sumas (Tartaglia)
v = [1 1];
disp(v)        
for k = 2:n
    v = [v 0] + [0 v];
    disp(v)
end