%% 1.9. La cicloide
%
% La cicloide es la trayectoria de un punto de una circunferencia que rueda
% sin deslizarse sobre una recta. En este problema dibujamos la cicloide,
% calculamos su longitud y representamos el vector velocidad de cada punto
% de la trayectoria.
%
%
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%% 
%
% a) Grafica de la cicloide
% Representamos graficamente la trayectoria de un punto P(x,y) de la
% circunferencia que rueda
t = linspace(0,2*pi);
x = t-sin(t);
y = 1-cos(t);
plot(x,y,[0 2*pi],[0 0],'k')
title('Cicloide')
axis equal


%% 
%
% Dibujamos la circunferencia que engendra la cicloide en una posicion
% determinada, por ejemplo, para t=2*pi/3.

s = 2*pi/3;
Px = s-sin(s);
Py = 1-cos(s);
Cx = s + cos(t);
Cy = 1 + sin(t);
plot(x,y,Cx,Cy,Px,Py,'*',[0 2*pi],[0 0],'k')
title('Generacin de la cicloide')
axis equal


%%
%
% b) Longitud de la cicloide
% Aproximamos la longitud de la cicloide por la de la poligonal que hemos
% utilizado para representarla

lx = diff(x);
ly = diff(y);
L = sum(sqrt(lx.^2+ly.^2))


%% 
%
% c) Vectores velocidad
% Elegimos algunos puntos de la trayectoria y dibujamos en ellos los
% vectores velocidad.

u = linspace(0,2*pi,11);
sx = u-sin(u); sy = 1-cos(u);
vx = 1-cos(u); vy = sin(u);
plot(x,y,'r:',sx,sy,'.',[0 2*pi],[0 0],'k')
axis equal
hold on, quiver(sx,sy,vx,vy,0.8), hold off
title('Vectores velocidad')


%%
%
% FIN del Problema 1.9