function dm02

% Capitulo 2
% Resolucin de Ecuaciones

% Problemas Resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

% jlh: nov-2006

% Ventana principal
fondo = [0 0 0];
colortit = [1 0.5 0];
colorcap = [0 0.2 0.6];
colornum = [0.9 0.9 0.9];
figure('Menubar', 'None', ...
    'Color', fondo, ...
    'Units', 'normalized', ...
    'Position', [0.05 0.1 0.9 0.8], ...
    'Numbertitle', 'off', ...
    'Name', 'Capitulo 2. Resolucin de Ecuaciones');

% Plantilla
sep = 0.04;
fil = 3;
col = 4;
fc = fil*col;
ancho_ejes = (1-col*sep)/col;
alto_ejes = (1-fil*sep)/fil;
x_ejes = sep/2:sep+ancho_ejes:1;
y_ejes = sep/2:sep+alto_ejes:1;
y_ejes = fliplr(y_ejes);
[Y_ejes, X_ejes] = meshgrid(y_ejes, x_ejes);

%====================================

% Titulo

ejes_pos = [X_ejes(6), Y_ejes(6), ancho_ejes, alto_ejes];
ax1 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

image(imread('prmn.jpg'))
axis equal off

ejes_pos = [X_ejes(7)-sep, Y_ejes(7), ancho_ejes, alto_ejes];
ax0 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

Capitulo = [...
        '  Resolucin ';...
        'de ecuaciones'];

tx1 = text( ...
    'String',Capitulo, ...
    'Position', [0.5,0.5], ...
    'VerticalAlignment','middle', ...
    'HorizontalAlignment','Center', ...
    'FontSize',18, ...
    'FontName','Arial', ...
    'FontWeight','demi', ...
    'Color',colortit);

%====================================

% Problema 2.1
cap = 1;
ax01 = axes;
ejes_pos = [X_ejes(cap), Y_ejes(cap), ancho_ejes, alto_ejes];
enlace01 = ['menupcn(2, 1)'];

% Figura 1: Mtodo de biseccin
p = [2 0 -3 -1];
a = 0; fa = polyval(p, a);
b = 2; fb = polyval(p, b);
h = 1;
x = linspace(a, b);
y = polyval(p, x);
plot(x, y, [a - 0.1, b + 0.1], [0, 0], 'w', [a b], [0 0], 'g*', ...
    [a a], [0 fa], 'r:', [b b], [0 fb], 'r:')
txa = text(a, h, 'a');
txb = text(b, -h, 'b');
c = (a+b)/2;
fc = polyval(p, c);
hold on
plot(c, 0, 'g*', [c c], [0 fc], 'r:')
txc = text(c, h, 'c');
set([txa txb txc], 'Color', 'y', 'HorizontalAlignment', 'Center')

set(ax01, ...
    'Position', ejes_pos, ...
    'Color', fondo, ...
    'XLim', [a - 0.1, b + 0.3], ...
    'YLim', [-3, 11], ...
    'XColor', fondo, ...
    'YColor', fondo, ...
    'ZColor', fondo, ...
    'ButtonDownFcn', enlace01);

lims = axis;
num_pos = [lims(1) lims(4)];
pr01 = text( ...
    'String', [...
        '1. Races de un polinomio';
        '      por bisecin       '], ...
    'Position', num_pos, ...
    'HorizontalAlignment', 'left', ...
    'VerticalAlignment', 'top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);

set(get(ax01, 'Children'), ...
    'ButtonDownFcn', enlace01);

% Fin Problema 2.1
   
%====================================

% Problema 2.2
cap = 2;
ax02 = axes;
enlace02 = ['menupcn(2, 2)'];
ejes_pos = [X_ejes(cap), Y_ejes(cap), ancho_ejes, alto_ejes];

% Figura 2: Mtodo de regula-falsi
f = inline('exp(-x.^2)-cos(x)');
a = 1; fa = feval(f, a);
b = 2; fb = feval(f, b);
c = (a*fb - b*fa)/(fb - fa);
x = linspace(a, b);
y = feval(f, x);
plot(x, y, [a-0.1 b+0.1], [0 0], 'w', [a b], [0 0], 'g*', ...
    [a a], [0 fa], 'r:', [b b], [0 fb], 'r:', ...
    [a b], [fa fb], 'r', c, 0, 'g*')
txt = text([a b c], [0.07 -0.07 0.07], ['a'; 'b'; 'c']);
set([txt], 'Color', 'y', 'HorizontalAlignment', 'Center')

set(ax02, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'XLim', [a - 0.1, b + 0.3], ...
    'Color', fondo, ...
    'XColor', fondo, ...
    'YColor', fondo, ...
    'ZColor', fondo, ...
    'ButtonDownFcn', enlace02, ...
    'Position', ejes_pos)

% Ttulo
lims = axis;
dlims = diff(axis)/2;
num_pos = [lims(1) lims(4)];
Problema02 = '2. Mtodo de Regula Falsi';
pr02 = text( ...
    'String', Problema02, ...
    'Position', num_pos, ...
    'HorizontalAlignment', 'left', ...
    'VerticalAlignment', 'top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace02);

% Fin Problema 2.2
   
%====================================

% Problema 2.3: Mtodo de Punto Fijo
cap = 3;
ax03 = axes;
enlace03 = ['menupcn(2, 3)'];

% Figura 3: Iterados de punto fijo
g2 = inline('acos(x/2)');
xg = linspace(0, 2);
yg = g2(xg);
plot(xg, yg, xg, xg, 'g')
axis equal
axis([-0.1 2.1 -0.1 2.1])
hold on
x = 0.1;
for k = 1:20
    x(k+1) = g2(x(k));
    plot([x(k) x(k) x(k+1)], [x(k) x(k+1) x(k+1)], 'r')
end

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax03, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', fondo, ...
    'XColor', fondo, ...
    'YColor', fondo, ...
    'ZColor', fondo, ...
    'ButtonDownFcn', enlace03, ...
    'Position', ejes_pos)

% Ttulo
lims = axis;
dlims = diff(axis)/2;
num_pos = [lims(1) lims(4)];
pr03 = text( ...
    'String', '3. Mtodo de punto fijo', ...
    'Position', num_pos, ...
    'HorizontalAlignment', 'left', ...
    'VerticalAlignment', 'top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace03);

% Fin Problema 2.3
   
%====================================

% Problema 2.4: Mtodo de Newton
cap = 4;
ax04 = axes;
enlace04 = ['menupcn(2, 4)'];

% Figura 4: Mtodo de Newton
% y = x.^5 - 2;
% dy = 5*x.^4;
xg = linspace(1, 1.5);
yg = xg.^5 - 2;
plot(xg, yg)
x = 1;
hold on
axis([0.99 1.25 -1 1])
plot([0.99 1.25], [0 0], 'w')
plot(x, 0, 'g*')
text( ...
    'Position', [x, 0.15], ...
    'String', 'x_1', ...
    'Color', 'y')

for k=1:3
    y(k) = x(k).^5 - 2;
    dy = 5*x(k)^4;
    x(k+1) = x(k) - y(k)/dy;
    plot([x(k) x(k)], [0 y(k)], 'r:')
    plot([x(k) x(k+1)], [y(k) 0], 'r')
    plot(x(k+1), 0, 'g*') 
    text( ...
        'Position', [x(k+1), 0.15*(-1)^k], ...
        'String', ['x_', num2str(k+1)], ...
        'HorizontalAlignment', 'Center', ...
        'Color', 'y')
end

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax04, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', fondo, ...
    'XColor', fondo, ...
    'YColor', fondo, ...
    'ZColor', fondo, ...
    'ButtonDownFcn', enlace04, ...
    'Position', ejes_pos)

% Ttulo
lims = axis;
dlims = diff(axis)/2;
num_pos = [lims(1) lims(4)];
Problema04 = '4. Mtodo de Newton';
pr03 = text( ...
    'String', Problema04, ...
    'Position', num_pos, ...
    'HorizontalAlignment', 'left', ...
    'VerticalAlignment', 'top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace04);

% Fin Problema 2.4
   
%====================================

% Problema 2.5: Billar circular
cap = 5;
ax05 = axes;
enlace05 = ['menupcn(2, 5)'];

% Figura 5: Billar circular

t = linspace(0, 2*pi);
x = cos(t);
y = sin(t);
P =  0.6-0.3i;
Q = -0.6-0.3i;
I = i;
O = 0; X = 0.95;
alfa = -pi/15;
g = cos(alfa)+i*sin(alfa);
gP = g*P; gQ = g*Q; gI = g*I;
plot(x, y, 'b')
axis([-1.25 1.25 -1.05 1.5]), axis equal 
hold on
plot([gP gI gQ], 'r')
%plot([1 0 gI], 'w:')
plot([gP gQ], '.', 'markersize', 20)
hold off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax05, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', fondo, ...
    'XColor', fondo, ...
    'YColor', fondo, ...
    'ZColor', fondo, ...
    'Position', ejes_pos)


% Ttulo
lims = axis;
dlims = diff(axis)/2;
num_pos = [lims(1) lims(4)];
Problema05 = '5. Billar circular';
pr05 = text( ...
    'String', Problema05, ...
    'Position', num_pos, ...
    'HorizontalAlignment', 'left', ...
    'VerticalAlignment', 'top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);

    
text_pos = [0.5 0.5];
tx05a = text( ...
    'String', 'Mtodo de Biseccin', ...
    'Position', [0 0.75], ...
    'HorizontalAlignment', 'Center', ...
    'VerticalAlignment', 'middle', ...
    'FontName', 'Times', ...
    'FontSize', 12, ...
    'Color', 'Green', ...
    'ButtonDownFcn', 'menupcn(2, 5, ''a'')');
tx05b = text( ...
    'String', 'Mtodo de Regula Falsi', ...
    'Position', [0 0.25], ...
    'HorizontalAlignment', 'Center', ...
    'VerticalAlignment', 'middle', ...
    'FontName', 'Times', ...
    'FontSize', 12, ...
    'Color', 'Green', ...
    'ButtonDownFcn', 'menupcn(2, 5, ''b'')');
tx05c = text( ...
    'String', 'Mtodo de Newton', ...
    'Position', [0 -0.25], ...
    'HorizontalAlignment', 'Center', ...
    'VerticalAlignment', 'middle', ...
    'FontName', 'Times', ...
    'FontSize', 12, ...
    'Color', 'Green', ...
    'ButtonDownFcn', 'menupcn(2, 5, ''c'')');
tx05d = text( ...
    'String', 'Mtodo de la secante', ...
    'Position', [0 -0.75], ...
    'HorizontalAlignment', 'Center', ...
    'VerticalAlignment', 'middle', ...
    'FontName', 'Times', ...
    'FontSize', 12, ...
    'Color', 'Green', ...
    'ButtonDownFcn', 'menupcn(2, 5, ''d'')');
 
% Fin Problema 2.5
   
%====================================

% Problema 2.6: La catenaria
cap = 8;
ax06 = axes;
enlace06 = ['menupcn(2, 6)'];

% Figura 6: Catenaria 
x = linspace(-1, 1);
y = cosh(x);
plot(x, y, 'Color', 'g', 'LineWidth', 2)
axis equal

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax06, ...
    'Color', fondo, ...
    'XColor', fondo, ...
    'YColor', fondo, ...
    'ZColor', fondo, ...
    'ButtonDownFcn', enlace06, ...
    'Position', ejes_pos)
% Ttulo
lims = axis;
dlims = diff(axis)/2;
num_pos = [lims(1) lims(4)];
Problema06 = '6. La Catenaria';
pr06 = text( ...
    'String', Problema06, ...
    'Position', num_pos, ...
    'HorizontalAlignment', 'left', ...
    'VerticalAlignment', 'top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace06);

% Fin Problema 2.6
   
%====================================
   

% Problema 2.7: Una ecuacin difcil
cap = 9;
ax07 = axes;
enlace07 = ['menupcn(2, 7)'];

% Figura 7
x = linspace(-1.1, 1.1);
plot([-1.1 1.1], [0 0], x, x.^10-1)
set(get(gca,'Children'), 'LineWidth', 2)

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax07, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', fondo, ...
    'XColor', fondo, ...
    'YColor', fondo, ...
    'ZColor', fondo, ...
    'ButtonDownFcn', enlace07, ...
    'Position', ejes_pos)

% Ttulo
lims = axis;
dlims = diff(axis)/2;
num_pos = [lims(1) lims(4)];
Problema07 = ['7. Una ecuacin difcil'];
pr07 = text( ...
    'String', Problema07, ...
    'Position', num_pos, ...
    'HorizontalAlignment', 'left', ...
    'VerticalAlignment', 'top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace07);

% Fin Problema 2.7

%====================================

% Problema 2.8: La ecuacin logstica
cap = 10;
ax08 = axes;
enlace08 = ['menupcn(2, 8)'];

% Figura 8: Iterados de la funcin logstica
g2 = inline('3.75*x.*(1-x)');
xg = linspace(0, 1);
yg = g2(xg);
plot(xg, yg, xg, xg, 'g')
axis equal
axis([0 1.25 0 1.25])
hold on
x = 0.5;
for k = 1:50
    x(k+1) = g2(x(k));
    plot([x(k) x(k) x(k+1)], [x(k) x(k+1) x(k+1)], 'r')
end

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax08, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', fondo, ...
    'XColor', fondo, ...
    'YColor', fondo, ...
    'ZColor', fondo, ...
    'ButtonDownFcn', enlace08, ...
    'Position', ejes_pos)
%axis(axis08);
% Ttulo
lims = axis;
dlims = diff(axis)/2;
num_pos = [lims(1) lims(4)];
Problema08 = '8. Ecuacin logstica';
pr08 = text( ...
    'String', Problema08, ...
    'Position', num_pos, ...
    'HorizontalAlignment', 'left', ...
    'VerticalAlignment', 'top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace08);

% Fin Problema 2.8
   
%====================================

% Problema 2.9: Diodo varicap
cap = 11;
ax09 = axes;
enlace09 = ['menupcn(2, 9)'];

% Figura 9: Diodo
image(imread('diodo.jpg'))

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax09, ...
    'XTickLabel', [], ...
    'Box', 'off', ...
    'Clipping', 'off', ...
    'Color', fondo, ...
    'XColor', fondo, ...
    'YColor', fondo, ...
    'ZColor', fondo, ...
    'ButtonDownFcn', enlace09, ...
    'Position', ejes_pos)

% Ttulo
lims = axis;
dlims = diff(axis)/2;
num_pos = [lims(1) lims(3)];
Problema09 = '9. Diodo varicap';
pr09 = text( ...
    'String', Problema09, ...
    'Position', num_pos, ...
    'HorizontalAlignment', 'left', ...
    'VerticalAlignment', 'top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace09);
% Fin Problema 2.9
   
%====================================

% Problema 2.10: Amortizacin de un prstamo
cap = 12;
ax10 = axes;
enlace10 = ['menupcn(2, 10)'];

% Figura
image(imread('amortiza2.jpg'))

% Ejes
ejes_pos = [X_ejes(cap)-sep Y_ejes(cap) ancho_ejes+sep alto_ejes];

set(ax10, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', fondo, ...
    'XColor', fondo, ...
    'YColor', fondo, ...
    'ZColor', fondo, ...
    'ButtonDownFcn', enlace10, ...
    'Position', ejes_pos)
%axis(axis10);
% Ttulo
lims = axis;
dlims = diff(axis)/2;
num_pos = [lims(1) lims(3)];
Problema10 = [...
        '10. Amortizacin de ';
        '    un prstamo     '];
pr10 = text( ...
    'String', Problema10, ...
    'Position', num_pos, ...
    'HorizontalAlignment', 'left', ...
    'VerticalAlignment', 'top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace10);

% Fin Problema 2.10
   
%====================================
