%% 4.1 Construccin de un frmula de cuadratura
%
% Se trata de construir una frmula de cuadratura para una funcin definida
% en el intervalo [0,1].
% Los pesos se determinan para que la regla sea exacta para polinomios de
% grado menor o igual que 10.
%
%
% Tema 4, Problema 1.
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%%
%
% Dados n puntos x1, ... xn, en un intervalo, tratamos de aproximar la
% integral de una funcin f en dicho intervalo por una media ponderada de
% los valores de la funcin en dichos puntos.
%
% I = w1*f(x1) + w2*f(x2) +  + wn*f(xn)

x=0:0.1:1;
y=rand(1,10);
[xx,yy]=stairs(x,[y 0]);
area(xx,yy)
axis off
title('Integracin aproximada')
colormap winter


%%El sistema a resolver para calcular los pesos es: A*w=b
% 
% 

%%
%
% Para construir el vector de trminos independientes basta
% con llevar a cabo la sentencias:
k=1:11;
b=1./k;
b=b(:)

%%
%
% La matriz A es una matriz de Vandermonde que construiremos
% de esta forma:
k=0:10;
v=k/10;
B=vander(v);
A=rot90(B)

%%
%
% Para resolver el sistema utilizamos el mtodo de eliminacin 
% de Gauss con pivotacin parcial 
w=A\b
stem(k,w)
%% 
%
% Contruimos una fucnin que llamaremos Prob0401.m que tendra como
% argumentos de entrada la funcin integrando y los pesos calculados
% anteriormente y como salida la aproximacin de la integral. Obteneos un
% error E1=9.63e-8
% 
% 
w=w';
I= Prob0401('f',w)

%%
%
% Para la segunda integral creamos el archivo g.m y obtenemos el sigueinte
% resultado con un error E2=0.010686. La mala aproximacion se debe a que
% estamos rabajando con una integral impropia.
type g;
I= Prob0401('g',w)


%%
%
% A la vista de E1 vamos a ejecutar la funcion Romberg.m con una tol=1e-8 y
% un numero inicial de subintervalos de 5:

R=Romberg('f',0,1,5,1e-8,50)

%%
%
% Para la segunda integral utilizamos tol=1e-3
R=Romberg('g',0,1,5,1e-3,50)

%%
%
% FIN del Problema 4.1