%% 4.2 Fuerza ejercida sobre el mastil de un velero
%
% En este problema se calcula la fuerza que se ejerce sobre el mastil de un
% velero utilizando para ello los metodos de Romberg y de los trapecios.
%
%
% Tema 4, Problema 2.
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%% 
% 
% Modificamos la funcion trapecios para que calcule sucesivas aproximaciones
% de la integral mediante la formula compuesta de los trapecios con 10n
% subintervalos.
type trapecios0402;

%% 
%
% Ejecutamos trapecios0402. En este caso el error cometido es 9.8843e-5

T=trapecios0402('f',0,30,50,1e-8)


%%
%
% Ejecutamos de nuevo con 18570 subintervalos y obenemos la siguiente aproximacion:
T=trapecios0402('f',0,30,18570,1e-8)


%%
%
% Lo hacemos ahora por Romberg con tol=1e-8 y un numero inicial de
% subintervalos de 10. Obteniendo la ultima aproximacion con 360
% subintervalos frente a los 18570  que eran necesarios antes.

R=Romberg('f',0,30,10,1e-8,50)




%%
%
% Para mejorar cnsiderablemente las aproximaciones que nos da la formula
% del punto medio sin aumentar excesivamente el numero de operaciones
% aplicamos la extrapolacion de Richardson.
type rchpmed;

%%
%
% Obteniendo con 360 subintervalos un error de 9.7771e-12
R=rchpmed('f',0,30,10,1e-8,50)

%%
%
% FIN del Problema 4.2
