%% 4.3 Fuerza ejercida por el agua en una presa
%
% En este problema se va a calcular la fuerza que ejerce el agua embalsada en 
% una presa sobre sus caras. 
% Tema 4, Problema 3.
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

%% Fuerza calculada con formula de los trapecios para 6 subintervalos

%El vector de nodos z y el ancho del rio,w, son:

z=0:10:60;
w=[122 130 135 160 175 190 200];
plot(w,z)
legend('Perfil de la presa',0)

%% 

% Definimos las constantes densidad del agua, p,
% aceleracion producida por la gravedad, g, 
% y distancia al fondo, D.
p=1e3;
g=9.8;
D=60;
y=p*g*w.*(D-z); %integrando
%%

% Por ultimo obtenemos la fuerza ejercida:
f=trapz(z,y) 

%% Fuerza calculada con formula compuesta de simpson para 10 subintervalos
% Creamos la funcion simpz cuyo contenido es:
type simpz;

%%
% Debemos averiguar el ancho del rio cada 6 metros de profundidad
h=(D-0)/10;
zz=0:h:60;



%%
% Como solo conocemos el ancho del rio en 3 puntos, utilizaremos
% el comando spline para conocer el resto de componentes

ww=spline(z,w,zz)


%%Finalmente evaluamos el nuevo integrando y aplicamos la funcion simpz para obtener la fuerza:

yy=p*g*ww.*(D-zz);
f=simpz(zz,yy)


%% Fuerza calculada utilizando Romberg con tolerancia 10e-8
%
%Para ello se constuye la siguiente funcion Rombz:
type Rombz;


%%
%La ejecutamos y obtenemos las fuerza
Rombz(z,y,10e-8,5)



%%
%
% FIN del Problema 4.3
