%% 4.4 Particula desplazandose en un fluido
%
% En este problema se analiza el movimiento de una particula de masa m
% sometida a una resistencia viscosa R que depende de la velocidad v de la
% particula.
%
%
% Tema 4, Problema 4.
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

%%
%
% Calculo del tiempo que tarda en pasar la particula de una velocidad de
% 10m/s a 5m/s utilizando del metodo de Simpon con 10n subintervalos hasta
% que la diferencia entre dos aproximaciones consecutivas sea menor de
% 10^-6
 

%% 
%
% Creamos dos fucniones: una fucnion f.m y otra Simpson0404.m cuyos
% contenidos son.
% f.m es la funcion del integrando y Simpson0404.m es:
type Simpson0404;


%%
%
% Y calculamos el tiempo ejecutando 
t=Simpson0404('f',5,10,10,1e-6,10)

%%
%
% Hacemos lo mismo por el metodo de Gauss-Legendre para n=8

%%
%
% Para ello construimos la funcion NPLegendre.m que calcula las raices 
% del polinomio de Legendre de grado n y sus pesos de la cuadratura de
% Gauss-Legendre
type NPLegendre;

%%
%
% Obtenemos las raices y los pesos para n=8
[N,P]=NPLegendre(8)
stem(N,P)

%%
%
% Usando la fucnion GaussLegendre.m, cuyo contenido se muestra a
% continuacion, en el intervalo [-1,1] para n=8 obtenemos el resultado
type GaussLegendre;
I=GaussLegendre('f',-1,1,8)

%%
%
% Ahora se utiliza el metodo de Monte-Carlo con 2^k puntos
% (k=10,11,...)

I=mcarlo1('f',0,-1,N)

    
%%
%
% FIN del Problema 4.4
