%% 4.5 Analisis de convergencia de integrales
%
% En este problema se analiza la convergencia de cuatro integrales. EN caso
% de converger, las dos primeras se calculan mediante Gauss-Legendrecon n=10 
% nodos y la dos segundas mediante Rombreg con 64 subintervalos y tol=1e-6
%
%
% Tema 4, Problema 5.
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%% 
% 
% La primera integral definida en [1,2] es impropia en x=1. Tomando E=0.01
% y descomponemos el intervalo en los intervalos [1,1+E] y [1+E,2].
% Evaluamos en el primer intervalo con el metode de Gauss-Legendre para
% n=10:
E=0.01;
I=GaussLegendre('f',1,1+E,10)


%% 
%
% Ahora hacemos Ee=0.001 y volvemos a descomponer el intervalo [1,1+E] en
% [1,1+Ee] y [1+Ee,1+E] y mediante Gauss-Legendre obtenemos:
Ee=0.0001;
I=GaussLegendre('f',1,1+Ee,10)
%%
%
% Asi que la integral es convergente. Aproximamos pues su valor mediante el
% metodo de Gauss-Legendre:
I=GaussLegendre('f',1,2,10)

%%
%
% La segunda integral esta definida en el intervalo [0,1]. Utilizando el
% mismo razonamiento que en el apartado anterior, E=0.01 y evaluamamos la
% integral en el intervalo [0,E]
E=0.01;
I=GaussLegendre('g',0,E,10)


%%
%
% Igual que en el apartado anterior, hacemos Ee=0.0001 y evaluamos la
% integral en [0,Ee] y a la vista del resultado podemos concluir que no es
% convergente
Ee=0.0001;
I=GaussLegendre('f',0,Ee,10)

%%
%
% Para evaluar la tercera integral construimos las funcion prob04052.m con
% el siguiente contenido:

type prob04052;

%%
%
% Y al ejecutarla para 20 nodos, 100 sumandos como maximo y una tolerancia
% de 1e-7, obtenemos 

[I,v,k]=prob04052('h',20,100,1e-7)

%%
%
% Haciendolo por el metodo de Romberg, obtenemos el siguiente triangulo:

R = Romberg('h',1,2^10,64,1e-6,100)

%%
%
% Para evaluar la cuarta integral construimos el archivo prob04053.m que va
% calculando mediante cuadratura de Romberg las aroximaciones de los
% distintos sumandos.
type prob04053;

%%
%
% Haciendo una llamada da esta funcion utilizando 32 subintervalos, un
% numro maximo de iteraciones de 50 y una olerancia de de 1e-7, se consumen
% todas las iteraciones y las componentes de v se mantienen entorno a
% 1.08888. Asi que conjeturamos que la integral es divergente.
prob04053('z',32,50,1e-7)

%%
%
% FIN del Problema 4.5
