%% 4.6 Evaluacion de integral doble
%
% En este problema se evaluara una integral doble mediante las cuadraturas
% de Simpson y Gauss-Legendre
%
%
%
% Tema 4, Problema 6.
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%% 
% 
% La integral doble es sobre un recinto rectangular en el que la funcion
% integrando no presenta ningun punto de discontinuidad. Aplicando pues
% cuadratura de Simpson se obtendra una buena aproximacion de la integral.
% Evaluamos la integral con lambda=0.5

I_05=Simpson2r('f05',0,1,0,1,5,5)

%%
%
% Y hacemos lo mismo para un valor de lambda de 0.9
I_09=Simpson2r('f09',0,1,0,1,5,5)

%% 
%
% Cuando lambda=1, aparece una discontinuidad en el punto (1,1). Por tanto
% ocurrira un error al aplicar Simpson o cuanquier formula con nodos
% equiespaciados debido a esa discontinuidad. Para aproximar esa integral
% debemos utilizar formulas de cuadratura con puntos no equiespaciados.

%%
%
% Creamos la funcion prob0406 que toma 2k nodos para cada variable hasta
% una cota N. Cada aproximacion de la integral es almacenada en un vector
% I.
type prob0406;
 


%%
%
% Al ejecutar la funcion, vemos como el valor de I va tendiendo a pi^2/6
I=prob0406('f1',0,1,0,1,15)
%%
%
% FIN del Problema 4.6
