%% 4.7 Integral en en recinto no rectangular
%
% En este problema se va a realizar la integral de exp(-x^2*y^2) en el
% recinto definido por las curvas y=x^2, x=y`2
%
%
% Tema 4, Problema 7.
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%% 
% 
% Represenamos graficamente el recinto de integracion y facilmente vemos
% que los limites de integracion son[0,1] para x y [x^2,sqrt(x)] para y

x=0:0.2:2;
y=x.^2;
z=sqrt(x);
plot(x,y,x,z)
title(' Recinto de integracion')

%% 
%
% La siguiente funcion utiliza el alla formula de cuadratura de Simpson
% para una integral doble con recinto no rectangular:
type simpson2f;




%%
%
% Ejecutamos la funcion simpson2f con f.m,c.m,d.m las funciones integrando
% y los limites de integracion de la variable y respectivamente y
% obtenemos:

I=simpson2f('f',0,1,'c','d',40,40)

%%
%
% Esta funcion utiliza la tecnica de Gauss-Legendre para calcular la
% integral
type GaussLegendre2f;

%%
%
% En este caso obtenemos una aproximacion de I=0.302149 que coincide
% unicamente con las tres primeras cifras decimales de la aproximacion
% obtenida en el apartado anterior.
I=GaussLegendre2f('f',0,1,'c','d',8,8)

%%
%
% FIN del Problema 4.7
