%% 4.8 Calculo de integral doble
% En este problema se calacula la integral de la funcion
% sin(sqrt(log(x+y+1))) en el recinto definido por la circunferencia de
% radio 1 centrada en (1,1), la region y<=x y -1<=y<=1
%
%
% Tema 4, Problema 8.
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%% 
% 
% Representamos el recinto R, el cual descomponemos en dos recintos R1 y R2
% Eso nos hace, asu vez, descomponer la integral en dos integrales que
% llamaremos I1 e I2.
x=0:0.001:2;

y1= sqrt((1-(x-1).^2))+1;
y2= -sqrt((1-(x-1).^2))+1;
z=x;
y3=1;
plot(x,y1,x,y2,x,z,x,y3); title('Recinto R')
text(1,0.4,'R')

%% 
%
% R1 estara delimitado por 1-sqrt(1-(x-1)^2)<=y<=x,
% 1-(1/sqrt(2))<=x<=1 y R2 por 1-sqrt(1-(x-1)^2)<=y<=x, 1<=x<=2. 

%%
%
% Eejcutando la funcion GaussLegendre2f cosntruida en el problema4.7 obtenemos I1 e I2

I1=GaussLegendre2f('f',1-(1/sqrt(2)),1,'c','d',15,15)
I2= GaussLegendre2f('f',1,2,'c','uno',15,15)
I=I1+I2

%%
%
% En la funcion trapecios2f.m programamos el metodo de los trapecios para
% recintos no rectangulares. Esta funcion sera empleada en el metodo de
% Romberg para este tipo de recintos.
type trapecios2f;
%%
%
% 
type Romberg2f;

%%
%
% Ejecutamos Romberg2f para calcular I1 partiendo de 32subintervalos para
% cada variable y tol=1e-7 y un numero maximo de filas de 50. Se obtiene
% que I1=0.297912
R1=Romberg2f('f',1-(1/sqrt(2)),1,'c','d',32,32,1e-7,50)

%%
%
% Hacemos lo mismo con I2 y obtenemos I2=0.675973. Asi que I=I1+I2=0.973885
R2=Romberg2f('f',1,2,'c','uno',32,32,1e-7,50)

%%
%
% Para calcular la aproximacion de I por Monte-Carlo, procederemos tomando
% un punto aleatorio del rectangulo [0,2]x[0,2] y analizamos si estan en R.
% En caso afirmativo, sera un nodo de integracion. En caso negativo lo
% desechamos. El proceso se repite hasta alcanzar el numero de nodos
% desados.
 type MonteCarlo2f;

%%
%
% Ejecutamos la funcion para maxnodos=13. En la figura se puede observar
% como las aproximaciones de la interal estan en torno a 0.97

I=MonteCarlo2f('f',13)

%%
%
% FIN del Problema 4.8
