%% 4.10 Centro de masa de un cuerpo
%
% En este problema se va a calcular el centro de masa de un obejeto del
% cual es conocida su funcion de densidad. Para ello se va a utilizar la
% cuadratura de Gauss-Legendre y el metodo de Simpson.
%
%
% Tema 4, Problema 10.
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%%
%
%  La funcion Gausslegendre3r.m aproxima integrales triples utilizando
%  cuadratura de Gauss-Legendre

type GaussLegendre3r;

%% 
% 
% Calculamos la masa del cuerpo integrando la densidad dentro de la region
% del volumen del cuerpo y calculamos tambien el punto de coordenadas (px,py,pz) 
% donde se encuentra el centro de masa a partir de los momentos alrededor de los
% tres planos coordenados (Myz,Mxz,Mxy):

m=GaussLegendre3r('f',0,1,0,1,0,1,15,15,15)
Myz=GaussLegendre3r('fx',0,1,0,1,0,1,15,15,15)
Mxz=GaussLegendre3r('fy',0,1,0,1,0,1,15,15,15)
Mxy=GaussLegendre3r('fz',0,1,0,1,0,1,15,15,15)
px=Myz/m
py=Mxz/m
pz=Mxy/m


%% 
%
% Construimos la funcion Simpsoniter3r.m que sera una variante del metodo
% de Simpson
type Simpsoniter3r;

%%
%
% Realizamos el mismo procedimento que en el apartado anterior, esta vez
% utilizando el metodo de simpson. Calculamos la masa del cuerpo:

m=Simpsoniter3r('f',0,1,0,1,0,1,1e-7,50)

%%
%
% El momento Myz
Myz=Simpsoniter3r('fx',0,1,0,1,0,1,1e-7,50)
%%
%
% El momento Mxz
Mxz=Simpsoniter3r('fy',0,1,0,1,0,1,1e-7,50)
%%
%
% El momento Mxy
Mxy=Simpsoniter3r('fz',0,1,0,1,0,1,1e-7,50)

%%
%
% Las coordenadas del centro de masa resultan ser :
px=Myz/m
py=Mxz/m
pz=Mxy/m



%%
%
% FIN del Problema 4.10
