function billar

% Problemas resueltos de Mtodos Numricos
% Cordero, Hueso, Martnez, Torregrosa
% Ed. Thomson
%
% jlh, ene-2006

t = linspace(0, 2*pi, 500);
x = cos(t);
y = sin(t);
P =  0.6-0.3i;
Q = -0.6-0.3i;
I = i;
O = 0; X = 0.95;
alfa = -pi/15;
g = cos(alfa)+i*sin(alfa);
gP = g*P; gQ = g*Q; gI = g*I;
plot(x, y, 'k')
axis([-1.15 1.15 -1.15 1.15]), axis square 
set(gca, 'XTickLabel', '', 'YTickLabel', '', ...
    'XColor', 'w', 'YColor', 'w', 'ZColor', 'w')
hold on
%compass([gP gQ], 'k--')
plot([gP gI gQ], 'k')
plot([1 0 gI], 'k:')
plot([gP gQ], '.', 'markersize', 20)
pos = [gP X gI]*1.1;
text(real(pos), imag(pos), ['P'; 'X'; 'I'], 'fontsize', 14)
pos = gQ*1.2;
text(real(pos), imag(pos), ['Q'], 'fontsize', 14)
text(-0.1, -0.1, 'O', 'fontsize', 14)
b = pi/2 + alfa;
[arco, flecha] = flechang(0, b, 0.2);
plot(arco, 'k')
plot(flecha, 'k')
text(0.25*cos(b/2), 0.25*sin(b/2), 't', 'fontsize', 14)
hold off


function [arco, flecha] = flechang(a, b, r)
t = linspace(a, b);
x = r*cos(t);
y = r*sin(t);
arco = x + i*y;
c = 0.8*b + 0.2*a;
C = cos(c) + i*sin(c);
s1 = 0.8*r; s2 = 1.2*r;
p1 = s1*C;
p2 = s2*C;
p0 = x(end) + i*y(end);
flecha = [p1 p0 p2];



