function [r,dr] = mibillar(z)

% Billar circular

%global P Q
P = [0.6,-0.3];Q = [-0.6,-0.3];

I = [cos(z), sin(z)];
J = [sin(z), -cos(z)];
IP = P-I;
IQ = Q-I;
nIP = norm(IP);
IPn = IP/nIP;
nIQ = norm(IQ);
IQn = IQ/nIQ;
r = dot(J,IPn+IQn);

if nargout>1
    dJ = I;
    dIP = J;
    dIQ = J;
    % ||v||' = dot(v,v')/||v||
    dnIP = dot(IP,J)/nIP;
    dnIQ = dot(IQ,J)/nIQ;
    % Derivada del cociente
    dIPn = (dIP*nIP-IP*dnIP)/nIP^2;
    dIQn = (dIQ*nIQ-IQ*dnIQ)/nIQ^2;
    % Derivada del producto escalar
    dr = dot(dJ,IPn+IQn)+dot(J,dIPn+dIQn);
end
