function feigenbaum(p, q, r, s)

% Fractal de Feigenbaum
%
% Comportamiento asinttico de las iteraciones de f(x) = a*x*(1-x) con a
% variando de 0 a 4.
% Cambiando las variables p, q, r, s, puede hacerse zoom sobre una zona del
% grfico.

% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

if nargin == 0
    p = 0; q = 4;		% Rango de variacin del parmetro
    r = 0; s = 1;		% Intervalo de valores de la iteracin
end
h = (q-p)/500;
X = zeros(1,100001); 
Y = X;
j=1;
for a = p:h:q		% Parmetro
    x = 0.5;		% Estimacin inicial
    for k = 1:400	% Iterados 
        x = a*x*(1-x);
        if k>200	% Dibuja el punto
            X(j) = a; Y(j) = x;
            j=j+1;
        end
    end
end
plot(X, Y, 'r.', 'markersize', 1)
axis([p,q,r,s])
