function [y, dy] = diodo2(V)

% Ecuacin del diodo de capacidad variable

% Parmetros del diodo
C0 = 81e-12;
fi = 0.6;
gamma = 0.44;

% Valor de Q para el que se quiere determinar la tensin.
Q = 1e-10;

% Ecuacin a resover y su derivada
y = V.*C0 - Q*(1+abs(V)/fi).^gamma;
dy = C0 - gamma*Q/fi*(1+V).^(gamma-1);
