function [sol,x,incr,k] = newton(fun,x1,tol,maxiter)

% Iteraciones de Newton para f(x)=0
% fun: fichero de funcin que devuelve y=f(x) y dy=f(x)
% con la sintaxis [y,dy]=fun(x)

k = 1;
x = x1;
incr = tol+1;

while incr > tol & k <= maxiter
    [y,dy] = feval(fun,x(k));
    delta = -y/dy;
    x(k+1) = x(k) + delta;
    incr = abs(delta);
    k = k+1;
end

if incr > tol
    sol = [ ];
    disp('Diverge o insuficientes iteraciones')
else
    sol = x(end);
end