function dm03

% Capitulo 3
% Interpolacin polinmica

% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

% jlh: nov-2006

% Ventana principal
fondo = [0 0 0];
colortit = [1 0.5 0];
colorcap = [0 0.3 0.9];
colornum = [0.9 0.9 0.9];
c_ejes = fondo; 
figure('Menubar', 'None', ...
    'Color', fondo, ...
    'Units', 'normalized', ...
    'Position', [0.05 0.1 0.9 0.8], ...
    'Numbertitle', 'off', ...
    'Name', 'Captulo 3. Interpolacin Polinmica');

% Plantilla
sep = 0.05;
alto_texto = 0.05;
fil = 3;
col = 4;
fc = fil*col;
ancho_ejes = 1/col - sep;
alto_ejes = 1/fil - sep - alto_texto;
x_ejes = sep/2 : sep + ancho_ejes : 1;
y_ejes = sep/2 : sep + alto_ejes + alto_texto : 1;
y_txt = sep/2 + alto_ejes + alto_texto : sep + alto_ejes + alto_texto : 1;
y_ejes = fliplr(y_ejes);
y_txt = fliplr(y_txt);
[Y_ejes, X_ejes] = meshgrid(y_ejes, x_ejes);
[Y_txt, X_txt] = meshgrid(y_txt, x_ejes);

%====================================

% Ttulos de los problemas
axes(...
    'Color', fondo, ...
    'XColor', fondo, ...
    'YColor', fondo, ...
    'ZColor', fondo, ...
    'Position', [0 0 1 1]);

problema = char(...
    '1. Viajeros, al metro!', ... 
    '2. Cloruro amnico', ... 
    '3. Resorte', ... 
    '4. Polinomio de Newton', ... 
    '5. Nodos de Chebyshef', ... 
    '', ... 
    '', ... 
    '6. Splines', ... 
    '7. Interpolacin global y local', ... 
    '8. Interpolando arctg(x)', ... 
    '9. Demanda elctrica', ... 
    '10. Trayectoria robtica');
txpro = text(X_txt(:), Y_txt(:), problema, ...
    'HorizontalAlignment', 'left', ...
    'VerticalAlignment', 'top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);
txpro(6:7) = [];
for k = 1:10
    set(txpro(k), 'ButtonDownFcn', ['menupcn(3,', num2str(k),')'])
end

%====================================

% Titulo
ejes_pos = [X_ejes(6), Y_ejes(6), ancho_ejes, alto_ejes];
ax1 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

image(imread('prmn.jpg'))
axis equal off

ejes_pos = [X_ejes(7)-sep, Y_ejes(7), ancho_ejes, alto_ejes];
ax0 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

Capitulo = [...
        'Interpolacin';...
        '  Polinmica '];

tx1 = text( ...
    'String',Capitulo, ...
    'Position', [0.5,0.5], ...
    'VerticalAlignment','middle', ...
    'HorizontalAlignment','Center', ...
    'FontSize',18, ...
    'FontName','Arial', ...
    'FontWeight','demi', ...
    'Color',colortit);

%====================================

% Problema 3.1
cap = 1;
ax01 = axes;
ejes_pos = [X_ejes(cap), Y_ejes(cap), ancho_ejes, alto_ejes];
enlace01 = ['menupcn(3, 1)'];

% Figura 1: 
image(imread('metro.jpg'))
set(ax01, ...
    'Position', ejes_pos, ...
    'Visible', 'off', ...
    'ButtonDownFcn', enlace01);

set(get(ax01, 'Children'), ...
    'ButtonDownFcn', enlace01);

% Fin Problema 3.1
   
%====================================

% Problema 3.2
cap = 2;
ax02 = axes;
enlace02 = ['menupcn(3, 2)'];
ejes_pos = [X_ejes(cap), Y_ejes(cap), ancho_ejes, alto_ejes];

% Figura 2: 
image(imread('cloruro.jpg'))
axis equal
set(ax02, ...
    'Visible', 'off', ...
    'ButtonDownFcn', enlace02, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace02);

% Fin Problema 3.2
   
%====================================

% Problema 3.3: 
cap = 3;
ax03 = axes;
enlace03 = ['menupcn(3, 3)'];

% Figura 3: 
image(imread('resorte.jpg'))

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];

set(ax03, ...
    'Visible', 'off', ...
    'ButtonDownFcn', enlace03, ...
    'Position', ejes_pos)
axis equal

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace03);

% Fin Problema 3.3
   
%====================================

% Problema 3.4: 
cap = 4;
ax04 = axes;
enlace04 = ['menupcn(3, 4)'];

% Figura 4: 

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax04, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace04, ...
    'Position', ejes_pos)

text04 = [ ...
        ' 10    21                   ';...
        '                            ';...
        ' 11     9   -12             ';...
    	'                            ';...
		' 12    11     2     7       ';...
		'                            ';...
		'  9    35    -8     5     2 '];
    
    
text_pos = [0.5 0.5];
tx04 = text( ...
    'String',text04, ...
    'Position',text_pos, ...
    'HorizontalAlignment','Center', ...
    'VerticalAlignment','middle', ...
    'FontName','courier', ...
    'FontSize',11, ...
    'FontWeight','Bold', ...
    'Color','red');

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace04);

% Fin Problema 3.4
   
%====================================

% Problema 3.5: 
cap = 5;
ax05 = axes;
enlace05 = ['menupcn(3, 5)'];

% Figura 5: 
xf = linspace(-5,5);
yf = 1./(1+xf.^2);
j = 1;
i = 12;
k = 1:i+1;
x = 5*cos(((2*(i-(k-1))+1)/(2*i+2))*pi);
y = 1./(1+x.^2);
p = polyfit(x,y,i);
yp = polyval(p,xf);
plot(x,y,'r*',xf,yf,'b',xf,yp,'g');


% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax05, ...
    'Visible', 'off', ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace05);

% Fin Problema 3.5
   
%====================================

% Problema 3.6: 
cap = 8;
ax06 = axes;
enlace06 = ['menupcn(3, 6)'];

% Figura 6: 
ys = spline(x, y, xf);
plot(x, y, 'r*', xf, yf, 'b', xf, ys, 'g');

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax06, ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace06, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace06);

% Fin Problema 3.6
   
%====================================
   

% Problema 3.7: 
cap = 9;
ax07 = axes;
enlace07 = ['menupcn(3, 7)'];

% Figura 7
x = (-5:5)';
y = x./(1+x.^2);
xg = linspace(-5, 5);
yf = xg./(1 + xg.^2);
p = polyfit(x, y, 10);
yp = polyval(p, xg);
ys = spline(x, y, xg);
plot(x, y, '*', xg, yf, xg, yp, xg, ys)

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax07, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace07, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace07);

% Fin Problema 3.7

%====================================

% Problema 3.8: 
cap = 10;
ax08 = axes;
enlace08 = ['menupcn(3, 8)'];

% Figura 8: 
x = (-3:3);
y = atan(x);
xg = linspace(-3,3);
yg = atan(xg);
ysnn = spline(x,y, xg);
plot(x, y, '*', xg, yg, xg, ysnn)

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax08, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace08, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace08);

% Fin Problema 3.8
   
%====================================

% Problema 3.9:
cap = 11;
ax09 = axes;
enlace09 = ['menupcn(3, 9)'];

% Figura 9: 
image(imread('demanda.jpg'))
axis equal

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax09, ...
    'Visible', 'off', ...
    'ButtonDownFcn', enlace09, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace09);

% Fin Problema 3.9
   
%====================================

% Problema 3.10: 
cap = 12;
ax10 = axes;
enlace10 = ['menupcn(3, 10)'];

% Figura
t = (0:0.2:1);
x = [1 1 4 4 7 7]; y = [1 4 4 1 1 4];
p = polyfit(t,x,5); q = polyfit(t,y,5);
tg = 0:0.01:1;
xp = polyval(p,tg); yq = polyval(q,tg);
x1 = [2; 2; 3; 3]; y1 = [0; 3; 3; 0];
x2 = x1+3; y2 = y1 + 2;
fill(x1,y1,'k'), hold on, fill(x2,y2,'k')
axis equal
axis([0,8,0,5])
pl = plot(x,y,'*',xp,yq,'r');
set(pl(2),'clip','off')
hold off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];

set(ax10, ...
    'Color', colornum, ...
    'ButtonDownFcn', enlace10, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace10);

% Fin Problema 3.10
   
%====================================
