%% 3.1. Viajeros al metro.  Interpolacin polinmica.
% 
% En este problema se obtienen polinomios de interpolacin de distintos 
% grados, mostrando el proceso a seguir paso a paso y utilizando directamente 
% el comando polyfit.
%
% 
% Tema 3, Problema 1
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%% 
%
% a) Interpolacin lineal
%
% El polinomio de grado 1 es la recta que pasa por los puntos (10,21) y (11,9)
% se obtiene al resolver el siguiente sistema lineal:

M = [10 1;11 1];
b = [21 9]';
p1 = M\b                   % Coeficientes de la recta
v1 = polyval(p1, 10.5)     % Estimacin a las 10:30

x = 8:14;
y = [41 35 21 9 11 17 32];
plot(x, y, '*', [10 11], [21 9], 10.5, v1, 'r*')
title('Viajeros al metro')
xlabel('Hora')
legend('Datos', 'Interpolacin', 'Estimacin')
grid


%%
%
% b) Interpolacin cuadrtica
%
% Para obtener la parbola que interpola los datos consideramos los tres
% puntos ms prximos al que se desea obtener la estimacin, la matriz
% asociada al sistema es de Vandermomde. 

x2 = x(2:4)';
y2 = y(2:4)';
A = vander(x2)


%%
%
% Resolviendo el sistema obtenemos los coeficientes del polinomio y lo
% evaluamos para obtener la estimacin deseada.

p2 = A\y2
v2 = polyval(p2,10.5)

xg = linspace(8,14);
yg2 = polyval(p2, xg);
plot(x, y, '*', xg, yg2, 10.5, v2, 'r*')
title('Viajeros al metro')
xlabel('Hora')
legend('Datos', 'Pol. grado 2', 'Estimacin')
grid


%%
%
% c) Para obtener los polinomios de interpolacin directamente podemos
% hacer uso del comando polyfit, damos como parmetros de entrada los
% puntos de interpolacin y el grado del polinomio.

x3 = x(2:5);
y3 = y(2:5);
p3 = polyfit(x3, y3, 3)
v3 = polyval(p3, 10.5)

yg3 = polyval(p3, xg);
plot(x, y, '*', xg, yg3, 10.5, v3, 'r*')
title('Viajeros al metro')
xlabel('Hora')
legend('Datos', 'Pol. grado 3', 'Estimacin')
grid


%%
%
% Representamos los distintos polinomios interpoladores en una misma
% grfica.

yg1 = polyval(p1, xg);
plot(x, y, '*', xg, [yg1' yg2' yg3'])
title('Viajeros al metro')
xlabel('Hora')
legend('Datos', 'Grado 1', 'Grado 2', 'Grado 3')
grid


%%
% 
% FIN del Problema 3.1
