function [c,T] = polynew(x,y,n)

% Polinomio de interpolacin de (x,y) forma de Newton
% p(x)=Cn+1 + Cn(x-x1) + Cn-1(x-x1)(x-x2) +  + C1(x-x1)(x-xn)

x = x(:); y = y(:);
if nargin==2
    n = length(x)-1;
end

% Tabla de diferencias divididas
T = y(1:n+1);
for j = 2:n+1  % Filas
    for k = 2:j
        T(j,k) = (T(j,k-1)-T(j-1,k-1))/(x(j)-x(j-k+1));
    end
end
% Coeficientes del polinomio de Newton
c = flipud(diag(T));