%% 3.5.  Funcin de Runge. Nodos de Chebyshev.
%
% Con este problema se pretende mostrar que para funciones con
% caractersticas muy diferentes a las de los polinomios, la interpolacin
% polinmica con nodos equiespaciados puede resultar inadecuada. Como es el
% caso de la funcin de Runge, como alternativa se interpola mediante los
% nodos de Chebyshev.
%
%
% Tema 3, Problema 5
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson



 
%% 
%
% Representamos la funcin de Runge en el intervalo [-5,5].
type runge
x = linspace(-5,5);
y = runge(x);
plot(x,y)
title('Funcin de Runge')


%%
%
% Los polinomios de interpolacin, tomando nodos equiespaciados, de grados
% 4,8,12 y 16 que aproximan a la funcin de Runge, presentan, a medida que
% aumenta el grado, mayor error en los extremos.

type rungeequi

rungeequi('runge')

%% 
%
% La aproximacin mejora notablemente tomando nodos de Chebyshev.

type rungecheb

rungecheb('runge')
%%
%
% FIN del Problema 3.5