%% 3.8.  Interpolando y = arctg x
%
% En este problema se comparan los resultados obtenidos al aproximar la
% funcin y = arctg x mediante un spline cbico completo, y un spline
% cbico no nodo.
%
%
% Tema 3, Problema 8.
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%% 
%
% Representamos la funcin y = arc tg x que se desea interpolar junto a los
% nodos, x = -3,-2,...,2,3, que definen los subintervalos sobre los que se
% van a construir los polinomios segmentarios.

x = (-3:3);
y = atan(x);
xg = linspace(-3,3);
yg = atan(xg);
plot(x, y, '*', xg, yg)
title('Funcin y = arctg(x)')


%% 
%
% El spline completo se obtiene con la orden spline de MATLAB aadiendo a
% las ordenadas dos componentes con los valores de la derivada en los
% extremos.

dy = 1/(1 + 3^2); % La derivada primera en los extremos.
ps = spline(x, [dy y dy]);
ysc = ppval(ps,xg);
s = ps.coefs
plot(x, y, '*', xg, yg, xg, ysc)
title('Funcin y = arctg(x)')
legend('Nodos', 'Funcin', 'Spline completo', 0)


%%
%
% La existencia de derivada tercera en los nodos segundo y penltimo exige
% que las dos primeras piezas del spline sean el mismo polinomio, al igual
% que las dos ltimas. Este es el interpolante cbico segmentario, 'no
% nodo', que calcula MATLAB por defecto.

psnn = spline(x,y);
ysnn = ppval(psnn, xg);
snn = psnn.coefs
plot(x, y, '*', xg, yg, xg, ysnn)
title('Funcin y = arctg(x)')
legend('Nodos', 'Funcin', 'Spline ''no nodo''', 0)


%%
%
% Representamos en una misma grfica las dos interpolaciones. La diferencia
% ms apreciable entre ambas aproximaciones es la distinta convexidad en
% las piezas extremas. En el primer subintervalo, el spline completo tiene
% derivada segunda positiva, al igual que la funcin, mientras que el
% spline ''no nodo'' tiene derivada segunda negativa.

plot(x, y, '*', xg, yg, xg, ysc, xg, ysnn)
title('Funcin y = arctg(x)')
legend('Nodos', 'Funcin', 'Spline completo', 'Spline ''no nodo''', 0)


%%
%
% En este ejemplo, el spline completo se adapta mejor a la funcin, aunque
% la diferencia mxima de la funcin con ambos splines es muy semejante.

plot(x, y - y, '*', xg, ysc - yg, xg, ysnn - yg)
title('Diferencia con la funcin y = arctg(x)')
legend('Nodos', 'Spline completo', 'Spline ''no nodo''', 0)
grid


%%
%
% FIN del Problema 3.8