function [ps,s] = natural(x,y,r1,rn1)

% Spline natural
% r1 rn1 derivada segunda en los extremos
n = length(x)-1;					% N intervalos
x = x(:);
y = y(:);
r = zeros(n+1,1);					
r(1) = r1;
r(n+1) =  rn1;
h = diff(x);						% Incremento de x

% Diagonales de la matriz del sistema
ds = h(2:n-1)/6;					
dp = (h(1:n-1)+h(2:n))/3;				
M = diag(dp)+diag(ds,1)+diag(ds,-1);

% Trminos independientes
e = diff(y)./h;
g = diff(e);
g(1) = g(1)-h(1)*r(1)/6;
g(n-1) = g(n-1)-h(n)/6*r(n+1);			

% M*r=g
r(2:n) = M\g;		

% Coeficinetes del spline
a = y(1:n);
rl = r(1:n);rr=r(2:n+1);
b = e-(rr+2*rl).*h/6;
c = rl/2;
d = diff(r)./h/6;

% Matriz de coeficientes del spline
s = [d c b a];
ps = mkpp(x,s);
