function dm04

% Capitulo 4
% Integracin Numrica

% Problemas Resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

% jlh: nov-2006

% Ventana principal
fondo = [0 0 0];
colortit = [1 0.5 0];
colorcap = [0 0.3 0.9];
colornum = [0.9 0.9 0.9];
c_ejes = fondo; 
figure('Menubar', 'None', ...
    'Color', fondo, ...
    'Units', 'normalized', ...
    'Position', [0.05 0.1 0.9 0.8], ...
    'Numbertitle', 'off', ...
    'Name', 'Captulo 4. Integracin Numrica');

% Plantilla
sep = 0.05;
alto_texto = 0.05;
fil = 3;
col = 4;
fc = fil*col;
ancho_ejes = 1/col - sep;
alto_ejes = 1/fil - sep - alto_texto;
x_ejes = sep/2 : sep + ancho_ejes : 1;
y_ejes = sep/2 : sep + alto_ejes + alto_texto : 1;
y_txt = sep/2 + alto_ejes + alto_texto : sep + alto_ejes + alto_texto : 1;
y_ejes = fliplr(y_ejes);
y_txt = fliplr(y_txt);
[Y_ejes, X_ejes] = meshgrid(y_ejes, x_ejes);
[Y_txt, X_txt] = meshgrid(y_txt, x_ejes);

%====================================

% Ttulos de los problemas
axes(...
    'Color', fondo, ...
    'XColor', fondo, ...
    'YColor', fondo, ...
    'ZColor', fondo, ...
    'Position', [0 0 1 1]);

problema = char(...
    '1. Frmula de cuadratura', ... 
    '2. Mstil de un velero', ... 
    '3. Fuerza en una presa', ... 
    '4. Desplazamiento en un fluido', ... 
    '5. Anlisis de convergencia', ... 
    '', ... 
    '', ... 
    '6. Integral doble', ... 
    '7. Doble no rectangular', ... 
    '8. Doble en polares', ... 
    '9. Flujo campo vectorial', ... 
    '10. Centro de masa');
txpro = text(X_txt(:), Y_txt(:), problema, ...
    'HorizontalAlignment', 'left', ...
    'VerticalAlignment', 'top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);
txpro(6:7) = [];
for k = 1:10
    set(txpro(k), 'ButtonDownFcn', ['menupcn(4,', num2str(k),')'])
end
set(txpro(10), 'ButtonDownFcn', 'menupcn(4,10,'''',''largetext'')')

%====================================

% Problema 4.5: 
cap = 5;
ax05 = axes;
enlace05 = ['menupcn(4, 5)'];

% Figura 5: 
x = linspace(0.01,20*pi,1000);
y = sin(x)./x;
area(x,y)
set(get(gca,'Ch'),'FaceColor','Red', 'EdgeColor', 'b')
axis([0 20*pi -0.2 1])
axis off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) 4*ancho_ejes+3*sep  alto_ejes];
set(ax05, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace05);

% Fin Problema 4.5
   
%====================================

% Titulo
ejes_pos = [X_ejes(6), Y_ejes(6), ancho_ejes, alto_ejes];
ax1 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

image(imread('prmn.jpg'))
axis equal off

ejes_pos = [X_ejes(7)-sep, Y_ejes(7), ancho_ejes, alto_ejes];
ax0 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

Capitulo = [...
        'Integracin';...
        '  Numrica '];

tx1 = text( ...
    'String',Capitulo, ...
    'Position', [0.5,0.5], ...
    'VerticalAlignment','middle', ...
    'HorizontalAlignment','Center', ...
    'FontSize',18, ...
    'FontName','Arial', ...
    'FontWeight','demi', ...
    'Color',colortit);

%====================================

% Problema 4.1
cap = 1;
ax01 = axes;
ejes_pos = [X_ejes(cap), Y_ejes(cap), ancho_ejes, alto_ejes];
enlace01 = ['menupcn(4, 1)'];

% Figura 1: 
k=1:11;
b=1./k;
b=b(:);
k=0:10;
v=k/10;
B=vander(v);
A=rot90(B);
w=A\b;
stem(k, w, 'Linewidth', 2, ...
    'Markersize', 6, ...
    'Color', 'Red', ...
    'MarkerFaceColor','Red', ...
    'MarkerEdgeColor','Red')
h = get(gca, 'Ch');
set(h(1), 'Linewidth', 2, ...
    'Color', 'Blue')

set(ax01, ...
    'Position', ejes_pos, ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace01);


set(get(ax01, 'Children'), ...
    'ButtonDownFcn', enlace01);

% Fin Problema 4.1
   
%====================================

% Problema 4.2
cap = 2;
ax02 = axes;
enlace02 = ['menupcn(4, 2)'];
ejes_pos = [X_ejes(cap), Y_ejes(cap), ancho_ejes, alto_ejes];

% Figura 2: 
image(imread('velero.jpg'))
axis equal off

set(ax02, ...
    'ButtonDownFcn', enlace02, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace02);

% Fin Problema 4.2
   
%====================================

% Problema 4.3: 
cap = 3;
ax03 = axes;
enlace03 = ['menupcn(4, 3)'];

% Figura 3: 
image(imread('pantano.jpg'))
axis equal off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax03, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace03, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace03);

% Fin Problema 4.3
   
%====================================

% Problema 4.4: 
cap = 4;
ax04 = axes;
enlace04 = ['menupcn(4, 4)'];

% Figura 4: 
r=1;
q= [1 0];
for k = 1:7
    p= (1/(k+1))*((2*k+1)*[q 0]-k*[0 0 r]);
    r=q;
    q=p;
end
Nodos = roots(p);
dp = polyder(p);
y=polyval(dp,Nodos);
Pesos =2./((1-Nodos.^2).*(y.^2));

stem(Nodos, Pesos, 'Linewidth', 2, ...
    'Markersize', 5, ...
    'Color', 'red', ...
    'MarkerFaceColor','Red', ...
    'MarkerEdgeColor','Red')
h = get(gca, 'Ch');
set(h(1), 'Linewidth', 2, ...
    'Color', 'Blue')

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax04, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace04, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace04);

% Fin Problema 4.4
   

%====================================

% Problema 4.6: 
cap = 8;
ax06 = axes;
enlace06 = ['menupcn(4, 6)'];

% Figura 6: 
x = 0:0.05:1;
y = x;
[X,Y] = meshgrid(x,y);
Z = 1./(1 - 0.5*X.*Y);
surf(X,Y,Z)


% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax06, ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace06, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace06);

% Fin Problema 4.6
   
%====================================
   

% Problema 4.7: 
cap = 9;
ax07 = axes;
enlace07 = ['menupcn(4, 7)'];

% Figura 7
x = 0:0.1:1;
cx = x.^2;   dx = sqrt(x);
uno = ones(11,1);
X = uno*x;
Y = uno*cx + (0:10)'*(dx - cx)./10;
Z = exp(- X.^2.*Y.^2);
surf(X,Y,Z)
shading interp
hold on
surf(X,Y,zeros(size(X)))
view(100,30)
hold off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax07, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace07, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace07);

% Fin Problema 4.7

%====================================

% Problema 4.8: 
cap = 10;
ax08 = axes;
enlace08 = ['menupcn(4, 8)'];

% Figura 8: 
a = 1-sqrt(2)/2;
x1 = linspace(a,1,8);
x2 = 1.1:0.1:2;
x = [x1 x2];
cx = 1 - sqrt(1-(x-1).^2);
d1x = x1;
d2x = ones(size(x2));
dx = [d1x d2x];
uno = ones(11,1);
X = uno*x;
Y = uno*cx + (0:10)'*(dx - cx)./10;
Z = sin(sqrt(log(X+Y+1)));
surf(X,Y,Z)
shading interp
hold on
surf(X,Y,zeros(size(X)))
view(30,30)
hold off
% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax08, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace08, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace08);

% Fin Problema 4.8
   
%====================================

% Problema 4.9:
cap = 11;
ax09 = axes;
enlace09 = ['menupcn(4, 9)'];

% Figura 9: 
[X,Y,Z] = cylinder(sqrt(2*pi)*ones(5,1),40);
Z=2*Z;
surf(X,Y,Z)
view(164,68)
Fx = sin(X.*Y);
Fy = zeros(size(Fx));
Fz = Fy;
hold on
quiver3(X,Y,Z,Fx,Fy,Fz,'g')
hold off
axis off

% Ejes
ejes_pos = [X_ejes(cap)-sep Y_ejes(cap)-sep ancho_ejes+2*sep alto_ejes+2*sep];
set(ax09, ...
    'ButtonDownFcn', enlace09, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace09);

% Fin Problema 4.9
   
%====================================

% Problema 4.10: 
cap = 12;
ax10 = axes;
enlace10 = ['menupcn(4,10,'''',''largetext'')'];

% Figura
[x,y,z] = meshgrid(0:0.05:1,0:0.05:1,0:0.05:1);
v = 4 - 4/3*sqrt(z + x.^2 + y.^2);
xslice = [0.35,0.65,1]; yslice = [0.5,1]; zslice = [0, 0.5];
slice(x,y,z,v,xslice,yslice,zslice)

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];

set(ax10, ...
    'ButtonDownFcn', enlace10, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace10);

% Fin Problema 4.10
   
%====================================
