%% 4.2 Fuerza ejercida sobre el mastil de un velero
%
% En este problema se calcula la fuerza que se ejerce sobre el mastil de un
% velero utilizando para ello los metodos de Romberg y de los trapecios.
%
%
% Tema 4, Problema 2.
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%% 
% 
% a) Aproximacin de la integral por el mtodo de trapecios
%
% Modificamos la funcion trapecios para que calcule sucesivas aproximaciones
% de la integral mediante la formula compuesta de trapecios con 10n
% subintervalos.

type trapecios0402;

%% 
%
% Construimos el archivo f.m en el que definimos la funcin integrando. 
% Ejecutamos la funcin trapecios0402 con un nmero mximo de subintervalos 
% de 1000. En este caso el error cometido es 9.8843e-5.

[T, incr]=trapecios0402('f',0,30,100,1e-4)


%%
%
% Para alcanzar una cota de error por debajo de 1.0e-8, necesitamos utilizar
% 18570 subintervalos. Con ese nmero de subintervalos se obtiene una cota 
% de error de 9.9e-9.

[T,incr]=trapecios0402('f',0,30,1860,1e-8)


%%
% b) Aproximacin de la integral por el mtodo de Romberg
%
% Llamamos a la funcin Romberg con tol=1e-8, un numero inicial de
% subintervalos de 10 y un nmero mximo de filas de 50. Obtenemos una
% aproximacin similar a la obtenida por trapecios,con 360 subintervalos 
% frente a los 18570  que eran necesarios antes.

R=Romberg('f',0,30,10,1e-8,50)


%%
% c) Extrapolacin de Richardson sobre la frmula del punto medio.
% 
% Para mejorar las aproximaciones que nos d la formula del punto medio sin 
% aumentar excesivamente el numero de operaciones, podemos aplicar la 
% extrapolacion de Richardson a esta frmula, de forma anloga a como la 
% aplicbamos a trapecios para obtener el mtodo de Romberg.

type rchpmed;

%%
%
% Llamamos a la funcin rchpmed con los mismos parmetros de entrada que
% hemos utilizado con el mtodo de Romberg. No se observan grandes 
% diferencias entre ambos mtodos.

R=rchpmed('f',0,30,10,1e-8,50)

%%
%
% FIN del Problema 4.2
