%% 4.3 Fuerza ejercida por el agua en una presa
%
% En este problema se va a calcular la fuerza que ejerce el agua embalsada 
% en una presa sobre sus paredes. 
%
% Tema 4, Problema 3.
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

%% 
% a) Fuerza calculada mediante la formula de trapecios.
%
% El vector de nodos z y el ancho del rio,w, son:

z=0:10:60;
w=[122 130 135 160 175 190 200];
plot(w,z)
legend('Perfil de la presa',0)

%% 
%
% Definimos las constantes de la densidad del agua, p, la aceleracion 
% producida por la gravedad, g,  y distancia al fondo, D.

p=1e+3;
g=9.8;
D=60;
y=p*g*w.*(D-z); %integrando

%%
% Por ltimo obtenemos la fuerza ejercida aplicando el mtodo de trapecios

f=trapz(z,y) 

%% 
% b) Fuerza calculada mediante la formula de Simpson.
%
% Construimos la funcin simpz.m en la que programamos el mtodo de Simpson
% cuando trabajamos con valores discretos de una funcin. El contenido de
% simpz es:

type simpz;

%%
% Debemos averiguar el ancho del rio cada 6 metros de profundidad

h=(D-0)/10;
zz=0:h:60;

%%
% Como solo conocemos el ancho del rio en 3 puntos, utilizaremos
% el comando spline para conocer el resto de componentes

ww=spline(z,w,zz)

%%
% Finalmente evaluamos el nuevo integrando y aplicamos la funcin simpz 
% para obtener la fuerza:

yy=p*g*ww.*(D-zz);
f=simpz(zz,yy)

%% 
% c) Fuerza calculada mediante el mtodo de Romberg
%
% Construimos la funcin Rombz en la que programamos el mtodo de Romberg
% para valores discretos de la funcin integrando

type Rombz;

%%
% Llamamos a la funcin Rombz con una tolerancia de 11e-8 y un nmero 
% mximo de filas igual a 5

R=Rombz(z,y,10e-8,5)

%%
%
% FIN del Problema 4.3
