%% 4.4 Particula desplazandose en un fluido
%
% En este problema se analiza el movimiento de una particula de masa m
% sometida a una resistencia viscosa R que depende de la velocidad v de la
% particula. Aproximamos el tiempo que tarda en reducir su velocidad a la
% mitad, mediante diferentes frmulas de cuadratura
%
%
% Tema 4, Problema 4.
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

%%
% a) Tiempo aproximado mediante el mtodo de Simpson.
%
% Calculamos del tiempo que tarda en pasar la partcula de una velocidad de
% 10m/s a 5m/s utilizando del metodo de Simpson con 10n subintervalos hasta
% que la diferencia entre dos aproximaciones consecutivas sea menor de
% 1e-6
 

%% 
% Construimos el archivo f.m con la funcin integrando y el archivo
% Simpson0404.m con una pequea modificacin del mtodo de Simpson para 
% adaptarlo a lo que pide el problema. Esta funcin es:

type Simpson0404;

%%
% Llamamos a la funcin Simpson0404 con los parmetros de entrada indicados
% en el problema

t=Simpson0404('f',5,10,10,1e-6,10)

%%
% b) Tiempo aproximado mediante el mtodo de Gauss-Legendre.
%
% Para programar el mtodo de Gauss-Legendre, necesitamos en primer lugar
% calcular los nodos y pesos de dicha cuadratura. Para ello construimos
% la funcin NPLegendre.m que calcula las raices del polinomio de Legendre 
% de grado n y sus pesos de la cuadratura de Gauss-Legendre.

type NPLegendre;

%%
% Obtenemos los noods  y pesos de Gauss-Legendre para n=8

[N,P]=NPLegendre(8)
stem(N,P)

%%
% Programamos la frmula de cudratura de Gauss-Legendre en la funcin
% GaussLegendre.m, cuyo contenido se muestra a continuacion, y ejecutamos
% dicha funcin con los parmetros del problema

type GaussLegendre;

t=GaussLegendre('f',5,10,8)

%%
% c) Tiempo aproximado mediante el mtodo de Monte-Carlo.
%
% Utilizamos ahora para la obtencin del tiempo el mtodo de Monte-Carlo,
% con 2^k nodos de cuadratura, k=6,7,8,.... Como nmero mximo de nodos
% tomamos 2^15

I=mcarlo1('f',5,10,15)

    
%%
%
% FIN del Problema 4.4
