%% 4.6 Aproximacin de integral doble
%
% Consideramos una funcin definida mediante una integral doble.
% Determinaremos el valor de dicha funcin aproximando la integral doble
% mediante las cuadraturas de Simpson y Gauss-Legendre. Compararemos los
% resultados con la solucin exacta.
%
%
% Tema 4, Problema 6.
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%% 
% 
% a) Debemos evaluar la funcin en lambda = 0.5 y lambda = 0.9. En sendos
% casos, la integral doble est definida sobre un recinto rectangular en el
% que la funcin integrando no presenta ningun punto de discontinuidad.
% Aplicando pues cuadratura de Simpson se obtendr una buena aproximacin
% de la integral. 

IS05 = Simpson2r('f05',0,1,0,1,5,5)

%%
%
% Y hacemos lo propio para lambda = 0.9

IS09 = Simpson2r('f09',0,1,0,1,5,5)

%% 
%
% b) Cuando lambda = 1, la funcin integrando tiene una discontinuidad en
% el punto (1,1). Por tanto al aplicar Simpson o cuanquier formula de
% cuadratura con nodos equiespaciados aparecer un mensaje de error debido
% a esa discontinuidad. Para aproximar esa integral debemos utilizar
% formulas de cuadratura con puntos no equiespaciados.

%%
%
% c) Partiendo de la funcin Simpson2r.m, sustituimos los vectores de
% nodos y pesos por los de la cuadratura de Gauss-Legendre, obteniendo as
% una funcin que aproxima integrales dobles sobre recintos rectangulares mediante el mtodo de
% Gauss-Legendre. A continuacin, modificamos esta funcin para adaptarla a
% nuestro problema: tomaremos 2k nodos en cada variable, k = 1,2,..., hasta una
% cota N que introduciremos como parmetro de entrada. Cada
% aproximacin de la integral la almacenamos como una coordenada de
% un vector I.

type prob0406
 


%%
%
% Al ejecutar la funcion, observamos las sucesivas aproximaciones y las
% comparamos con la solucin exacta pi^2/6.

I = prob0406('f1',0,1,0,1,15)
abs(I-pi^2/6)

%%
%
% FIN del Problema 4.6
