%% 4.7 Integral doble sobre recinto no rectangular
%
% Dada una integral doble sobre un recinto limitado por dos curvas, se
% aproxima su valor empleando los mtodos de Simpson y Gauss-Legendre,
% adaptados a recintos no rectangulares.
%
%
% Tema 4, Problema 7.
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%% 
% 
% a) Represenamos grficamente el recinto de integracion y observamos
% que los limites de integracion son [0,1] para la variable x y
% [x^2,sqrt(x)] para y.

x=0:0.02:2;
y=x.^2;
z=sqrt(x);
plot(x,[y',z'])
title(' Recinto de integracin')

%% 
%
% b) Adaptamos la funcin Simpason2r.m para una integral doble con recinto
% no rectangular y la almacenamos en la funcin Simpson2f.m. Definimos la
% funcin integrando f.m y las funciones que definen los limites
% de integracion, c.m y d.m.

I = Simpson2f('f',0,1,'c','d',40,40)

%%
%
% c) Del mismo modo, adaptamos la funcin Prob0406.m, que permite aproximar
% integrales dobles definidas sobre recintos rectangulares, a nuestro caso,
% donde el recinto es no rectangular. Almacenamos la funcin resultante en
% el fichero GaussLegendre2f.m.
%
% La aproximacin que nos proporciona este mtodo coincide unicamente con
% las tres primeras cifras decimales de la aproximacin obtenida en el
% apartado anterior.

I=GaussLegendre2f('f',0,1,'c','d',8,8)


%%
%
% Notemos que para que coincida tambin la cuarta cifra decimal entre ambas
% aproximaciones necesitamos una particin de 600 subintervalos en cada
% variable para el caso de Simpson y polinomios de grado 30 en el caso de
% Gauss-Legendre. Esto nos permite hacernos una idea de la dificultad de
% aproximar con precisin esta integral.

IS = Simpson2f('f',0,1,'c','d',600,600)
IGL = GaussLegendre2f('f',0,1,'c','d',30,30)

%%
%
% FIN del Problema 4.7
