%% 4.8 Integral doble sobre sector circular
%
% Consideramos una integral doble definida sobre un sector de crculo.
% Representamos grficamente el recinto de integracin y aproximamos el
% valor de la integral aplicando las tcnicas de Gauss-Legendre, Romberg y
% Monte-Carlo.
%
%
% Tema 4, Problema 8.
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%% 
% 
% a) Representamos la regin de integracin descompuesta en dos recintos R1
% y R2. A su vez, descompondremos la integral en dos integrales definidas
% respectivamente, sobre sendos recintos.

x = 0:0.001:2;
y1 = sqrt((1-(x-1).^2))+1;
y2 = -sqrt((1-(x-1).^2))+1;
z = x;
y3 = ones(size(x));
plot(x,[y1',y2',z',y3']); hold on
plot(ones(1,501),0:0.002:1); title('Recinto de integracin')
hold off
text(0.7,0.4,'R1')
text(1.5,0.4,'R2')

%% 
%
% As, los lmites de integracin sern, en R1:
%                     1-1/sqrt(2) <= x <= 1
%               1-sqrt(1-(x-1)^2) <= y <= x,
% y en R2:
%                               1 <= x <= 2
%               1-sqrt(1-(x-1)^2) <= y <= 1. 

%%
%
% b)Ejecutando la funcion GaussLegendre2f cosntruida en el Problema 4.7:

I1 = GaussLegendre2f('f',1-1/sqrt(2),1,'c','d',15,15)
I2 = GaussLegendre2f('f',1,2,'c','uno',15,15)
IGL = I1+I2

%%
%
% c) Sabemos que programar el mtodo de Romberg para recintos no
% rectangulares pasa, en primer lugar, por programar el mtodo de trapecios
% para tales recintos. As, construimos la funcin trapecios2f.m. A
% continuacin, modificamos la funcin Romberg para que aplique la
% extrapolacin de Richardson sobre sucesivas llamadas a trapecios2f.
% Llamamos a esta funcin Romberg2f.m.

type Romberg2f

%%
%
% Llamamos a Romberg2f para calcular I1 e I2.

I1 = Romberg2f('f',1-(1/sqrt(2)),1,'c','d',32,32,1e-7,50)
I1 = I1(end,end);
I2 = Romberg2f('f',1,2,'c','uno',32,32,1e-7,50)
I2 = I2(end,end);
IR = I1+I2


%%
%
% d) Para aproximar I aplicando el mtodo de Monte-Carlo, tomamos puntos
% aleatorios  en el rectangulo [0,2]x[0,2] y analizamos si estan en el
% recinto de integracin. En caso afirmativo, ser un nodo de integracin;
% en caso negativo, lo desechamos. El proceso se repite hasta alcanzar el
% numero de nodos deseados, partiendo de 2, 2^2, 2^3,... nodos . En este
% caso, representaremos los 2^13 puntos considerados en la regin de
% integracin y la evolucin de las aproximaciones.

I = MonteCarlo2f('f',13)

%%
%
% FIN del Problema 4.8
