%% 4.9 Flujo de un campo vectorial
%
% Calculamos el flujo de un campo vectorial a traves de la superficie de un
% cilindro de base circular y altura conocida, mediante la aproximacin de
% una integral triple definida sobre un recinto rectangular. Para ello,
% emplearemos los mtodos de Simpson y Monte-Carlo.
%
%
% Tema 4, Problema 9.
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%% 
% 
% a) Planteamos la integral en coordenadas cilndricas (r,alpha,z). El
% recinto de integracin es [0,5]x[0,2pi]x[0,2] y la funcin integrando la
% almacenamos en f.m:
%              r^2*sin(alpha)*cos(r.^2*cos(alpha)*sin(alpha))


%% 
%
% b) Almacenamos en la funcin Simpson3r.m el cdigo que nos permite aproximar
% integrales triples, generalizando a tres variables la funcin
% Simpson2r.m. Observamos que el flujo calculado es prcticamente nulo.

IS = Simpson3r('f',0,5,0,2*pi,0,2,10,10,10)

%%
%
% c) La funcin mcarlo3r.m aproxima la integral triple por el mtodo de
% Monte-Carlo, generando puntos aleatorios en la regin tridimensional de
% integracin y evaluando en ellos el integrando. Aproximamos el flujo
% empleando para ello 2, 2^2, 2^3,..., 2^23 puntos. Observamos en la
% grfica de las sucesivas aproximaciones que la convergencia es muy lenta
% y el coste computacional elevado.
 
for k = 0:18
    I(k+1) = mcarlo3r('f',0,5,0,2*pi,0,2,2^(k))
end
plot(I)

%%
%
% FIN del Problema 4.9
