function I=Simpson3r(g,a,b,c,d,e,f,n1,n2,n3)
% Cuadratura de Simpson para f(x,y) en el recinto [a,b]x[c,d]x[e,f]
%2*n1: numero de subintervalos en x
%2*n2: numero de subintervalos en y
%2*n3: numero de subintervalos en z
h=(b-a)/(2*n1);   k=(d-c)/(2*n2);   w=(f-e)/(2*n3);

p=ones(1,2*n1+1);               %pesos de x
p(2:2:2*n1)=4; p(3:2:2*n1-1)=2;

q=ones(1,2*n2+1);               %pesos de y
q(2:2:2*n2)=4; q(3:2:2*n2-1)=2;

r=ones(1,2*n3+1);               %pesos de z
r(2:2:2*n3)=4; r(3:2:2*n3-1)=2;

p=h/3*p;  q=k/3*q;   r=w/3*r;

x=a:h:b;  y=c:k:d;   z=e:w:f;

for i=1:2*n1+1
    for j=1:2*n2+1
        A = feval(g,x(i),y(j),z);
        Iz(j,:)=r.*A;
        Iz2(j)=sum(Iz(j,:));    %Integral respecto a z
    end
    Iy(i)=q*Iz2';               %Integral respecto a y
end
I=p*Iy';                         %Integral respecto a x