%% 4.10 Centro de masa de un cuerpo
%
% Consideramos un cuerpo del que conocemos su funcin de densidad.
% Aproximaremos su centro de masa utilizando la cuadratura de
% Gauss-Legendre y el metodo de Simpson.
%
%
% Tema 4, Problema 10.
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%%
%
% a) El centro de masa est ubicado en el punto de coordenadas 
%                   (Myz/m, Mxz/m, Mxy/m)
% donde m es la masa del cuerpo y Myz, Mxz, y Mxy son los momentos
% alrededor de los planos coordenados.
%
% Almacenamos en f.m la funcin densidad del cuerpo, y en fx.m, fy.m, fz.m
% los respectivos productos de la funcin densidad por las coordandas x, y,
% z. As, la masa y los momentos se obtendrn aproximando las integrales
% definidas por estas funcines en el recinto delimitado por el cuerpo.

m = GaussLegendre3r('f',0,1,0,1,0,1,15,15,15)
Myz = GaussLegendre3r('fx',0,1,0,1,0,1,15,15,15)
Mxz = GaussLegendre3r('fy',0,1,0,1,0,1,15,15,15)
Mxy = GaussLegendre3r('fz',0,1,0,1,0,1,15,15,15)
centromasasGL = [Myz/m,Mxz/m,Mxy/m]


%% 
%
% Modificamos la funcin Simpson3r.m construida en el Problema 4.9, de
% manera que almacenamos en un vector las aproximaciones de la integral
% para 10, 20, 30,... nodos en cada variable, hasta que la diferencia entre
% dos aproximaciones consecutivas sea suficientemente pequea.

m = Simpsoniter3r('f',0,1,0,1,0,1,1e-7,50), m = m(end);
Myz = Simpsoniter3r('fx',0,1,0,1,0,1,1e-7,50), Myz = Myz(end);
Mxz = Simpsoniter3r('fy',0,1,0,1,0,1,1e-7,50), Mxz = Mxz(end);
Mxy = Simpsoniter3r('fz',0,1,0,1,0,1,1e-7,50), Mxy = Mxy(end);
centromasasS = [Myz/m,Mxz/m,Mxy/m]


%%
%
% FIN del Problema 4.10
