function dm05

% Capitulo 5
% Problemas de Valor Inicial
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

% jlh: nov-2006

% Ventana principal
fondo = [0 0 0];
colortit = [1 0.5 0];
colorcap = [0 0.3 0.9];
colornum = [0.9 0.9 0.9];
c_ejes = fondo; 
figure('Menubar', 'None', ...
    'Color', fondo, ...
    'Units', 'normalized', ...
    'Position', [0.05 0.1 0.9 0.8], ...
    'Numbertitle', 'off', ...
    'Name', 'Captulo 5. Problemas de Valor Inicial');

% Plantilla
sep = 0.05;
alto_texto = 0.05;
fil = 3;
col = 4;
fc = fil*col;
ancho_ejes = 1/col - sep;
alto_ejes = 1/fil - sep - alto_texto;
x_ejes = sep/2 : sep + ancho_ejes : 1;
y_ejes = sep/2 : sep + alto_ejes + alto_texto : 1;
y_txt = sep/2 + alto_ejes + alto_texto : sep + alto_ejes + alto_texto : 1;
y_ejes = fliplr(y_ejes);
y_txt = fliplr(y_txt);
[Y_ejes, X_ejes] = meshgrid(y_ejes, x_ejes);
[Y_txt, X_txt] = meshgrid(y_txt, x_ejes);

%====================================

% Ttulos de los problemas
axes(...
    'Color', fondo, ...
    'XColor', fondo, ...
    'YColor', fondo, ...
    'ZColor', fondo, ...
    'Position', [0 0 1 1]);

problema = char(...
    '1. Modelos de poblacin. Euler', ... 
    '2. Modelos de poblacin. Heun', ... 
    '3. Depsito cnico', ... 
    '4. Circuito RC', ... 
    '5. Cada en medio resistente', ... 
    '', ... 
    '', ... 
    '6. Modelo Presa-Rapaz', ... 
    '7. Circuito LRC', ... 
    '8. Movimiento del pndulo', ... 
    '9. Mesa de resortes', ... 
    '10. Control biolgico de plagas');
txpro = text(X_txt(:), Y_txt(:), problema, ...
    'HorizontalAlignment', 'left', ...
    'VerticalAlignment', 'top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);
txpro(6:7) = [];
for k = 1:10
    set(txpro(k), 'ButtonDownFcn', ['menupcn(5,', num2str(k),')'])
end

%====================================

% Titulo
ejes_pos = [X_ejes(6), Y_ejes(6), ancho_ejes, alto_ejes];
ax1 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

image(imread('prmn.jpg'))
axis equal off

ejes_pos = [X_ejes(7)-sep, Y_ejes(7), ancho_ejes, alto_ejes];
ax0 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

Capitulo = [...
        'Problemas de ';...
        'Valor Inicial'];

tx1 = text( ...
    'String',Capitulo, ...
    'Position', [0.5,0.5], ...
    'VerticalAlignment','middle', ...
    'HorizontalAlignment','Center', ...
    'FontSize',18, ...
    'FontName','Arial', ...
    'FontWeight','demi', ...
    'Color',colortit);

%====================================

% Problema 5.1
cap = 1;
ax01 = axes;
ejes_pos = [X_ejes(cap), Y_ejes(cap), ancho_ejes, alto_ejes];
enlace01 = ['menupcn(5, 1)'];

% Figura 1: 
image(imread('Malthus.jpg'))
title('Thomas Malthus', 'Color', colortit)
axis equal off

set(ax01, ...
    'Position', ejes_pos, ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace01);


set(get(ax01, 'Children'), ...
    'ButtonDownFcn', enlace01);

% Fin Problema 5.1
   
%====================================

% Problema 5.2
cap = 2;
ax02 = axes;
enlace02 = ['menupcn(5, 2)'];
ejes_pos = [X_ejes(cap), Y_ejes(cap), ancho_ejes, alto_ejes];

% Figura 2: 
image(imread('Verhulst.jpg'))
title('Pierre Verhulst', 'Color', colortit)
axis equal off


set(ax02, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace02, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace02);

% Fin Problema 5.2
   
%====================================

% Problema 5.3: 
cap = 3;
ax03 = axes;
enlace03 = ['menupcn(5, 3)'];

% Figura 3: 
image(imread('deposito.jpg'))
axis off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax03, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace03, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace03);

% Fin Problema 5.3
   
%====================================

% Problema 5.4: 
cap = 4;
ax04 = axes;
enlace04 = ['menupcn(5, 4)'];

% Figura 4: 
image(imread('circuito_rc.jpg'))
axis off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax04, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace04, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace04);

% Fin Problema 5.4
   
%====================================

% Problema 5.5: 
cap = 5;
ax05 = axes;
enlace05 = ['menupcn(5, 5)'];

% Figura 5: 
[t, y2] = rungekutta('proyectil', 0:.5:10, 8);
plot(t, y2)
v = -25:1.75:10;
[tt, vv] = meshgrid(t, v);
uno = ones(size(tt));
dv = proyectil(tt, vv);
hold on, quiver(tt, vv, uno, dv, 'r'), hold off
axis([0 10 -25 10])

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax05, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace05);

% Fin Problema 5.5
   
%====================================

% Problema 5.6: 
cap = 8;
ax06 = axes;
enlace06 = ['menupcn(5, 6)'];

% Figura 6: 
[t,y] = mieuler('presarapaz', 0:0.03:30, [10, 10]);
plot(y(:,1), y(:,2))
c = 10:5:70; z = 10:5:55;
[cc, zz] = meshgrid(c, z);
a = 0.4; b = 0.01; g = 0.01; d = 0.01;
dc = a*cc - b*cc.*zz;
dz = g*cc.*zz - d*zz.^2;
hold on, quiver(cc, zz, dc, dz, 'r'), hold off
axis([10 70 10 55])

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax06, ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace06, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace06);

% Fin Problema 5.6
   
%====================================
   

% Problema 5.7: 
cap = 9;
ax07 = axes;
enlace07 = ['menupcn(5, 7)'];

% Figura 7
image(imread('circuito_lrc.jpg'))
axis off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax07, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace07, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace07);

% Fin Problema 5.7

%====================================

% Problema 5.8: 
cap = 10;
ax08 = axes;
enlace08 = ['menupcn(5, 8)'];

% Figura 8: 
image(imread('pendulo.jpg'))
axis equal off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax08, ...
    'ButtonDownFcn', enlace08, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace08);

% Fin Problema 5.8
   
%====================================

% Problema 5.9:
cap = 11;
ax09 = axes;
enlace09 = ['menupcn(5, 9)'];

% Figura 9: 
image(imread('mesa.jpg'))
axis equal off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax09, ...
    'XTickLabel', [], ...
    'Box', 'off', ...
    'Clipping', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace09, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace09);

% Fin Problema 5.9
   
%====================================

% Problema 5.10: 
cap = 12;
ax10 = axes;
enlace10 = ['menupcn(5, 10)'];

% Figura
image(imread('mosca.jpg'))
axis equal off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];

set(ax10, ...
    'ButtonDownFcn', enlace10, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace10);

% Fin Problema 5.10
   
%====================================
