%% 5.4. Circuito elctrico. Mtodo de Runge-Kutta.
% 
% En este problema se resuelve por el mtodo de Runge-Kutta la ecuacin
% diferencial que modeliza un circuito elctrico y se representa el campo
% de direcciones de la misma.
% 
%
% Tema 5, Problema 4
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

%% 
%
% Editamos un fichero con la ecuacin diferencial que modeliza el circuito.

image(imread('rc_circuit.jpg'))
axis off
type circuito


%%
%
% Resolvemos el problema de valor inicial en el intervalo [0, 0.2] con 
% I(0) = 1

[t, y1] = rungekutta('circuito', 0:.2:2, 1);

y1

plot(t, y1)
title('Circuito elctrico. Mtodo de Runge-Kutta')
xlabel('Tiempo'), ylabel('Intensidad')
grid


%%
%
% La pendiente de la curva solucin en cada punto viene dada por el valor
% de la ecuacin diferencial en dicho punto.
% Mostramos el campo de direcciones de la ecuacin diferencial junto con la
% solucin obtenida.

I = 0:.1:1;
[tt, II] = meshgrid(t, I);
uno = ones(size(tt));
dI = circuito(tt, II);
hold on
quiver(tt, II, uno, dI)
hold off
title('Campo de direcciones de la ecuacin del circuito elctrico')




%%
%
% Para determinar el orden del mtodo, estimamos el error de la solucin
% obtenida con paso h = 0.2 mediante la diferencia con la solucin obtenida
% con paso h = 1.


[t2, y2] = rungekutta('circuito', 0:.1:2, 1);
E1 = max(abs(y1 - y2(1:2:end)));

plot(t, y1 - y2(1:2:end), '.-')
title('Runge-Kutta: Estimacin del error con paso h = 0.2')
xlabel('Tiempo'), ylabel('Error')
hold on, grid


%%
%
% Del mismo modo, el error con paso 0.1 se estima mediante la diferencia
% entre la solucin obtenida con este paso y la obtenida con paso 0.05.
% Como el cociente entre estas estimaciones resulta prximo a 16 = 2^4,
% comprobamos que el mtodo de Runge-Kutta es de orden 4.


[t3, y3] = rungekutta('circuito', 0:.05:2, 1);
E2 = max(abs(y2-y3(1:2:end)))
E1/E2

plot(t2, y2-y3(1:2:end), 'r.-')
title('Mtodo de Runge-Kutta. Reduccin del error con el paso')
xlabel('Tiempo'), ylabel('Error')
legend('h = 0.2','h = 0.1')
hold off


%%
%
% FIN del Problema 5.4
