%% 5.5. Cada en medio resistente. Mtodo de Runge-Kutta.
% 
% En este problema se resuelve por el mtodo de Runge-Kutta la ecuacin
% diferencial que modeliza la cada de un objeto en un medio resistente y
% se representa el campo de direcciones de dicha ecuacin.
% 
%
% Tema 5, Problema 5
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

%% 
%
% Editamos un fichero con la ecuacin diferencial que modeliza el lanzamiento.

type proyectil


%%
%
% Resolvemos el problema de valor inicial en el intervalo [0, 0.2] con 
% v(0) = 8.
% Aparentemente, la velocidad decrece linealmente, tomando valores
% negativos cada vez ms grandes en valor absoluto.

[t, y1] = rungekutta('proyectil', 0:.2:2, 8);

y1

plot(t, y1, 'r')
v = -15:1:10;
[tt, vv] = meshgrid(t, v);
uno = ones(size(tt));
dv = proyectil(tt, vv);
hold on, quiver(tt, vv, uno, dv), hold off
title('Cada en medo resistente. Mtodo de Runge-Kutta')
xlabel('Tiempo'), ylabel('Velocidad')


%%
%
% Sin embargo, al tomar un intervalo mayor, observamos que la velocidad
% tiende a estabilizarse y el proyectil cae finalmente con movimiento
% uniforme, a velocidad constante de unos 23Km/h.

[t, y2] = rungekutta('proyectil', 0:.2:10, 8);

y2

plot(t, y2, 'r')
v = -25:1:10;
[tt, vv] = meshgrid(t, v);
uno = ones(size(tt));
dv = proyectil(tt, vv);
hold on, quiver(tt, vv, uno, dv), hold off
title('Cada en medo resistente. Mtodo de Runge-Kutta')
xlabel('Tiempo'), ylabel('Velocidad')


%%
%
% Analticamente tambin podemos hallar este valor al que tiende la
% velocidad, pues se trata de un punto de equilibrio donde v? = 0.

k = 0.002; 
m = 0.11;
g = 9.8;
vel_lim_teor = -sqrt(m*g/k)
vel_lim_num = y2(end)


%%
%
% FIN del Problema 5.5