%% 5.6. Modelo Presa-Rapaz. Mtodo de Euler.
% 
% En este problema se resuelve por el mtodo de Runge-Kutta el sistema de
% ecuaciones diferenciales que modeliza la competencia entre dos especies y
% se muestra su evolucin a largo plazo.
% 
%
% Tema 5, Problema 6
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

%% 
%
% Editamos un fichero con el sistema de ecuaciones diferenciales del modelo.

type presarapaz


%%
%
% Aplicamos el mtodo de Euler, en el que hemos tenido en cuenta la
% notacin matricial, tomando un paso relativamente pequeo por tratarse de
% un mtodo tan elemental.

[t,y] = mieuler('presarapaz', 0:0.03:30, [10, 10]);
plot(t, y)
title('Modelo presa-rapaz. Mtodo de Euler')
xlabel('Tiempo')
legend('Conejos', 'Zorros')
grid


%%
%
% La figura muestra la evolucin de las poblaciones con el tiempo,
% observndose que tienden a una situacin estable con 40 individuos de
% cada especie. Analticamente, podemos hallar los puntos de equilibrio
% resolviendo el sistema obtenido al exigir que se anulen las derivadas.
% Tambin se muestran las direcciones de y' en el plano (c, z).

plot(y(:,1), y(:,2))
c = 10:5:70; z = 10:5:55;
[cc, zz] = meshgrid(c, z);
a = 0.4; b = 0.01; g = 0.01; d = 0.01;
dc = a*cc - b*cc.*zz;
dz = g*cc.*zz - d*zz.^2;
hold on, quiver(cc, zz, dc, dz), hold off
title('Modelo presa-rapaz. Plano de fases')
xlabel('Conejos'), ylabel('Zorros')


%%
%
% FIN del Problema 5.6