%% 5.7. Circuito LRC. Mtodo de Runge-Kutta.
% 
% En este problema se resuelve por el mtodo de Runge-Kutta el sistema de
% ecuaciones diferenciales que modeliza un circuito elctrico LRC y se
% comprueba que el mtodo utilizado es de orden 4.
% 
%
% Tema 5, Problema 7
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

%% 
%
% Editamos un fichero con el sistema de ecuaciones diferenciales que
% modeliza el circuito.

image(imread('lrc_circuit.jpg'))
axis off
type lrc


%%
%
% Resolvemos el problema de valor inicial en el intervalo [0, 30] con 
% Q(0) = 1 e I(0) = 0.

[t1,y1] = rungekutta('lrc', 0:0.3:30, [1,0]);
disp('Carga   Intensidad')
disp(y1)

plot(t1, y1)
title('Circuito LRC. Mtodo de Runge-Kutta')
xlabel('Tiempo')
legend('Carga', 'Intensidad')
grid


%%
%
% Para determinar el orden del mtodo, estimamos el error de la carga en la
% solucin obtenida con paso h = 0.3 mediante la diferencia con los valores
% de la carga obtenidos con paso h = 0.15.


[t2, y2] = rungekutta('lrc', 0:0.15:30, [1,0]);
E1 = max(abs(y1(:,1) - y2(1:2:end, 1)))

plot(t1, y1(:,1) - y2(1:2:end, 1), '.-')
title('Runge-Kutta: Estimacin del error de la carga con paso h = 0.3')
xlabel('Tiempo'), ylabel('Error')
hold on, grid


%%
%
% Del mismo modo, el error con paso 0.15 se estima mediante la diferencia
% entre la solucin obtenida con este paso y la obtenida con paso 0.075.
% Como el cociente entre estas estimaciones resulta prximo a 16 = 2^4,
% comprobamos que el mtodo de Runge-Kutta es de orden 4.


[t3, y3] = rungekutta('lrc', 0:.075:30, [1,0]);
E2 = max(abs(y2(:,1) - y3(1:2:end, 1)))
E1/E2

plot(t2, y2(:,1) - y3(1:2:end, 1), 'r.-')
title('Mtodo de Runge-Kutta. Reduccin del error con el paso')
xlabel('Tiempo'), ylabel('Error')
legend('h = 0.3','h = 0.15')
hold off


%%
%
% FIN del Problema 5.7
