function dy = lrc(t,y)

% Sistema diferencial de un circuito LRC
% LI' + RI + Q/C = E(t)

% Parametros del circuito
L = 2; R = 0; C = 1; E = 0;

% Variables
Q = y(1);
I = y(2);

% Ecuacin
dQ = I;
dI = (E-Q/C-R*I)/L;

% Salida
dy = [dQ; dI];
