%% 5.9. Mesa de resortes. Mtodo de Runge-Kutta.
% 
% En este problema se resuelve por el mtodo de Runge-Kutta el sistema de
% ecuaciones diferenciales que modeliza la oscilacin en un plano de una masa sujeta a
% resotres de direcciones perpendiculares.
% 
%
% Tema 5, Problema 9
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%% 
%
% Codificamos en un fichero.m el sistema diferencial que describe el
% movimiento de la masa sujeta a los resortes.

type atraccion

image(imread('mesa.jpg'))
axis equal off

%%
%
% Supongamos que la masa est situada en el punto (1,0) con velocidad (0,3). 
% Resolvemos el problema de valor inicial por el mtodo de Runge-Kutta.
% Observamos el comportamiento peridico de la solucin.

[t, y] = rungekutta('atraccion', 0:0.01:3, [1 0 0 3]);

plot(t, y)
title('Mesa de resortes. Mtodo de Runge-Kutta')
xlabel('Tiempo')
legend('x', 'y', 'v_x', 'v_y')
grid


%%
%
% La trayectoria del movimiento segn la solucin aproximada coincide con
% la dada por la solucin exacta, que es una elipse de semiejes 1 y
% 3/sqrt(k/m).

k = 50; m = 1; T = 1:89;
solex = [cos(sqrt(k/m)*t'), 3*sqrt(m/k)*sin(sqrt(k/m)*t')];
plot(y(T,1), y(T,3), '.-', solex(T,1), solex(T,2))
title('Trayectorias del movil')
xlabel('x')
ylabel('y')
legend('Solucin numrica','Solucin analtica')
grid


%%
%
% Dando distintos valores a las constantes de los resortes, la trayectoria
% deja de ser elptica y el cuerpo describe curvas ms complejas.

type atraccion520
[t, y] = rungekutta('atraccion520', 0:0.01:3, [1 0 0 3]);
plot(y(:,1), y(:,3))
title('Trayectoria del movil para k_1 = 5 y k_2 = 20')
xlabel('x')
ylabel('y')


%%
%
% Dando distintos valores a las constantes de los resortes, la trayectoria
% deja de ser elptica y el cuerpo describe curvas ms complejas. En este
% caso la trayectoria no es peridica, como vemos dejndola correr ms
% tiempo.

type atraccion52
[t, y] = rungekutta('atraccion52', 0:0.01:30, [1 0 0 3]);
plot(y(:,1), y(:,3))
title('Trayectoria del movil para k_1 = 5 y k_2 = 2')
xlabel('x')
ylabel('y')


%%
%
% Dando distintos valores a las constantes de los resortes, la trayectoria
% deja de ser elptica y el cuerpo describe curvas ms complejas. En este
% caso la trayectoria no es peridica, como vemos dejndola correr ms
% tiempo.

type atraccion52
[t, y] = rungekutta('atraccion52', 0:0.01:300, [1 0 0 3]);
plot(y(:,1), y(:,3))
title('Trayectoria del mvil para k_1 = 5 y k_2 = 2')
xlabel('x')
ylabel('y')


%%
%
% FIN del Problema 5.9