function [t, y] = eulermod(f, t, y0)

% [t, y] = eulermod(f, [a, b], y0, n)
%
% Aplica eulermod al PVI  y' = f(t,y) con y'(a) = y0
% t nodos de integracin
%
% y solucin aproximada
%
% Ejemplo: sol = eulermod('malthus',0,10,100,10)

% Clculo del numero de estimaciones
n = length(t);
%Paso de integracin
h = diff(t);
% Inicializar solucin
y = zeros(n,1); y(1) = y0;
% Salida: Resto de aproximaciones
for k = 1:n-1
    y12 = y(k) + h(k)/2*feval(f, t(k), y(k));   %Estimacin de yk + h/2
    y(k+1) = y(k) + h(k)*feval(f,t(k) + h(k)/2, y12); %Est. de yk+1
end

  
