function [t, y]=heun(f, t, y1)

% Mtodo de Heun
%
% Aplica Heun al PVI  y' = f(t,y) con y'(a) = y1 en [a,b]
% t: nodos de integracin
% y: solucin aproximada
%
% Ejemplo: [t,y] = Heun('malthus', 0:.1:10, 100)

% Clculo del numero de estimaciones
n = length(t);
% Paso de integracin
h = diff(t);
% Nmero de incognitas
m = length(y1);
% Inicializar solucin
y = zeros(n,m); y(1,:) = y1;
% Resto de aproximaciones
for k = 1:n-1
    k1 = feval(f, t(k), y(k,:))';
    yp =  y(k,:) + h(k)*k1;             % Prediccin
    k2 = feval(f, t(k) + h(k), yp)';
    y(k+1,:) = y(k,:) + h(k)/2*(k1+k2);    % Correccin
end

