function [t, y] = mieuler(f, t, y0)

% Aplica el mtodo de Euler al PVI  y' = f(t, y) con y'(a) = y0
% t nodos de integracin
% y solucin aproximada


% Clculo del numero de estimaciones
n = length(t);
%Paso de integracin
h = diff(t);
%Nmero de incognitas
m = length(y0);
% Inicializar solucin
y = zeros(n,m); 
y(1,:) = y0;
% Salida: Resto de aproximaciones
for k = 1:n-1
    y(k+1,:) = y(k,:) + h(k)*feval(f, t(k), y(k,:))';
end
