function [t,y]=rungekutta(f,t,y0)

% Aplica el mtodo de Runge-Kutta al PVI  y' = f(t,y) con y'(a) = y0
% t nodos de integracin
% y solucin aproximada


% Clculo del numero de estimaciones
n = length(t);
%Paso de integracin
h = diff(t);
%Nmero de incognitas
m = length(y0);
% Inicializar solucin
y = zeros(n,m); 
y(1,:) = y0;
% Clculo del resto de aproximaciones
for k = 1:n-1
    k1 = feval(f, t(k), y(k,:))';
    k2 = feval(f, t(k) + h(k)/2, y(k,:) + h(k)/2*k1)';
    k3 = feval(f, t(k) + h(k)/2, y(k,:) + h(k)/2*k2)';
    k4 = feval(f, t(k+1), y(k,:) + h(k)*k3)';
    y(k+1,:) = y(k,:) + h(k)/6*(k1 + 2*k2 + 2*k3 + k4);
end
