function dm06

% Captulo 6
% Sistemas de Ecuaciones Lineales

% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

% jlh: nov-2006

% Ventana principal
fondo = [0 0 0];
colortit = [1 0.5 0];
colorcap = [0 0.3 0.9];
colornum = [0.9 0.9 0.9];
c_ejes = fondo; 
figure('Menubar', 'None', ...
    'Color', fondo, ...
    'Units', 'normalized', ...
    'Position', [0.05 0.1 0.9 0.8], ...
    'Numbertitle', 'off', ...
    'Name', 'Captulo 6. Sistemas de Ecuaciones Lineales');

% Plantilla
sep = 0.05;
alto_texto = 0.05;
fil = 3;
col = 4;
fc = fil*col;
ancho_ejes = 1/col - sep;
alto_ejes = 1/fil - sep - alto_texto;
x_ejes = sep/2 : sep + ancho_ejes : 1;
y_ejes = sep/2 : sep + alto_ejes + alto_texto : 1;
y_txt = sep/2 + alto_ejes + alto_texto : sep + alto_ejes + alto_texto : 1;
y_ejes = fliplr(y_ejes);
y_txt = fliplr(y_txt);
[Y_ejes, X_ejes] = meshgrid(y_ejes, x_ejes);
[Y_txt, X_txt] = meshgrid(y_txt, x_ejes);

%====================================

% Ttulos de los problemas
axes(...
    'Color', fondo, ...
    'XColor', fondo, ...
    'YColor', fondo, ...
    'ZColor', fondo, ...
    'Position', [0 0 1 1]);

problema = char(...
    '1. Eliminacin Gaussiana', ... 
    '2. Condicionamiento de sistemas', ... 
    '3. Calor en una placa', ... 
    '4. Matriz de transicin', ... 
    '5. Mtodos iterativos', ... 
    '', ... 
    '', ... 
    '6. Circuito elctrico', ... 
    '7. Matrices dispersas', ... 
    '8. Laplace rectangular', ... 
    '9. Tubo de refrigeracin', ... 
    '10. Laplace en un disco');
txpro = text(X_txt(:), Y_txt(:), problema, ...
    'HorizontalAlignment', 'left', ...
    'VerticalAlignment', 'top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);
txpro(6:7) = [];
set(txpro(1), 'ButtonDownFcn', 'menupcn(6,1,'''',''largetext'')')
for k = 2:10
    set(txpro(k), 'ButtonDownFcn', ['menupcn(6,', num2str(k),')'])
end

%====================================

% Titulo

ejes_pos = [X_ejes(6), Y_ejes(6), ancho_ejes, alto_ejes];
ax1 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

image(imread('prmn.jpg'))
axis equal off

ejes_pos = [X_ejes(7)-sep, Y_ejes(7), ancho_ejes, alto_ejes];
ax0 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

Capitulo = [...
        '    Sistemas de    ';...
        'Ecuaciones Lineales'];

tx1 = text( ...
    'String',Capitulo, ...
    'Position', [0.5,0.5], ...
    'VerticalAlignment','middle', ...
    'HorizontalAlignment','Center', ...
    'FontSize',18, ...
    'FontName','Arial', ...
    'FontWeight','demi', ...
    'Color',colortit);


%====================================

% Problema 6.1
cap = 1;
ax01 = axes;
ejes_pos = [X_ejes(cap), Y_ejes(cap), ancho_ejes, alto_ejes];
enlace01 = ['menupcn(6,1,'''',''largetext'')'];

% Figura 1: 
image(imread('gauss.jpg'))
axis equal off

set(ax01, ...
    'Position', ejes_pos, ...
    'ButtonDownFcn', enlace01);


set(get(ax01, 'Children'), ...
    'ButtonDownFcn', enlace01);

% Fin Problema 6.1
   
%====================================

% Problema 6.2
cap = 2;
ax02 = axes;
enlace02 = ['menupcn(6, 2)'];
ejes_pos = [X_ejes(cap), Y_ejes(cap), ancho_ejes, alto_ejes];

% Figura 2: 
x = 0:0.1:2; y = x;
[X,Y] = meshgrid(x,y);
Z1 = (5.01 - 2.01*X - Y)/2;
Z2 = (7 - 2*X -3*Y)/2;
Z3 = (24 -4*X -16*Y)/4;
surf(X, Y, Z1), hold on
surf(X, Y, Z2)
surf(X, Y, Z3)
view(140, 30)

set(ax02, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace02, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace02);

% Fin Problema 6.2
   
%====================================

% Problema 6.3: 
cap = 3;
ax03 = axes;
enlace03 = ['menupcn(6, 3)'];

% Figura 3: 
m4 = [ 4 -1; -1  4];
m1 = [-1  0;  0 -1];
m0 = [ 0  0;  0  0];
A = [m4 m1 m0; m1 m4 m1; m0 m1 m4];
b = [150 50 50 50 150 50]';
sol = A\b;
P = reshape(sol, 2, 3);
M = [75 100 50 100 75];
M(2:3,:) = [[50; 50] P [50; 50]];
M(4,:) = [25 0 50 0 25];
imagesc(M)
axis equal off

% Ejes

ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax03, ...
    'ButtonDownFcn', enlace03, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace03);

% Fin Problema 6.3
   
%====================================

% Problema 6.4: 
cap = 4;
ax04 = axes;
enlace04 = ['menupcn(6, 4)'];

% Figura 4: 
M = [0.5 0.3 0   0   0
     0.5 0.2 0.3 0   0
     0   0.5 0.2 0.3 0
     0   0   0.5 0.2 0.3
     0   0   0   0.5 0.7];
 
imagesc(M)
axis equal off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax04, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace04, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace04);

% Fin Problema 6.4
   
%====================================

% Problema 6.5: 
cap = 5;
ax05 = axes;
enlace05 = ['menupcn(6, 5)'];

% Figura 5: 
n = 9;
for i = 1:n
    for j = 1:n
        if i <= j
            A(i,j) = i*(n-j+1);
        else
            A(i,j) = A(j,i);
        end
    end
end
b = (1:9)';
M = tril(A);
N = M - A;
x0 = randn(n,1);
x = x0;
incr = 1;
k = 1;
while incr > 0.001 & k < 200
    x(:,k+1) = M\(N*x(:,k) + b);
    incr = norm(x(:,k+1) - x(:,k), inf);
    k = k+1;
end
plot(x')

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax05, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace05);

% Fin Problema 6.5
   
%====================================

% Problema 6.6: 
cap = 8;
ax06 = axes;
enlace06 = ['menupcn(6, 6)'];

% Figura 6: 
image(imread('circuito.jpg'))
axis equal off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax06, ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace06, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace06);

% Fin Problema 6.6
   
%====================================
   

% Problema 6.7: 
cap = 9;
ax07 = axes;
enlace07 = ['menupcn(6, 7)'];

% Figura 7
n = 20; a = 2; b = 1;
v = ones(1,n-1);
A = a*eye(n) + b*diag(v,1) + b*diag(v,-1);

imagesc(A)
axis equal off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax07, ...
    'ButtonDownFcn', enlace07, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace07);

% Fin Problema 6.7

%====================================

% Problema 6.8: 
cap = 10;
ax08 = axes;
enlace08 = ['menupcn(6, 8)'];

% Figura 8: 
n = 3; m = 4; 
A = calor2D(n,m);
spy(A)
hold on
for k = 0 : m : m*n
    plot([0.5 12.5], [k + 0.5, k + 0.5], 'r')
    plot([k + 0.5, k + 0.5], [0.5 12.5], 'r')
end
hold off
axis off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax08, ...
    'Color', colornum, ...
    'ButtonDownFcn', enlace08, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace08);

% Fin Problema 6.8
   
%====================================

% Problema 6.9:
cap = 11;
ax09 = axes;
enlace09 = ['menupcn(6, 9)'];

% Figura 9: 

n = 9; m = 9;
A = -calor2D(n,m);
Tubo = ones(9,9);
Tubo(3:7,3:7) = zeros(5,5);
tubocol = Tubo(:);
elim = find(tubocol==0);
A(elim,:) = [ ];
A(:,elim) = [ ];
C = zeros(11,11);
C(1,:) = 100;       % Cara superior
C(11,:) = 0;        % Base
lin = linspace(100,0,6);
C(1:6,1) = lin';    % Lateral izquierdo
C(1:6,11) = lin';   % Lateral derecho
C(4:8,4:8) = 200;   % Interior del tubo
uno = 1:9;
dos = 2:10;
tres = 3:11;
B = C(uno, dos) + C(dos, uno) + C(dos, tres) + C(tres, dos);
b = B(:);
b(elim) = [ ];
n = length(b);
Tcol = A\b;
[I,J] = find(Tubo);
T = sparse(I, J, Tcol);
C(dos, dos) = T;
C(4:8,4:8) = 200;    % Interior del tubo
[c,h] = contour(C);
axis ij
axis equal
axis ([1 11 1 11])

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax09, ...
    'XTickLabel', [], ...
    'Box', 'off', ...
    'Clipping', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace09, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace09);

% Fin Problema 6.9
   
%====================================

% Problema 6.10: 
cap = 12;
ax10 = axes;
enlace10 = ['menupcn(6, 10)'];

% Figura

n = 4; m = 16; p =n*m;
R = 1;
h = R/(n+1);
r = h:h:1-h;
k = 2*pi/m;
z = k:k:2*pi;
Dp = eye(m);
ds = ones(1,m-1);
Ds = diag(ds,-1) + diag(1,m-1);
Ds = Ds+Ds';
for i=1:n
    Mi = -2*(h^2/r(i)^2+k^2)*Dp + h^2./r(i)^2*Ds;
    I = 1+(i-1)*m:i*m;
    A(I,I) = Mi;
    if i>1
        Ni = k^2*(1-h/2/r(i))*Dp;
        J = 1+(i-2)*m : (i-1)*m;
        A(I,J) = Ni;
    end
    if i<n
        Pi = k^2*(1+h/2/r(i))*Dp;
        J = 1+i*m : (i+1)*m;
        A(I,J) = Pi;
    end
end
b = zeros(p,1);
u1 = sin(2*z);
u1 = flipud(u1');
u0 = mean(u1);
b(p-m+1:p) = -k^2*(1+h/2/r(n))*u1; % Frontera
b(1:m) = -k^2*(1-h/2/r(1))*u0;
sol = A\b;
Tsol = reshape(sol,m,n);
rg = 1 : -h : 0;
zg = 2*pi : -k : 0;
[R, Z] = meshgrid(rg, zg);
X = R.*cos(Z);
Y = R.*sin(Z);
T = [u1 fliplr(Tsol) u0*ones(m,1)];
T = [T; T(1,:)];
pcolor(X,Y,T)
axis equal off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];

set(ax10, ...
    'ButtonDownFcn', enlace10, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace10);

% Fin Problema 6.10
   
%====================================
