function a = convjac(m, n)

% convjac(100, 20)

v = ones(1,n-1);
b = zeros(n,1);
b(1) = 1;
x0 = zeros(n,1);
tol = 1e-4;
plot(0, 2, 'r*', 3,  0, 'b*', 4,  2, 'g*', ...
    [-2 2], [-1 1], 'k:', [-2 2], [1 -1], 'k:')
title('Mtodo de Jacobi')
legend('Diverge', 'Converge', 'Dudoso', '|a| = 2|b|', ...
    'Location', 'SouthOutside')
xlabel('a'), ylabel('b')
grid
hold on
axis equal
axis([-2 2 -1 1])
for k = 1:m
    a(k,:) = 2*rand(1,2) - 1;
    A = 2*a(k,1)*eye(n) - a(k,2)*diag(v,1) - a(k,2)*diag(v,-1);
    M = diag(diag(A));
    N = M - A;
    sol = A\b;
    x = x0;
    incr = tol+1;
    iter = 0;
    while incr > tol & incr <20 & iter < 200
        x = M\(N*x+b);
        incr = norm(x-sol, inf);
        iter = iter+1;
    end
    if incr < tol
        plot(2*a(k,1), a(k,2), '*')
    elseif incr > 20
        plot(2*a(k,1), a(k,2), 'r*')
    else % iter >=50
        plot(2*a(k,1), a(k,2), 'g*')
    end
    drawnow
end
hold off