function A = polapmat(m,n)

% Matriz de la ecuacin de Laplace en un crculo
% con una malla uniforme con mxn nodos

R = 1;
h = R/(n+1);
r = h:h:1-h;
k = 2*pi/m;
z = k:k:2*pi;
Dp = eye(m);
ds = ones(1,m-1);
Ds = diag(ds,-1) + diag(1,m-1);
Ds = Ds+Ds';
for i=1:n
    Mi = -2*(h^2/r(i)^2+k^2)*Dp + h^2./r(i)^2*Ds;
    I = 1+(i-1)*m:i*m;
    A(I,I) = Mi;
    if i>1
        Ni = k^2*(1-h/2/r(i))*Dp;
        J = 1+(i-2)*m : (i-1)*m;
        A(I,J) = Ni;
    end
    if i<n
        Pi = k^2*(1+h/2/r(i))*Dp;
        J = 1+i*m : (i+1)*m;
        A(I,J) = Pi;
    end
end
