function [x, incr, iter] = gseidel(A, b, x0, tol, maxiter)

% Aplica el mtodo de Gauss-Seidel al sistema
%                 Ax = b
% iterando a partir de la estimacin inicial x0,
% hasta que los iterados difieran en norma menos que tol
% o se alcance el mximo de iteraciones, maxiter


% Inicializacin
M = tril(A);
N = M-A;
incr = tol+1;
iter = 0;
% Iteraciones
while incr > tol & iter < maxiter
   x = M\(N*x0+b);
   incr = norm(x-x0, inf);
   x0 = x;
   iter = iter+1;
end
if incr>tol
   disp('No converge con las iteraciones dadas')
   end