function [x, incr, iter] = jacobi(A, b, x0, tol, maxiter)

% Aplica el mtodo de Jacobi al sistema
%                 Ax = b
% iterando a partir de la estimacin inicial x0,
% hasta que los iterados difieran en norma menos que tol
% o se alcance el mximo de iteraciones, maxiter


% Inicializacin
M = diag(diag(A));
N = M-A;
iter = 0;
incr = tol+1;
% Iteraciones
while incr > tol & iter < maxiter
   x = M\(N*x0+b);
   incr = norm(x-x0, inf);
   x0 = x;
   iter = iter+1;
end
if incr > tol
   disp('No converge con las iteraciones dadas')
end