function [x, incr, iter] = sobrerrel(A, b, x0, w, tol, maxiter)

% Aplica el mtodo de sobrerrelajacin al sistema
%                 Ax = b
% iterando a partir de la estimacin inicial x0,
% hasta que los iterados difieran en norma menos que tol
% o se alcance el mximo de iteraciones, maxiter


% Inicializacin
D = diag(diag(A));
L = tril(A,-1);
M = L + D/w;
N = M - A;
iter = 0;
incr = tol+1;

% Iteraciones
while incr > tol & iter < maxiter
	x = M\(N*x0+b);      	% Iteracin de Gauss-Seidel
	incr = norm(x-x0, inf);    	% Distancia entre iterados
	x0 = x;
	iter = iter+1;
end

if incr > tol
   disp('No converge con las iteraciones dadas')
end