function dm07

% Captulo 7
% Interpolacin Polinmica

% Problemas Resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

% jlh: nov-2006

% Ventana principal
fondo = [0 0 0];
colortit = [1 0.5 0];
colorcap = [0 0.3 0.9];
colornum = [0.9 0.9 0.9];
c_ejes = fondo; 
figure('Menubar', 'None', ...
    'Color', fondo, ...
    'Units', 'normalized', ...
    'Position', [0.05 0.1 0.9 0.8], ...
    'Numbertitle', 'off', ...
    'Name', 'Captulo 7. Teora de Aproximacin');

% Plantilla
sep = 0.05;
alto_texto = 0.05;
fil = 3;
col = 4;
fc = fil*col;
ancho_ejes = 1/col - sep;
alto_ejes = 1/fil - sep - alto_texto;
x_ejes = sep/2 : sep + ancho_ejes : 1;
y_ejes = sep/2 : sep + alto_ejes + alto_texto : 1;
y_txt = sep/2 + alto_ejes + alto_texto : sep + alto_ejes + alto_texto : 1;
y_ejes = fliplr(y_ejes);
y_txt = fliplr(y_txt);
[Y_ejes, X_ejes] = meshgrid(y_ejes, x_ejes);
[Y_txt, X_txt] = meshgrid(y_txt, x_ejes);

%====================================

% Ttulos de los problemas
axes(...
    'Color', fondo, ...
    'XColor', fondo, ...
    'YColor', fondo, ...
    'ZColor', fondo, ...
    'Position', [0 0 1 1]);

problema = char(...
    '1. Polinomio mnimo-cuadrtico', ... 
    '2. Estimacin del paro', ... 
    '3. Difusin de una epidemia', ... 
    '4. Factura de luz y gas', ... 
    '5. Aproximacin trigonomtrica', ... 
    '', ... 
    '', ... 
    '6. Previsin meteorolgica', ... 
    '7. Seal sinusoidal', ... 
    '8. Control de calidad', ... 
    '9. Funcin error', ... 
    '10. Densidad del aire');
txpro = text(X_txt(:), Y_txt(:), problema, ...
    'HorizontalAlignment', 'left', ...
    'VerticalAlignment', 'top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);

txpro(6:7) = [];
for k = 1:10
    set(txpro(k), 'ButtonDownFcn', ['menupcn(7,', num2str(k),')'])
end

%====================================

% Titulo
ejes_pos = [X_ejes(6), Y_ejes(6), ancho_ejes, alto_ejes];
ax1 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

image(imread('prmn.jpg'))
axis equal off

ejes_pos = [X_ejes(7)-sep, Y_ejes(7), ancho_ejes, alto_ejes];
ax0 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

Capitulo = [...
        ' Teora de  ';...
        'Aproximacin'];

tx1 = text( ...
    'String',Capitulo, ...
    'Position', [0.5,0.5], ...
    'VerticalAlignment','middle', ...
    'HorizontalAlignment','Center', ...
    'FontSize',18, ...
    'FontName','Arial', ...
    'FontWeight','demi', ...
    'Color',colortit);


%====================================

% Problema 7.1
cap = 1;
ax01 = axes;
ejes_pos = [X_ejes(cap), Y_ejes(cap), ancho_ejes, alto_ejes];
enlace01 = ['menupcn(7, 1)'];

% Figura 1: 
n = [5 10 15 20 25 30 35 40]';
t = [4 10 17 35 42 67 71 85]';
p = polyfit(n, t, 2);
x = linspace(5,40);
y = polyval(p,x);
plot(n, t, 'r*', x, y, 'g')

set(ax01, ...
    'Position', ejes_pos, ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace01);


set(get(ax01, 'Children'), ...
    'ButtonDownFcn', enlace01);

% Fin Problema 7.1
   
%====================================

% Problema 7.2
cap = 2;
ax02 = axes;
enlace02 = ['menupcn(7, 2)'];
ejes_pos = [X_ejes(cap), Y_ejes(cap), ancho_ejes, alto_ejes];

% Figura 2: 
image(imread('paro.jpg'))
axis equal off

set(ax02, ...
    'ButtonDownFcn', enlace02, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace02);

% Fin Problema 7.2
   
%====================================

% Problema 7.3: 
cap = 3;
ax03 = axes;
enlace03 = ['menupcn(7, 3)'];

% Figura 3: 
t = (0 : 7)';
c = [1 7.34 51.82 287.66 748.99 956.61 993.89 999.17]';
td = t - mean(t);
p = polyfit(td, c, 3);
tg = linspace(0, 7);
cg3 = polyval(p, tg - mean(t));
p = polyfit(td, c, 4);
cg4 = polyval(p, tg - mean(t));
p = polyfit(td, c, 5);
cg5 = polyval(p, tg - mean(t));
cn = 1./c;
A = [ones(size(t)) exp(-2*t)];
N = A'*A;
d = A'*cn;
p = N\d;
yg = 1./(p(1) + p(2)*exp(-2*tg));
plot(t, c, '*', tg, [cg3' cg4' cg5'], tg, yg, ':')

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax03, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace03, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace03);

% Fin Problema 7.3
   
%====================================

% Problema 7.4: 
cap = 4;
ax04 = axes;
enlace04 = ['menupcn(7, 4)'];

% Figura 4: 
image(imread('factura.png'))
axis equal off


% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax04, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace04, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace04);

% Fin Problema 7.4
   
%====================================

% Problema 7.5: 
cap = 5;
ax05 = axes;
enlace05 = ['menupcn(7, 5)'];

% Figura 5: 
t = linspace(-pi, pi, 200)';
y = sign(t);
A = [sin(t) sin(3*t) sin(5*t) sin(7*t)];
N = A'*A;
yt = A'*y;
b = N\yt;  
M = A*diag(b);
S = cumsum(M')';
plot(t, y, t, S)

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax05, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace05);

% Fin Problema 7.5
   
%====================================

% Problema 7.6: 
cap = 8;
ax06 = axes;
enlace06 = ['menupcn(7, 6)'];

% Figura 6: 
% t = [6; 8; 10; 12; 14; 16; 18; 20];
% y = [7; 9; 12; 18; 21; 19; 15; 10];
% tg = linspace(6, 20);
% p = polyfit(t,y,4);
% yg = polyval(p, tg);
% plot(t, y, '*', tg, yg)
image(imread('tiempo.jpg'))
axis equal off


% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax06, ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace06, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace06);

% Fin Problema 7.6
   
%====================================
   

% Problema 7.7: 
cap = 9;
ax07 = axes;
enlace07 = ['menupcn(7, 7)'];

% Figura 7
t = (0:1.5:6)';
y = [-0.0713 -2.1641 0.8403 2.2658 -0.5283]';
A = [sin(t) cos(t)];
N = A'*A;
b = A'*y;
sc = N\b;
tg = linspace(0, 2*pi)';
yg = [sin(tg) cos(tg)]*sc;
plot(t, y, 'r*', tg, yg, 'g')

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax07, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace07, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace07);

% Fin Problema 7.7

%====================================

% Problema 7.8: 
cap = 10;
ax08 = axes;
enlace08 = ['menupcn(7, 8)'];

% Figura 8: 
x = (-1:0.2:1)';
y = [4 4 11 10 15 18 16 8 9 2 3]';
bar(x, y)
set(get(gca,'Ch'), 'Facecolor', colortit)

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax08, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace08, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace08);

% Fin Problema 7.8
   
%====================================

% Problema 7.9:
cap = 11;
ax09 = axes;
enlace09 = ['menupcn(7, 9)'];

% Figura 9: 
x = linspace(0,5,200)';
y = erf(x);
p = polyfit(x,y,3);
yp = polyval(p,x);
plot(x,y,x,yp,'r')

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax09, ...
    'XTickLabel', [], ...
    'Box', 'off', ...
    'Clipping', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace09, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace09);

% Fin Problema 7.9
   
%====================================

% Problema 7.10: 
cap = 12;
ax10 = axes;
enlace10 = ['menupcn(7, 10)'];

% Figura
h = [7 10 15 21 27 34 39 43 47 51 55 59 61];
r = [556 369 191 75 26.2 9.9 4.4 2.3 1.4 0.8 0.5 0.33 0.25];
p = polyfit(h,r,4);
hg = linspace(5,65);
rg = polyval(p,hg);
plot(h,r,'r*',hg,rg,'g')

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];

set(ax10, ...
    'ButtonDownFcn', enlace10, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace10);

% Fin Problema 7.10
   
%====================================
