%% 7.4. Factura de luz y gas
% 
% En este problema estimamos por mnimos cuadrados los parmetros de un
% modelo lineal en dos variables.
%
%
% Tema 7, Problema 4
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%% 
%
% El total T de la factura depende del consumo de electricidad, L y del
% consumo de gas, G. Representamos los datos en 3D.

L = [576 512 496 599 495 572]';
G = [ 240 202 175 159 203 237]';
T = [95.02 87.09 84.30 93.47 85.50 94.49 ]'

plot3(L, G, T, 'k*')
axis([450 600 150 250 80 100])
title('Factura de la energa')
xlabel('Consumo elctrico (Kwh)')
ylabel('Consumo de gas (Kwh)')
zlabel('Importe')
grid


%%
%
% El importe viene dado por la expresin
%
% T = a + bL + cG + 0,16(a + bL + cG) = 1,16(a + bL + cG)
%
% Determinamos los coeficientes a, b y c por mnimos cuadrados y
% representamos la funcin resultante.

A = 1.16*[ones(size(L)) L G]
N = A'*A;
c = A'*T;
p = N\c

disp(['Trmino fijo: ', num2str(p(1))])
disp(['Precio del Kwh de luz: ', num2str(p(2))])
disp(['Precio del Kwh de gas: ', num2str(p(3))])

x = linspace(min(L), max(L), 10);
y = linspace(min(G), max(G), 10);
[X, Y] = meshgrid(x, y);
Z = 1.16*(p(1) + p(2)*X + p(3)*Y);
hold on
surf(X, Y, Z)
title('Ajuste mnimo-cuadrtico')


%%
%
% Podemos estimar el importe de un factura cualquiera en funcin de los
% consumos. Por ejemplo, una factura de 500 Kwh de luz y 188 Kwh de gas
% costar:

T = 1.16*dot([1 500 188],p)

plot3(500, 188, T, 'r*')
hold off


%%
%
% FIN del Problema 7.4