%% 7.6. Previsin meteorolgica
% 
% En este problema obtenemos por diversos mtodos el polinomio que ajusta
% por mnimos cuadrados las temperaturas registradas a lo largo de un da.
%
%
% Tema 7, Problema 6
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%% 
%
% Introducimos los datos en columna y normalizamos las abscisas para que
% tengan media 0 y desviacin tpica 1.

t = [6; 8; 10; 12; 14; 16; 18; 20];
y = [7; 9; 12; 18; 21; 19; 15; 10];
m = mean(t);
s = std(t);
x = (t-m)/s;

plot(t, y, '*')
title('Temperaturas diurnas')
xlabel('Hora')
ylabel('Temperatura')
grid


%%
%
% Obtendremos por diversos procedimientos los coeficientes del polinomio
% de grado 4 que mejor aproxima los datos por mnimos cuadrados.


%%
%
% a) Al imponer que p(xi) = yi, i = 1, 2, . . . , 8, se obtiene el sistema
% sobredeterminado Ap = y cuya matriz es:

A = [x.^4 x.^3 x.^2 x x.^0]


%%
%
% Formamos las ecuaciones normales:

N = A'*A
c = A'*y


%%
% 
% Resolvemos las ecuaciones normales para obtener los coeficientes del
% polinomio mnimo-cuadrtico.

p = N\c


%%
%
% Para evaluar el polinomio mnimo-cuadrtico obtenido previa
% normalizacin, hay que aplicar la misma nomalizacin a las abscisas
% originales.

tg = linspace(6, 20);
xg = (tg - m)/s;
yg = polyval(p, xg);
plot(t, y, '*', tg, yg)
title('Polinomio mnimo-cuadrtico de grado 4')
xlabel('Hora')
ylabel('Temperatura')
grid


%%
%
% b) Obtenemos la factorizacin QR de A mediante nuestra funcin miqr.

[Q,R] = miqr(A)

type miqr


%%
%
% La solucin mnimo cuadrtica del sistema sobredeterminado Ap = y se
% obtiene resolviendo el sistema triangular Rp = Q'y.

pb = R\(Q'*y)


%%
%
% c) Factorizamos ahora A por el algoritmo qr de MATLAB:

[Q,R] = qr(A,0)


%%
%
% y la solucin se obtiene como antes:

pc = R\(Q'*y)


%%
%
% d) Aplicando la contrabarra al sistema Ap = y, se obtiene el mismo
% polinomio:

pd = A\y


%%
%
% e) Obtenemos ahora el polinomio directamente con polyfit:

pe = polyfit(x,y,4)


%%
%
% Comprobamos que, con una precisin de 6 decimales, el resultado es
% siempre el mismo. Los apartados c) y e) dan exactamente el mismo
% resultado, pues polyfit aplica la factorizacin QR a la matriz del
% sistema. Las diferencias de valores entre los polinomios de los distintos
% apartados son del orden de 10-14.


%%
%
% FIN del Problema 7.6