%% 7.7. Seal sinusoidal
% 
% En este problema se estima la amplitud y la fase de una seal sinusoidal
% mediante linealizacin del modelo y ajuste por mnimos cuadrados.
%
%
% Tema 7, Problema 7
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%% 
%
% Representamos los valores conocidos de una seal sinusoidal.
% Traramos de determinar F y fi en la frmula
%               y = F sen(t+fi)

t = (0:1.5:6)';
y = [-0.0713 -2.1641 0.8403 2.2658 -0.5283]';

plot(t, y, '*')
title('Seal sinusoidal')
grid


%%
%
% Determinamos los parmetros c y s del modelo linealizado 
%               y = c sen(t)+ s cos(t), 
% resolviendo por mnimos cuadrados el sistema obtenido al sustituir cada
% par de datos (tk, yk) en el modelo. La matriz del sistema es:

A = [sin(t) cos(t)]


%%
%
% Resolvemos las ecuaciones normales y representamos el ajuste.

N = A'*A;
b = A'*y;
sc = N\b

tg = linspace(0, 2*pi)';
yg = [sin(tg) cos(tg)]*sc;
plot(t, y, '*', tg, yg)
title('Ajuste mnimo-cuadrtico de la seal sinusoidal')
grid


%%
%
% Evaluamos el resultado en los datos y calculamos el error cuadrtico.

yp = A*sc;
E2 = norm(y-yp)^2


%%
%
% Deshacemos el cambio de variables para obtener la amplitud y la fase de
% la seal. 

K = norm(sc)
fi = atan2(sc(2),sc(1))


%%
%
% FIN del Problema 7.7