%% 7.9.  Funcin error.
%
% En este problema se proponen distintos ajustes mnimo cuadrticos para la
% funcin error, definida en Matlab mediante el comando erf. Se comparan los
% resultados hallando la diferencia mxima entre la funcin y el ajuste
% obtenido as como obteniendo el indice de determinacin en cada caso.
% 
%
%
% Tema 7, Problema 9.
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson


%% 
%
% Generamos las abscisas en [0,5], evaluamos en ellas la funcin de error y
% hallamos el polinomio mnimo cuadrtico de grado 3, representndolo junto
% a la funcin.
x = linspace(0,5,200)';
y = erf(x);
p = polyfit(x,y,3)
yp = polyval(p,x);
plot(x,y,x,yp)
%%
%
% Hallamos la mxima diferencia entre las ordenadas de la funcin y las del
% polinomio que la ajusta, y obtenemos el ndice de determinacin.

max(abs(y-yp))
ym = mean(y);
ind = (norm(yp-ym)/norm(y-ym))^2  
%%
%
% Al imponer que se verifique el modelo
% q(x)=e^{-x^{2}}(c_{1}x^{2}+c_{2}x+c_{3})+c_{4}
% se obtiene un sistema de ecuaciones lineales con matriz de coeficientes:
ex2 = exp(-x.^2);
A = [x.^2.*ex2  x.*ex2  ex2  x.^0]
%%
%
% Obtenemos los coeficientes, as como la representacin de este ajuste
% exponencial.
q = A\y
yq = ex2.*polyval(q(1:end-1),x) + q(end);
plot(x,y,x,yp,x,yq)
legend('funcin error', 'polinomio', 'ajuste exponencial')
%%
%
% Claramente en la grfica se observa la mejora del ajuste, veamos como
% disminuye la mxima diferencia entre las ordenadas, y se produce un
% aumento del ndice de determinacin. En particular, los polinomios no
% estn acotados cuando x crece, mientras que la funcin propuesta q(x)
% tiene una asntota horizontal, al igual que la funcin dada.

yq = ex2.*polyval(q(1:end-1),x) + q(end);
e = max(abs(y-yq))
ind = (norm(yq-ym)/norm(y-ym))^2
%%
%
% FIN del Problema 7.9