function dm08

% Captulo 8
% Sistemas de Ecuaciones no Lineales

% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

% jlh: nov-2006

% Ventana principal
fondo = [0 0 0];
colortit = [1 0.5 0];
colorcap = [0 0.3 0.9];
colornum = [0.9 0.9 0.9];
colortitle = [0.9 0.9 0.9];   
c_ejes = fondo; 
figure('Menubar', 'None', ...
    'Color', fondo, ...
    'Units', 'normalized', ...
    'Position', [0.05 0.1 0.9 0.8], ...
    'Numbertitle', 'off', ...
    'Name', 'Captulo 8. Sistemas de Ecuaciones no Lineales');

% Plantilla
sep = 0.05;
alto_texto = 0.05;
fil = 3;
col = 4;
fc = fil*col;
ancho_ejes = 1/col - sep;
alto_ejes = 1/fil - sep - alto_texto;
x_ejes = sep/2 : sep + ancho_ejes : 1;
y_ejes = sep/2 : sep + alto_ejes + alto_texto : 1;
y_txt = sep/2 + alto_ejes + alto_texto : sep + alto_ejes + alto_texto : 1;
y_ejes = fliplr(y_ejes);
y_txt = fliplr(y_txt);
[Y_ejes, X_ejes] = meshgrid(y_ejes, x_ejes);
[Y_txt, X_txt] = meshgrid(y_txt, x_ejes);

%====================================

% Ttulos de los problemas
axes(...
    'Color', fondo, ...
    'XColor', fondo, ...
    'YColor', fondo, ...
    'ZColor', fondo, ...
    'Position', [0 0 1 1]);

problema = char(...
    '1. Elipse y parbola', ... 
    '2. Curvas no continuas', ... 
    '3. Sistema con tres ecuaciones', ... 
    '4. Newton y Broyden', ... 
    '5. Maximizar beneficios', ... 
    '', ... 
    '', ... 
    '6. Aproximacin de datos', ... 
    '7. Distancia entre dos curvas', ... 
    '8. Ecuacin integral', ... 
    '9. Puntos crticos', ... 
    '10. Optimizacin con restricciones');
txpro = text(X_txt(:), Y_txt(:), problema, ...
    'HorizontalAlignment', 'left', ...
    'VerticalAlignment', 'top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);
txpro(6:7) = [];
set(txpro(10), 'String', ...
    char('10. Optimizacin', '    con restricciones'))
for k = 1:10
    set(txpro(k), 'ButtonDownFcn', ['menupcn(8,', num2str(k),')'])
end

%====================================

% Titulo

ejes_pos = [X_ejes(6), Y_ejes(6), ancho_ejes, alto_ejes];
ax1 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

image(imread('prmn.jpg'))
axis equal off

ejes_pos = [X_ejes(7)-sep, Y_ejes(7), ancho_ejes, alto_ejes];
ax0 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

Capitulo = [...
        'Sistemas de Ecuaciones';...
        '      no Lineales     '];

tx1 = text( ...
    'String',Capitulo, ...
    'Position', [0.5,0.5], ...
    'VerticalAlignment','middle', ...
    'HorizontalAlignment','Center', ...
    'FontSize',18, ...
    'FontName','Arial', ...
    'FontWeight','demi', ...
    'Color',colortit);

%====================================

% Problema 8.1
cap = 1;
ax01 = axes;
ejes_pos = [X_ejes(cap), Y_ejes(cap), ancho_ejes, alto_ejes];
enlace01 = ['menupcn(8, 1)'];

% Figura 1: 
xg = linspace(-1,3);
yg = xg.^2 - 2*xg + 0.5;
plot(xg, yg, 'Color', 'red')
hold on
ezplot('y^2 + x.^2/4 - 1')
h=get(gca,'Ch');
set(h(1),'Color',[0 .8 0])
title('')
axis([-3 3 -3 3])


set(ax01, ...
    'Position', ejes_pos, ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace01);


set(get(ax01, 'Children'), ...
    'ButtonDownFcn', enlace01);

% Fin Problema 8.1
   
%====================================

% Problema 8.2
cap = 2;
ax02 = axes;
enlace02 = ['menupcn(8, 2)'];
ejes_pos = [X_ejes(cap), Y_ejes(cap), ancho_ejes, alto_ejes];

% Figura 2: 
ezplot('asin(exp(x^2)/(8*x))')
title('')
h=get(gca,'Ch');
set(h(1),'Color','red')
hold on
plot([-1.8, 1.8], [2.8, -0.8], 'Color', [0 .8 0])


set(ax02, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace02, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace02);

% Fin Problema 8.2
   
%====================================

% Problema 8.3: 
cap = 3;
ax03 = axes;
enlace03 = ['menupcn(8, 3)'];

% Figura 3: 
t = -1:0.1:1;
y = t; z = t;
[Y, Z] = meshgrid(y, z);
X = (cos(Y.*Z) + 0.5)/3;
surf(X, Y, Z)
hold on
x = t; z = t;
[X, Z] = meshgrid(x, z);
Y = X/25;
surf(X, Y, Z)
x = t; y = t;
[X, Y] = meshgrid(x, y);
Z = (1-exp(-X.*Y))/20 - pi/6;
surf(X, Y, Z)

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax03, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace03, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace03);

% Fin Problema 8.3
   
%====================================

% Problema 8.4: 
cap = 4;
enlace04 = ['menupcn(8, 4)'];

% Figura 4: 
[sol, iter, M] = Broyden('funcion',[2,3,4],1e-12,50);
for i = 1:iter-1
    conv(i) = norm(M(i+1,:)-M(i,:));
end
tcl = conv(2:end)./conv(1:end-1);
tcc=conv(2:end)./conv(1:end-1).^2;

ax04a = axes;
plot(tcl, '.-', 'Color', [0 0.8 0])
title('T. C. lineal', 'Color', colortit)
set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace04);

ax04b = axes;
plot(tcc(1:end-2),'r.-')
title('T. C. cuadrtica', 'Color', colortit)
set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace04);

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes/3];
set(ax04a, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace04, ...
    'Position', ejes_pos + [0 alto_ejes/2 0 0])

set(ax04b, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace04, ...
    'Position', ejes_pos)


% Fin Problema 8.4
   
%====================================

% Problema 8.5: 
cap = 5;
ax05 = axes;
enlace05 = ['menupcn(8, 5)'];

% Figura 5: 
image(imread('beneficios.jpg'))
axis equal off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax05, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace05);

% Fin Problema 8.5
   
%====================================

% Problema 8.6: 
cap = 8;
ax06 = axes;
enlace06 = ['menupcn(8, 6)'];

% Figura 6: 
t = 0:0.5:3;
d = [1.095 -0.1569 -1.0157 -1.474 -1.3616 -0.8342 -0.0135];
x = 0:0.01:3;   y = exp(-0.429530*x)-1.984219*sin(x);
plot(t,d,'*',x,y)


% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax06, ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace06, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace06);

% Fin Problema 8.6
   
%====================================
   

% Problema 8.7: 
cap = 9;
ax07 = axes;
enlace07 = ['menupcn(8, 7)'];

% Figura 7
x = -3:0.1:6;
y1 = x.^2; y2 = x-5;
p = 0.5; q = p^2 ;
u = 2.875; v = u-5;
plot(x, [y1', y2'], p, q, 'y*', u, v, 'y*', [p u], [q v], 'r:')
axis equal
axis([-5 5 -5 5])

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax07, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace07, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace07);

% Fin Problema 8.7

%====================================

% Problema 8.8: 
cap = 10;
ax08 = axes;
enlace08 = ['menupcn(8, 8)'];

% Figura 8: 
text(0.5, 0.5, 'e^{2} u(x) = 1 + (2+x) \int_0^1 e^{xt} u^2(t) dt', ...
    'HorizontalAlignment', 'Center', ...
    'Color', colortit, ...
    'Fontweight', 'demi', ...
    'FontSize', 11)

% Ejes
ejes_pos = [X_ejes(cap)-sep/2 Y_ejes(cap) ancho_ejes alto_ejes];
set(ax08, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace08, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace08);

% Fin Problema 8.8
   
%====================================

% Problema 8.9:
cap = 11;
ax09 = axes;
enlace09 = ['menupcn(8, 9)'];

% Figura 9: 
x = 0:pi/10:2*pi; y = x;
[X,Y] = meshgrid(x,y);
Z = cos(X+Y)+sin(X)+cos(Y);
surf(x,y,Z)
axis off

% Ejes
ejes_pos = [X_ejes(cap)-sep Y_ejes(cap)-sep ancho_ejes+2*sep alto_ejes+2*sep];
set(ax09, ...
    'ButtonDownFcn', enlace09, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace09);

% Fin Problema 8.9
   
%====================================

% Problema 8.10: 
cap = 12;
ax10 = axes;
enlace10 = ['menupcn(8, 10)'];

% Figura
t = 0.05 : 0.05 : 1.2; 
[x,y] = meshgrid(t,t);
z = (1-x.*y)./(x+y);
C = x.*y.*z;
surf(x,y,z,C.^1.5)
axis([0, 1.2, 0, 1.2, -0.2, 10])
view(125,30)
axis off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];

set(ax10, ...
    'ButtonDownFcn', enlace10, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace10);

% Fin Problema 8.10


%=============================================================
%funciones auxiliares   
%====================================
function [x, iter,M] = Broyden(F,x0,tol,maxiter)
[Fx,dFx] = feval(F,x0);
v = Fx(:);                           % v es F(x0) en columna
A = inv(dFx);                        % inversa del Jacobiano
s = -A*v;
x = x0' + s;   
M = x';                               % paso de Newton
incr = norm(s);     iter = 1;
while incr > tol & iter < maxiter
    w = v;                          % F(x(k-1))
    Fx = feval(F,x);                 % F(x(k))
    v = Fx(:);
    y = v-w;                        % F(x(k)) - F(x(k-1))
    z = -A*y;                       % -inv(A(k-1))*y(k)
    p = -s'*z;                      % s(k)'*inv(A(k-1))*y(k)
    q = s'*A;                       % s(k)'*inv(A(k-1)
    R = (s + z)*q/p;
    A = A + R;                      % actualizaci\'on de la inversa
    s = -A*v;
    x = x + s;                      % actualizaci\'on del iterado
    M = [M;x'];
    incr = norm(s);
    iter = iter + 1;
end
if incr > tol
    disp('Se necesitan mas iteraciones')
end

%======================================
function [y,dy] = funcion(x)
 y(1) = sin(x(1))+x(2)^2+log(x(3))-7;
 y(2) = 3*x(1)+2^x(2)-x(3)^(-3)+1;
 y(3) = x(1)+x(2)+x(3)-5;
if nargout==2
  dy = ones(3,3);
  dy(1,:) = [cos(x(1)) 2*x(2) 1/x(3)];
  dy(2,:) = [3 log(2)*(2^x(2)) 3*x(3)^(-4)];
end