function [x0, iter,x] = pfijo2(g,x0,tol,maxiter)

% [x, incr, iter] = pfijo(g,x0,tol,maxiter,tipo)
% Resuelve la ecuacin de punto fijo  x = g(x),
% siendo g una funcin vectorial de varias variables
% iterando a partir de x0 hasta que la variacin sea
% menor que tol o se supere el mximo de iteraciones
%

% Ejemplo: pfijo('cos',0,0.01,10)
% Ejemplo: pfijo('fsim',[1 1 1],1e-9,100)

% Modificado: jlh, feb 2000

iter=0;
x=x0;conv=[];
incr=tol+1;
while incr>tol & iter<maxiter
	xn=feval(g,x0);
	incr=norm(xn-x0);
	x=[x;xn];conv=[conv,incr];
	%pause
	iter=iter+1;
	x0=xn;
end
if incr>tol
	disp('Insuficientes iteraciones')
end

plot(x),title('Punto fijo')
pause
dc=conv(2:iter)./conv(1:iter-1);
plot(dc),title('Tasa de convergencia')
pause