function [x, incr, iter] = newton1(f,x0,tol,maxiter)

% [x, incr, iter] = newton(f,x0,tol,maxiter)
%
% Resuelve la ecuacin f(x)=0,
% siendo f una funcin vectorial de varias variables
% iterando por el mtodo de Newton a partir de x0 
% hasta que la variacin sea menor que tol 
% o se supere el mximo de iteraciones.
%
% El fichero f.m devuelve el valor de la funcin f(x)
% y el de su matriz de Jacobi en x, Df(x).
%


iter=0;
x=x0;
incr=tol+1;
while incr>tol & iter<maxiter
	iter=iter+1;
	[fx,dfx]=feval(f,x0);
	d=-dfx\fx';
	xn=x0+d';
   incr=norm(d);
   Inc(iter)=incr;
	x=[x;xn];
	%pause
  	x0=xn;
end
cont=1:iter-1;
vcl=Inc(cont+1)./Inc(cont);		% estudio de la veloc. de convergencia (lineal)
%plot(vcl),title('conv. lineal')
subplot(2,2,1), plot(vcl),title('conv. lineal')
%pause
vcc=Inc(cont+1)./Inc(cont).^2;		% estudio de la veloc. de convergencia
%plot(vcc),title('conv. cuadrtica')
subplot(2,2,2), plot(vcc),title('conv. cuadrtica')
%pause

%plot(x),title('Mtodo de Newton')
subplot(2,2,3), plot(x),title('Mtodo de Newton')
