function [x,iter,A] = puntofijo(G,x0,tol,maxiter)
% G: nombre del archivo .m donde se define la funci\'on
% x0: estimaci\'on inicial de la soluci\'on
% tol: tolerancia en el criterio de convergencia
% maxiter: n\'umero m\'aximo de iteraciones

incr = tol + 1;     iter = 1;           % inicializaci\'on
A = [x0];
while (incr > tol) & (iter < maxiter)
   x = feval(G,x0);
   A = [A;x];
   incr = norm(x-x0);
   iter = iter+1;
   x0 = x;
end
if incr > tol
    disp('Se necesitan mas iteraciones')
end
