function [x, incr, iter,A] = Newton(funcion,x0,tol,maxiter)
% funcion: nombre del archivo .m donde se define la funci\'on
%          vectorial F y su matriz  jacobiana
% x0: estimaci\'on inicial de la soluci\'on
% tol: tolerancia en el criterio de convergencia
% maxiter: n\'umero m\'aximo de iteraciones
A = [x0];
incr = tol+1;   iter = 0;
while incr > tol & iter < maxiter
    iter = iter+1;
    [F,dF] = feval(funcion,x0);
    F = F(:);
    z = - dF\F;
    x = x0 + z';
    A = [A;x];
    incr = norm(z);
    x0 = x;
end
if incr > tol
    disp('Se necesitan mas iteraciones')
end
