%% 8.3. Sistema no lineal con tres ecuaciones
% 
% Dado un sistema no lineal de ecuaciones, para estimar su solucin se aplican
% los mtodos de punto fijo (desplazamientos sucesivos y simultneos), Newton y la 
% variante del mtodo de Newton que actualiza peridicamente la matriz jacobiana.
% 
% Tema 8, Problema 3
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

%% 
%
% a) Transformamos el sistema despejando la variable x de la primera 
% ecuacin, la y de la segunda y la z de la tercera.
%
% Definimos la funcin G(x,y,z) que describe el sistema de punto fijo
% en el fichero funcion1.m.  
%
% function y = funcion1(x,tipo)
% Si tipo = 1 se aplican desplazamientos simultneos
% Si tipo = 2 se aplican desplazamientos sucesivos;
%  if tipo == 1
%    y(1) = (1/3)*(cos(x(2)*x(3))+0.5);
%    y(2) = (1/25)*x(1);
%    y(3) = (-1/20)*exp(-x(1)*x(2))-(pi/6)+(1/20);
% elseif tipo == 2
%    y(1) = (1/3)*(cos(x(2)*x(3))+0.5);
%    y(2) = (1/25)*y(1);
%    y(3) = (-1/20)*exp(-y(1)*y(2))-(pi/6)+(1/20);
% end
%
% Aadimos adems la variable 'tipo' como parmetro de entrada de la
% funcin puntofijo, resultando el fichero de funcin puntofijot.m.

%%
% Ejecutaremos puntofijot primero para desplazamientos simultneos

  [sol,iter,A] = puntofijot('funcion1',[0,0,0],1e-7,50,1)


%%
% y posteriormente para desplazamientos sucesivos

  [sol,iter,A] = puntofijot('funcion1',[0,0,0],1e-7,50,2)


%%
%
% b) Construimos el archivo funcion2.m en el que definimos
% la funcin F que describe el sistema inicial y su matriz jacobiana.
%
% Si llamamos a la funcin Newton,obtenemos un mensaje de error provocado 
% por la singularidad de la matriz jacobiana en la iteracin inicial. 

  [sol,incr,iter,A] = Newton('funcion2',[0,0,0],1e-7,50)


%%
% Cambiando la aproximacin inicial, obtenemos una solucin aproximada.

  [sol,incr,iter,A] = Newton('funcion2',[0.5,0.5,0.5],1e-7,50),


%%
% A continuacin podemos observar la representacin grfica
% de la tasa de convergencia cuadrtica 

for i=1:iter
       conv1(i)=norm(A(i+1,:)-A(i,:));
end
tcc = conv1(2:end)./conv1(1:end-1).^2;
plot(tcc)


%%
% y la grfica de las coordenadas de los distintos iterados.

  plot(A)
 

%%
% Si tomamos como aproximacin inicial (-0.5, -0.5, -0.5) obtenemos
% la aproximacin a una nueva raz.

  [sol,incr,iter,A] = Newton('funcion2',[-0.5,-0.5,-0.5],1e-7,50),


%%
% c) Construimos un fichero, Newtonmod.m, que contiene la variante del mtodo 
% de Newton consistente en actualizar la jacobiana tras un nmero fijo de iteraciones, 
% que denotaremos por 'per' y  formar parte de los parmetros de entrada. 
% Llamamos a esta funcin con actualizacin de la jacobiana cada dos iteraciones:

  [sol,iter] = Newtonmod('funcion2',[0.5,0.5,0.5],1e-7,50,2)


%%
% Repetimos el proceso con per = 5:

  [sol,iter] = Newtonmod('funcion2',[0.5,0.5,0.5],1e-7,50,5)


%%
% Para encontrar la otra solucin cambiamos de estimacin inicial:

  [sol,iter] = Newtonmod('funcion2',[-0.5,-0.5,-0.5],1e-7,50,2)


%%
% FIN del Problema 8.3