function [x, iter,M] = Broyden(F,x0,tol,maxiter)
[Fx,dFx] = feval(F,x0);
v = Fx(:);                           % v es F(x0) en columna
A = inv(dFx);                        % inversa del Jacobiano
s = -A*v;
x = x0' + s;   
M = x';                               % paso de Newton
incr = norm(s);     iter = 1;
while incr > tol & iter < maxiter
    w = v;                          % F(x(k-1))
    Fx = feval(F,x);                 % F(x(k))
    v = Fx(:);
    y = v-w;                        % F(x(k)) - F(x(k-1))
    z = -A*y;                       % -inv(A(k-1))*y(k)
    p = -s'*z;                      % s(k)'*inv(A(k-1))*y(k)
    q = s'*A;                       % s(k)'*inv(A(k-1)
    R = (s + z)*q/p;
    A = A + R;                      % actualizaci\'on de la inversa
    s = -A*v;
    x = x + s;                      % actualizaci\'on del iterado
    M = [M;x'];
    incr = norm(s);
    iter = iter + 1;
end
if incr > tol
    disp('Se necesitan mas iteraciones')
end
