%% 8.4. Newton y Broyden en un sistema no lineal con tres ecuaciones
% 
% Dado un sistema no lineal de ecuaciones, para estimar su solucin se
% aplican los mtodos de Newton, Broyden y Newton unidimensional.
% 
% Tema 8, Problema 4
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

%% 
%
% a) Construimos el archivo que contiene la funcin que describe el sistema
% y su matriz jacobiana. 
%
% function [y,dy] = funcion(x)
%   y(1) = sin(x(1))+x(2)^2+log(x(3))-7;
%   y(2) = 3*x(1)+2^x(2)-x(3)^(-3)+1;
%   y(3) = x(1)+x(2)+x(3)-5;
% if nargout==2
%   dy = ones(3,3);
%   dy(1,:) = [cos(x(1)) 2*x(2) 1/x(3)];
%   dy(2,:) = [3 log(2)*(2^x(2)) 3*x(3)^(-4)];
% end


%%
% Llamamos a la funcin Newton.m con estimacin inicial (2,3,4):

  [x1, incr1, iter1, A1] = Newton('funcion',[2,3,4],1e-7,50)


%%
% partiendo del iterado (2,3,0.5):

  [x2, incr2, iter2, A2] = Newton('funcion',[2,3,0.5],1e-7,50)


%%
% y tambin de (-2,-3,0.5)

  [x3, incr3, iter3, A3] = Newton('funcion',[-2,-3,0.5],1e-7,50)



%%
% o de (-2,-3,4):

  [x4, incr4, iter4, A4] = Newton('funcion',[-2,-3,4],1e-7,50)


%%
% b) Para obtener aproximaciones a las soluciones del sistema no lineal aplicando 
% el mtodo de Broyden, llamamos a la funcin Broyden.m con los siguientes 
% parmetros de entrada:

  [sol, iter] = Broyden('funcion',[2,3,4],1e-7,50)



%%
% Para estudiar el comportamiento de la tasa de convergencia lineal, modificamos 
% el algoritmo de Broyden de manera que se almacenen los diferentes iterados en 
% una matriz M. As las siguientes instrucciones nos proporcionan las tasas de 
% convergencia lineal,

  [sol, iter, M] = Broyden('funcion',[2,3,4],1e-7,50);
  for i = 1:iter-1
      conv(i) = norm(M(i+1,:)-M(i,:));
  end
  tcl = conv(2:end)./conv(1:end-1);
  tcl(end)
  plot(tcl)


%%
% superlineal 

  tcsl=conv(2:end)./conv(1:end-1).^(1.618);
  tcsl(end)
  plot(tcsl)


%%
% y cuadrtica del mtodo de Broyden para este caso concreto.

  tcc=conv(2:end)./conv(1:end-1).^2;
  tcc(end)
  plot(tcc)


%%
% Tomemos ahora las aproximaciones iniciales utilizadas en el apartado a),

  [sol2,iter2,M2] = Broyden('funcion',[2,3,0.5],1e-7,50)


%%

  [sol3,iter3,M3] = Broyden('funcion',[-2,-3,0.5],1e-7,50)


%%

  [sol4,iter4,M4] = Broyden('funcion',[-2,-3,4],1e-7,50)


%%
% c) Para aplicar el mtodo iterativo de Newton unidimensional 
% definimos la funcin:
%
% function y = fnewuni(x)
% f1 = sin(x(1))+x(2)^2+log(x(3))-7;  df1 = cos(x(1));
% y(1) = x(1)-f1/df1;
%
% f2 = 3*y(1)+2^x(2)-x(3)^(-3)+1;     df2 = log(2)*(2^x(2));
% y(2) = x(2)-f2/df2;
%
% f3 = y(1)+y(2)+x(3)-5;              df3 = 1;
% y(3) = x(3)-f3/df3;


%%
% Llamamos a la funcin puntofijo.m con la primera aproximacin inicial
% utilizada en los apartados anteriores, aumentando el nmero mximo 
% de iteraciones. Observamos que el mtodo es divergente. Este hecho se repite para cualquier
% aproximacin inicial que tomemos.


  [sol,iter] = puntofijo('fnewuni',[2,3,4],1e-7,100),


%%
% FIN del Problema 8.4
