function [x, iter,M] = Broyden2(funcion, x0, x1, tol, maxiter)
x0 = x0(:);   x = x1(:);   s = x-x0;      M = [x0';x'];
fx = feval(funcion,x0);    v = fx(:);
fx = feval(funcion,x);     w = fx(:);     y = w-v;
A = diag(s./y);
incr = norm(s); iter = 1;
while incr > tol & iter < maxiter
    w = v;
    fx = feval(funcion,x);    v = fx(:);  y = v-w;
    z = -A*y;     p = -s'*z;  q = s'*A;
    R = (s+z)*q/p;
    A = A+R;      s = -A*v;
    x = x+s;      M = [M;x'];
    incr = norm(s);       iter = iter+1;
end
