function dm09

% Captulo 9
% Problemas de Frontera

% Problemas Resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

% jlh: nov-2006

% Ventana principal
fondo = [0 0 0];
colortit = [1 0.5 0];
colorcap = [0 0.3 0.9];
colornum = [0.9 0.9 0.9];
c_ejes = fondo; 
figure('Menubar', 'None', ...
    'Color', fondo, ...
    'Units', 'normalized', ...
    'Position', [0.05 0.1 0.9 0.8], ...
    'Numbertitle', 'off', ...
    'Name', 'Captulo 9. Problemas de Frontera');

% Plantilla
sep = 0.05;
alto_texto = 0.05;
fil = 3;
col = 4;
fc = fil*col;
ancho_ejes = 1/col - sep;
alto_ejes = 1/fil - sep - alto_texto;
x_ejes = sep/2 : sep + ancho_ejes : 1;
y_ejes = sep/2 : sep + alto_ejes + alto_texto : 1;
y_txt = sep/2 + alto_ejes + alto_texto : sep + alto_ejes + alto_texto : 1;
y_ejes = fliplr(y_ejes);
y_txt = fliplr(y_txt);
[Y_ejes, X_ejes] = meshgrid(y_ejes, x_ejes);
[Y_txt, X_txt] = meshgrid(y_txt, x_ejes);

%====================================

% Ttulos de los problemas
axes(...
    'Color', fondo, ...
    'XColor', fondo, ...
    'YColor', fondo, ...
    'ZColor', fondo, ...
    'Position', [0 0 1 1]);

problema = char(...
    '1. Potencial electrosttico', ... 
    '2. Condiciones Dirichlet', ... 
    '3. Ecuacin de Euler', ... 
    '4. Condiciones mixtas', ... 
    '5. Temperatura en un anillo', ... 
    '', ... 
    '', ... 
    '6. Problema difcil', ... 
    '7. Mtodo de Rayleigh-Ritz', ... 
    '8. Elementos finitos trigonomtricos', ... 
    '9. Muchos subintervalos', ... 
    '10. Disparo hacia atrs');
txpro = text(X_txt(:), Y_txt(:), problema, ...
    'HorizontalAlignment', 'left', ...
    'VerticalAlignment', 'top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);
txpro(6:7) = [];
set(txpro(8), 'String', ...
    char('8. Elementos finitos', '    trigonomtricos'))
for k = 1:10
    set(txpro(k), 'ButtonDownFcn', ['menupcn(9,', num2str(k),')'])
end
set(txpro(1), 'ButtonDownFcn', 'menupcn(9,1,'''',''largetext'')')
set(txpro(2), 'ButtonDownFcn', 'menupcn(9,2,'''',''largetext'')')
set(txpro(4), 'ButtonDownFcn', 'menupcn(9,4,'''',''largetext'')')


%====================================

% Titulo

ejes_pos = [X_ejes(6), Y_ejes(6), ancho_ejes, alto_ejes];
ax1 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

image(imread('prmn.jpg'))
axis equal off

ejes_pos = [X_ejes(7)-sep, Y_ejes(7), ancho_ejes, alto_ejes];
ax0 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

Capitulo = [...
        ' Problemas ';...
        'de Frontera'];

tx1 = text( ...
    'String',Capitulo, ...
    'Position', [0.5,0.5], ...
    'VerticalAlignment','middle', ...
    'HorizontalAlignment','Center', ...
    'FontSize',18, ...
    'FontName','Arial', ...
    'FontWeight','demi', ...
    'Color',colortit);

%====================================

% Problema 9.1
cap = 1;
ax01 = axes;
ejes_pos = [X_ejes(cap), Y_ejes(cap), ancho_ejes, alto_ejes];
enlace01 = ['menupcn(9,1,'''',''largetext'')'];

% Figura 1: 
image(imread('esfera.jpg'))
axis equal off

set(ax01, ...
    'Position', ejes_pos, ...
    'ButtonDownFcn', enlace01);

set(get(ax01, 'Children'), ...
    'ButtonDownFcn', enlace01);

% Fin Problema 9.1
   
%====================================

% Problema 9.2
cap = 2;
ax02 = axes;
enlace02 = ['menupcn(9,2,'''',''largetext'')'];
ejes_pos = [X_ejes(cap), Y_ejes(cap), ancho_ejes, alto_ejes];

% Figura 2: 
image(imread('dirichlet.jpg'))
axis equal off


set(ax02, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace02, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace02);

% Fin Problema 9.2
   
%====================================

% Problema 9.3: 
cap = 3;
ax03 = axes;
enlace03 = ['menupcn(9, 3)'];

% Figura 3: 
image(imread('euler.jpg'))
axis equal off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax03, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace03, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace03);

% Fin Problema 9.3
   
%====================================

% Problema 9.4: 
cap = 4;
ax04 = axes;
enlace04 = ['menupcn(9,4,'''',''largetext'')'];

% Figura 4: 
x = 1:0.1:3;
y = 0:pi/24:2*pi;
[r,z] = meshgrid(x,y);
X = r.*cos(z);
Y = r.*sin(z);
Z = 3/2*log(r) -log(3) - r.^2;
surf(X,Y,Z)
view(0, 30)
axis([-3 3 -3 3 -8.5 -2])

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax04, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace04, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace04);

% Fin Problema 9.4
   
%====================================

% Problema 9.5: 
cap = 5;
ax05 = axes;
enlace05 = ['menupcn(9, 5)'];

% Figura 5: 
x = 1:0.1:3;
y = 0:pi/24:2*pi;
[r,z] = meshgrid(x,y);
X = r.*cos(z);
Y = r.*sin(z);
Z = zeros(size(X));
C = 1/2*log(r) -log(3);
surf(X,Y,C)
view(0,90)
axis equal
shading interp

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax05, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace05);

% Fin Problema 9.5
   
%====================================

% Problema 9.6: 
cap = 8;
ax06 = axes;
enlace06 = ['menupcn(9, 6)'];

% Figura 6: 
f = inline('[y(2);x.*y(2)-(x.^2).*y(1)+x.^3]','x','y');
a=0; b=1; n=20; maxiter=15; tol=1e-3;
h = (b-a)/n;        
x = a:h:b;
t1 = [0;1];                                         % primer disparo
[x,Y] = ode45(f,x,t1);
ya1 = Y(1,:);   yb1 = Y(n+1,:);
YY = Y(:,1);
f1 = [2*t1(1)+2*yb1(1)-7;2*t1(2)+2*yb1(2)-1];
if norm(f1)<tol
    disp('acertaste a la primera')
    t = t1;     incr = norm(f1);
    iter = 1;
else
    t2 = [-1;-1];                                   % segundo disparo
    [x,Y] = ode45(f,x,t2);
    YY = [YY Y(:,1)];
    ya2 = Y(1,:);   yb2 = Y(n+1,:);
    f2 = [2*t2(1)+2*yb2(1)-7;2*t2(2)+2*yb2(2)-1];
    if norm(f2)<tol
        disp('acertaste a la segunda')
        t = t2;     
        incr = norm(f2);
        iter = 2;
    else
        iter = 2;
        A = zeros(2);
        incr = max(abs(f2));
        while incr > tol & iter < maxiter
            A(1,1) = (f2(1)-f1(1))/(t2(1)-t1(1));
            A(2,2) = (f2(2)-f1(2))/(t2(2)-t1(2));
            z = A  \  f2;
            t = t2 - z;
            t1 = t2; 
            t2 = t;
            [X,Y] = ode45(f,x,t);
            YY = [YY Y(:,1)];
            ya1 = ya2;
            yb1 = yb2;
            ya2 = Y(1,:);       
            yb2 = Y(n+1,:);
            f1 = f2;
            f2 = [2*t2(1)+2*yb2(1)-7;2*t2(2)+2*yb2(2)-1];
            incr = norm(f2);
            iter = iter+1;
        end
    end
end
plot(x,YY(:,4:end))

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax06, ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace06, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace06);

% Fin Problema 9.6
   
%====================================
   

% Problema 9.7: 
cap = 9;
ax07 = axes;
enlace07 = ['menupcn(9, 7)'];

% Figura 7
x = 0:0.1:1;
y = [0 320, 549, 696, 769, 775, 720, 610, 450, 245, 0];
plot(x,diag(y))
hold on
plot(x,y,'linewidth',2,'color','r')

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax07, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace07, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace07);

% Fin Problema 9.7

%====================================

% Problema 9.8: 
cap = 10;
ax08 = axes;
enlace08 = ['menupcn(9, 8)'];

% Figura 8: 
x = linspace(0,1)';
y = zeros(size(x));
Y = y;
C = [0.15876236,-0.02534419, 0.00794539,-0.00345743, 0.00271544];
for k=1:5
    z = C(k)*sin(k*pi*x);
    Y = [Y, z];
    y = y + z;
end
plot(x,Y(:,1:6))
hold on
plot(x,y,'linewidth',2,'color','r')
hold off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap)-sep/2 ancho_ejes alto_ejes];
set(ax08, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace08, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace08);

% Fin Problema 9.8
   
%====================================

% Problema 9.9:
cap = 11;
ax09 = axes;
enlace09 = ['menupcn(9, 9)'];

% Figura 9: 
f=inline('y.*z+exp(-2*x)-x+x.*exp(-x)');
a = 0; b = 1; beta = 1+exp(-1); 
N = 99; tol = 1e-4; maxiter = 2;
h=(b-a)/(N+1);          
X=a:h:b;        
x=X(1:N+1);
%Y=[ones(1,N+1),beta];  
Y = linspace(1,beta,N+2);
y=Y(1:N+1);
Z = Y(:);
incre=tol+1;
iter=1;
while incre>tol & iter<=maxiter
    z=(Y(3:N+2)-Y(1:N))/(2*h);              % estimacin de la derivada
    z=[1-y(1),z];
    fx=feval(f,x,y,z);
    apas=-2+2*h-h^2+2*h^2*y(1);      
    a=-2-h/2*(Y(3:N+2)-Y(1:N));
    a=[apas,a];                 % diagonal principal de la matriz jacobiana
    bpas=2;      b=1-h/2*y(2:N);     b=[bpas,b];        %diagonal superior
    c=1+h/2*y(2:N+1);                                   % diagonal inferior
    paso=h^2*(exp(-2*x(1))-x(1)+x(1)*exp(-x(1)));
    idp=(2-2*h+h^2)*y(1)-h^2*y(1)^2-2*y(2)+2*h+paso;
    d=-Y(1:N)+2*Y(2:N+1)-Y(3:N+2)+h^2*fx(2:N+1);
    d=[idp,d];                          % vector de trminos independientes
    v=Crout(a,b,c,d);       
    y=y+v;              
    Y=[y beta];
    Z = [Z, Y(:)];
    incre=norm(v);
    iter=iter+1;
end   
plot(X,Z)

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax09, ...
    'XTickLabel', [], ...
    'Box', 'off', ...
    'Clipping', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace09, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace09);

% Fin Problema 9.9
   
%====================================

% Problema 9.10: 
cap = 12;
ax10 = axes;
enlace10 = ['menupcn(9, 10)'];

% Figura
f = inline('[y(2); y(3); -3*((1+x)./x)*y(3)-(6./x)*y(2)+4*y(1)+x.*exp(x);y(5); y(6); 4*y(4)-(6./x)*y(5)-3*((1+x)./x)*y(6)]','x','y');
a = 1; b = 2;
alfa = 0; beta = 1; gamma = 0;
n = 100; maxiter = 3; tol = 1e-4;
h = (b-a)/n;
t = (beta-alfa)/(b-a);           % valor inicial del parmetro
incr = tol+1;   iter = 0;
Z = [];
while incr > tol & iter < maxiter
    [x,Y] = ode45(f,[b:-h:a],[beta,gamma,t,0,0,1]');
    Z = [Z, Y(:,1)];
    t = t-(Y(n+1,1)-alfa)/Y(n+1,4);
    incr = abs(Y(n+1,1)-alfa);
    iter = iter+1;
end
if incr>tol
    disp('Se necesitan ms iteraciones');
end
y = Y(:,1);
yd = Y(:,2);
plot(x,Z)

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];

set(ax10, ...
    'ButtonDownFcn', enlace10, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace10);

% Fin Problema 9.10
   
%====================================


function x=Crout(a,b,c,d)
n=length(d);
l(1)=a(1);
u(1)=b(1)/l(1);
for i=2:n-1
    l(i)=a(i)-c(i-1)*u(i-1);
    u(i)=b(i)/l(i);
end
l(n)=a(n)-c(n-1)*u(n-1);
z(1)=d(1)/l(1);
for i=2:n
    z(i)=(1/l(i))*(d(i)-c(i-1)*z(i-1));
end
x(n)=z(n);
for i=n-1:-1:1
    x(i)=z(i)-u(i)*x(i+1);
end
