function [x,Y,t,iter,incr] = disecant(f,a,b,alfa,beta,n,maxiter,tol)
% f: nombre del archivo .m donde se define la funcin del sistema
% a,b: extremos del intervalo
% alfa, beta: condiciones de contorno
% n: nmero de subintervalos
% maxiter: nmero mximo de iteraciones
% tol: tolerancia permitida

h = (b-a)/n;
t1 = 0;
[x,Y] = ode45(f,a:h:b,[alfa,t1]);
yb1 = Y(n+1,1);
t2 = 1;
[x,Y] = ode45(f,a:h:b,[alfa,t2]);
yb2 = Y(n+1,1);
incr = abs(yb2-beta); 
iter = 0;
while incr > tol & iter < maxiter
    t = t2 -(t2-t1)/(yb2-yb1)*(yb2-beta);
    t1 = t2; t2 = t;
    [x,Y] = ode45(f,a:h:b,[alfa,t]);
    yb1 = yb2;  yb2 = Y(n+1,1);
    incr = abs(yb2-beta);
    iter = iter+1
end