function [x,Y,t,iter,incr] = disecant03(f,a,b,alfa,beta,gamma,n,maxiter,tol)
% f: nombre del archivo .m donde se define la funcin del sistema
% a,b: extremos del intervalo
% alfa, beta, gamma: condiciones de contorno
% n: nmero de subintervalos
% maxiter: nmero mximo de iteraciones
% tol: tolerancia permitida

h = (b-a)/n;
t1 = 1;                                   % primer disparo
[x,Y] = ode45(f,a:h:b,[alfa,beta,t1]);
yb1 = Y(n+1,1);
t2 = 2;                                   % segundo disparo
[x,Y] = ode45(f,a:h:b,[alfa,beta,t2]);
yb2 = Y(n+1,1);
incr = abs(yb2-gamma);  
iter = 0;
while incr > tol & iter < maxiter
    t = t2 -(t2-t1)/(yb2-yb1)*(yb2-gamma);
    t1 = t2; t2 = t;
    [X,Y] = ode45(f,a:h:b,[alfa,beta,t]);
    yb1 = yb2;  yb2 = Y(n+1,1);
    incr = abs(yb2-gamma);
    iter = iter+1
end
