function [r,U,t,iter,incr] = disecant04(f,a,b,alfa,beta,N,maxiter,tol)
% f: nombre del archivo .m donde se define la funcin del sistema
% a,b: extremos del intervalo
% alfa, beta: condiciones de contorno
% n: nmero de subintervalos
% maxiter: nmero mximo de iteraciones
% tol: tolerancia permitida

h = (b-a)/N;
t0 = 1;                                  % primer disparo
[r,U] = ode45(f,a:h:b,[alfa,t0]);
ub0 = U(N+1,1);
upb0 = U(N+1,2);
t1 = 2;                                  % segundo disparo
[r,U] = ode45(f,a:h:b,[alfa,t1]);
ub1 = U(N+1,1);     
upb1 = U(N+1,2);
incr = abs(ub1-upb1-beta);  iter = 0;
while incr > tol & iter < maxiter
    t = t1-((t1-t0)*(ub1-upb1-beta))./(ub1-upb1-ub0+upb0);
    [r,U] = ode45(f,a:h:b,[alfa,t]');
    t0 = t1;            
    t1 = t;
    ub0 = ub1;          
    upb0 = upb1;
    ub1 = U(N+1,1);     
    upb1 = U(N+1,2);
    incr = abs(ub1-upb1-beta);
    iter = iter+1;
end
if incr > tol
    disp('Se necesitan ms iteraciones');
end
