function [r,u,ud,t,iter] = disparoNewton05(f,a,b,alfa,beta,n,maxiter,tol)
% f:  archivo .m donde se define la funcin del sistema 
% a,b: extremos del intervalo
% alfa, beta: condiciones de contorno
% n: nmero de subintervalos
% maxiter: nmero mximo de iteraciones
% tol: tolerancia permitida
% u: valores aproximados de la solucin
% ud: valores aproximados de la derivada

h = (b-a)/n;
t = (beta-alfa)/(b-a);                % valor inicial del parmetro
incr = tol+1;   iter = 0;
while incr > tol & iter < maxiter
    [r,U] = ode45(f,[a:h:b],[t,alfa-t,1,-1]');
    t = t-(U(n+1,1)+U(n+1,2)-beta)/(U(n+1,3)+U(n+1,4));
    incr = abs(U(n+1,1)+U(n+1,2)-beta);
    iter = iter+1;
end
if incr > tol
    disp('Se necesitan ms iteraciones');
end
u = U(:,1);
ud = U(:,2);