function [x,Y,t,iter,incr] = disparo906(f,a,b,n,maxiter,tol)
% f: nombre del archivo .m donde se define la funcin del sistema
% a,b: extremos del intervalo
% n: nmero de subintervalos
% maxiter: nmero mximo de iteraciones
% tol: tolerancia permitida

h = (b-a)/n;        
x = a:h:b;
t1 = [0;1];                                         % primer disparo
[x,Y] = ode45(f,x,t1);
ya1 = Y(1,:);   yb1 = Y(n+1,:);
f1 = [2*t1(1)+2*yb1(1)-7;2*t1(2)+2*yb1(2)-1];
if norm(f1)<tol
    disp('acertaste a la primera')
    t = t1;     incr = norm(f1);
    iter = 1;
else
    t2 = [-1;-1];                                   % segundo disparo
    [x,Y] = ode45(f,x,t2);
    ya2 = Y(1,:);   yb2 = Y(n+1,:);
    f2 = [2*t2(1)+2*yb2(1)-7;2*t2(2)+2*yb2(2)-1];
    if norm(f2)<tol
        disp('acertaste a la segunda')
        t = t2;     
        incr = norm(f2);
        iter = 2;
    else
        iter = 2;
        A = zeros(2);
        incr = max(abs(f2));
        while incr > tol & iter < maxiter
            A(1,1) = (f2(1)-f1(1))/(t2(1)-t1(1));
            A(2,2) = (f2(2)-f1(2))/(t2(2)-t1(2));
            z = A  \  f2;
            t = t2 - z;
            t1 = t2; 
            t2 = t;
            [X,Y] = ode45(f,x,t);
            ya1 = ya2;          
            yb1 = yb2;
            ya2 = Y(1,:);       
            yb2 = Y(n+1,:);
            f1 = f2;
            f2 = [2*t2(1)+2*yb2(1)-7;2*t2(2)+2*yb2(2)-1];
            incr = norm(f2);
            iter = iter+1;
        end
    end
end
