function c = Rayleigh_lineal(p,q,f,t,m)
% p,q,f: funciones que describen la ecuacin diferencial
% t: particin del intervalo
% m: 2m+1 nmero de nodos de la cuadratura de Simpson
% c: coeficientes de la funcin aproximante

n = length(t)-1;
for i = 1:n
    l = t(i); r = t(i+1);
    h = r-l;                        % amplitud de los intervalos
    h2 = h^2;
    k = h/(2*m);    x = l:k:r;      % paso y nodos de integracin
    px = eval(p);
    ph(i) = simpz(x,px)/h2;
    qx = eval(q);
    ql(i) = simpz(x,qx.*(x-l).^2)/h2;
    qr(i) = simpz(x,qx.*(r-x).^2)/h2;
    qh(i) = simpz(x,qx.*(x-l).*(r-x))/h2;
    fx = eval(f);
    fl(i) = simpz(x,fx.*(x-l))/h;
    fr(i) = simpz(x,fx.*(r-x))/h;
end
L = 1:n-1;    R = 2:n;
a = ph(L)+ph(R)+ql(L)+qr(R);        % diagonal principal
b = qh-ph;    b = b(2:n-1);         % diagonal superior e inferior
d = fl(L)+fr(R);                    % trmino independiente
c = Crout(a,b,b,d);