function [x,Y] = dispalin(f1,f2,a,b,alfa,beta,n)
% Sintaxis:  [x,Y] = dispalin('f1','f2',a,b,alfa,beta,n)
% f1: nombre del archivo .m donde se define el sistema
%      u_1' = u_2
%      u_2' = p(x)u_2 + q(x)u_1 + r(x)
% f2: nombre del archivo .m donde se define el sistema
%      v_1' = v_2
%      v_2' = p(x)v_2 + q(x)v_1
% a,b: extremos del intervalo
% alfa, beta: valores de frontera
% n: nmero de subintervalos en [a,b]
% x: vector de nodos
% Y: valores de la solucin y su derivada

h = (b-a)/n;
[x,Y1] = ode45(f1,[a:h:b],[alfa,0]);        % primer disparo
[x,Y2] = ode45(f2,[a:h:b],[0,1]);           % segundo disparo
c = (beta - Y1(n+1,1))/Y2(n+1,1);           % ajuste del ngulo de tiro
Y = Y1 + c*Y2;                              % disparo final