function [X,Y] = Richardsondifinlin(p,q,r,a,b,alfa,beta,n,maxiter)
% p,q,r: funciones que describen la ecuacin diferencial lineal
% a,b: extremos del intervalo
% alfa,beta: condiciones de contorno
% n: nmero de subintervalos

[X,Y] = difinlin(p,q,r,a,b,alfa,beta,n); 
i = 1; 
while  i < maxiter
    n = 2*n;
    [X,Z] = difinlin(p,q,r,a,b,alfa,beta,n);
    YN(1,:) = Z(1:2^i:n+1);
    for j = 1:i
        YN(j+1,:) = (4^j*YN(j,:)-Y(j,:))/(4^j-1);
    end
    i = i+1;
    Y = YN;
end