function [X,Z] = difinlin(p,q,r,a,b,alfa,beta,n)
% p,q,r: funciones que describen la ecuacin diferencial lineal
% a,b: extremos del intervalo
% alfa,beta: condiciones de contorno
% n: nmero de subintervalos

h = (b-a)/n;        
X = a:h:b;
x = X(2:n);
px = eval(p);
qx = eval(q);
rx = eval(r);
a = 2 + h^2*qx;                         % diagonal principal de A
b = -1 + h/2*px(1:n-2);                 % superdiagonal de A
c = -1 - h/2*px(2:n-1);                 % subdiagonal de A
d = - h^2*rx;                           % trminos independientes
d(1) = d(1) + (1 + h/2*px(1))*alfa;
d(n-1) = d(n-1) + (1 -h/2*px(n-1))*beta;
y = Crout(a,b,c,d);
Z = [alfa y beta];