function [x,Y,t,iter,incr] = disparoNewton(f,a,b,alfa,beta,n,maxiter,tol)
% f:  archivo .m donde se define la funcin del sistema 
% a,b: extremos del intervalo
% alfa, beta: condiciones de contorno
% n: nmero de subintervalos
% maxiter: nmero mximo de iteraciones
% tol: tolerancia permitida
% Y: valores aproximados de la solucin y su derivada
% t: ltimo valor del parmetro
% iter: nmero de iteraciones realizadas

h = (b-a)/n;
t = (beta-alfa)/(b-a);              % valor inicial del parmetro
incr = tol+1;   iter = 0;
while incr > tol & iter < maxiter
    [x,Y] = ode45(f,[a:h:b],[alfa,t,0,1]');
    t = t-(Y(n+1,1)-beta)/Y(n+1,3);
    incr = abs(Y(n+1,1)-beta);
    iter = iter+1;
end
if incr > tol
    disp('Se necesitan ms iteraciones');
end
