function [X,Y,iter, incre]=difnolin09(f,a,b,beta,N,tol,maxiter)
%
% f: archivo.m con la funcin que describe la ecuacin diferencial
% dy: archivo.m con la parcial de f con respecto a y
% dyp: archivo con la parcial de f con respecto a y'
% N: N+1 subintervalos
% maxiter: nmero mximo de iteraciones a realizar por Newton
% tol: diferencia que aceptamos entre una iteracin y la anterior
%
h=(b-a)/(N+1);          
X=a:h:b;        
x=X(1:N+1);
Y=[ones(1,N+1),beta];  
y=Y(1:N+1);

incre=tol+1;
iter=1;
while incre>tol & iter<=maxiter
    z=(Y(3:N+2)-Y(1:N))/(2*h);              % estimacin de la derivada
    z=[1-y(1),z];
    fx=feval(f,x,y,z);
    
    apas=-2+2*h-h^2+2*h^2*y(1);      
    a=-2-h/2*(Y(3:N+2)-Y(1:N));
    a=[apas,a];                 % diagonal principal de la matriz jacobiana
    
    bpas=2;      b=1-h/2*y(2:N);     b=[bpas,b];        %diagonal superior
    
    c=1+h/2*y(2:N+1);                                   % diagonal inferior
    
    paso=h^2*(exp(-2*x(1))-x(1)+x(1)*exp(-x(1)));
    idp=(2-2*h+h^2)*y(1)-h^2*y(1)^2-2*y(2)+2*h+paso;
    d=-Y(1:N)+2*Y(2:N+1)-Y(3:N+2)+h^2*fx(2:N+1);
    d=[idp,d];                          % vector de trminos independientes
    
    v=Crout(a,b,c,d);       
    y=y+v;              
    Y=[y beta];
    incre=norm(v);
    iter=iter+1;
end    

