function [X,Y,iter]=difnolinealesNewton(f,dy,dyp,a,b,alfa,beta,N,tol,maxiter)
%
% f: archivo.m con la funcin que describe la ecuacin diferencial
% dy: archivo.m con la parcial de f con respecto a y
% dyp: archivo con la parcial de f con respecto a y'
% N: nmero de puntos donde quiero estimar la solucin. Coincide con el
% tamao del sistema
% maxiter: nmero mximo de iteraciones a realizar por Newton
% tol: diferencia que aceptamos entre una iteracin y la anterior
%
h=(b-a)/(N+1);
X=a:h:b;
x=X(2:N+1);
k=(beta-alfa)/(N+1);
Y=alfa:k:beta;
y=Y(2:N+1);

incre=tol+1;
iter=1;
while incre>tol & iter<=maxiter
    z=(Y(3:N+2)-Y(1:N))/(2*h);   % estimacin de la derivada
    fx=feval(f,x,y,z);
    dyx=feval(dy,x,y,z);
    dypx=feval(dyp,x,y,z);
    
    a=2+h^2*dyx;
    b=-1+(h/2)*dypx(1:N-1);
    c=-1-(h/2)*dypx(2:N);
    d=Y(1:N)-2*Y(2:N+1)+Y(3:N+2)-h^2*fx;
    
    v=Crout(a,b,c,d);
    y=y+v;
    Y=[alfa y beta];
    incre=norm(v);
    iter=iter+1;
end    
