function [x,y,yd,t,incr] = disparoNewton10(f,a,b,alfa,beta,gamma,n,maxiter,tol)
% f:  archivo .m donde se define la funcin del sistema 
% a,b: extremos del intervalo
% alfa, beta,gamma: condiciones de contorno
% n: nmero de subintervalos
% maxiter: nmero mximo de iteraciones
% tol: tolerancia permitida
% y: valores aproximados de la solucin 
% yd: valores aproximados de la derivada
% t: ltimo valor del parmetro

h = (b-a)/n;
t = (beta-alfa)/(b-a);           % valor inicial del parmetro
incr = tol+1;   iter = 0;
while incr > tol & iter < maxiter
    [x,Y] = ode45(f,[b:-h:a],[beta,gamma,t,0,0,1]');
    t = t-(Y(n+1,1)-alfa)/Y(n+1,4);
    incr = abs(Y(n+1,1)-alfa);
    iter = iter+1;
end
if incr>tol
    disp('Se necesitan ms iteraciones');
end
y = Y(:,1);
yd = Y(:,2);