function dm10

% Captulo 10
% Ecuaciones en Derivadas Parciales

% Problemas Resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson

% jlh: nov-2006

% Ventana principal
fondo = [0 0 0];
colortit = [1 0.5 0];
colorcap = [0 0.3 0.9];
colornum = [0.9 0.9 0.9];
c_ejes = fondo;
figure('Menubar', 'None', ...
    'Color', fondo, ...
    'Units', 'normalized', ...
    'Position', [0.05 0.1 0.9 0.8], ...
    'Numbertitle', 'off', ...
    'Name', 'Captulo 10. Ecuaciones en Derivadas Parciales');

% Plantilla
sep = 0.05;
alto_texto = 0.05;
fil = 3;
col = 4;
fc = fil*col;
ancho_ejes = 1/col - sep;
alto_ejes = 1/fil - sep - alto_texto;
x_ejes = sep/2 : sep + ancho_ejes : 1;
y_ejes = sep/2 : sep + alto_ejes + alto_texto : 1;
y_txt = sep/2 + alto_ejes + alto_texto : sep + alto_ejes + alto_texto : 1;
y_ejes = fliplr(y_ejes);
y_txt = fliplr(y_txt);
[Y_ejes, X_ejes] = meshgrid(y_ejes, x_ejes);
[Y_txt, X_txt] = meshgrid(y_txt, x_ejes);

%====================================

% Ttulos de los problemas
axes(...
    'Color', fondo, ...
    'XColor', fondo, ...
    'YColor', fondo, ...
    'ZColor', fondo, ...
    'Position', [0 0 1 1]);

problema = char(...
    '1. Instrumento musical', ...
    '2. Ecuacin de ondas', ...
    '3. Ecuacin del calor', ...
    '4. Ecuacin de Poisson', ...
    '5. Ecuacin de Laplace', ...
    '', ...
    '', ...
    '6. Parablica con condiciones mixtas', ...
    '7. Ecuacin del telgrafo', ...
    '8. Cuerda en medio elstico', ...
    '9. Hiperblica complicada', ...
    '10. Parablica no estndar');
txpro = text(X_txt(:), Y_txt(:), problema, ...
    'HorizontalAlignment', 'left', ...
    'VerticalAlignment', 'top', ...
    'FontName','Verdana', ...
    'FontSize',10, ...
    'FontWeight','demi', ...
    'Color',colorcap);
txpro(6:7) = [];
set(txpro(6), 'String', ...
    char('6. Parablica con ', '    condiciones mixtas'))
for k = 1:10
    set(txpro(k), 'ButtonDownFcn', ['menupcn(10,', num2str(k),')'])
end
set(txpro(5), 'ButtonDownFcn', 'menupcn(10,5,'''',''largetext'')')


%====================================

% Titulo

ejes_pos = [X_ejes(6), Y_ejes(6), ancho_ejes, alto_ejes];
ax1 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

image(imread('prmn.jpg'))
axis equal off

ejes_pos = [X_ejes(7)-sep, Y_ejes(7), ancho_ejes, alto_ejes];
ax0 = axes(...
    'Visible','off', ...
    'Position',ejes_pos);

Capitulo = [...
        '   Ecuaciones en   ';...
        'Derivadas Parciales'];

tx1 = text( ...
    'String',Capitulo, ...
    'Position', [0.5,0.5], ...
    'VerticalAlignment','middle', ...
    'HorizontalAlignment','Center', ...
    'FontSize',18, ...
    'FontName','Arial', ...
    'FontWeight','demi', ...
    'Color',colortit);

% ====================================

% Problema 10.1
cap = 1;
ax01 = axes;
ejes_pos = [X_ejes(cap), Y_ejes(cap), ancho_ejes, alto_ejes];
enlace01 = ['menupcn(10, 1)'];

% Figura 1:
U = exponda(20,0,80,40,1/350,56000,'f01','g','g','g');
surf(U)
shading flat
view(30,50)
axis([1 41 1 21 -1 1])
axis off

set(ax01, ...
    'Position', ejes_pos, ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace01);


set(get(ax01, 'Children'), ...
    'ButtonDownFcn', enlace01);

% Fin Problema 10.1

%====================================

% Problema 10.2
cap = 2;
ax02 = axes;
enlace02 = ['menupcn(10, 2)'];
ejes_pos = [X_ejes(cap)-sep, Y_ejes(cap)-sep, ancho_ejes+sep, alto_ejes+2*sep];

% Figura 2:
Uex = exponda(10,0,1,120,3,1,'f','g','g','g');
surf(Uex)
shading flat
axis off
% x = 0:1/20:1;
% y = 0:3/20:3;
% [x,y] = meshgrid(x,y);
% z=(1/8)*sin(pi*x).*cos(pi*y);
% surf(z)
% axis off

set(ax02, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace02, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace02);

% Fin Problema 10.2

%====================================

% Problema 10.3:
cap = 3;
ax03 = axes;
enlace03 = ['menupcn(10, 3)'];

% Figura 3:
x = 0:0.1:4;
t = 0:0.5:8;
[x,t] = meshgrid(x,t);
y=exp(-t).*sin((pi/2)*x)+exp(-t/4).*sin((pi/4)*x);
waterfall(flipud(y))
view(50,30)
set(get(gca,'Ch'), 'LineWidth', 2, 'FaceColor', 'k')

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap)-sep ancho_ejes alto_ejes+sep];
set(ax03, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace03, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace03);

% Fin Problema 10.3

%====================================

% Problema 10.4:
cap = 4;
ax04 = axes;
enlace04 = ['menupcn(10, 4)'];

% Figura 4:
x = 0:pi/10:pi;
y = 0:pi/20:pi/2;
[x,y] = meshgrid(x,y);
u = cos(x).*cos(y);
surf(u)
axis off
view(50,30)

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes+sep alto_ejes];
set(ax04, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace04, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace04);

% Fin Problema 10.4

%====================================

% Problema 10.5:
cap = 5;
ax05 = axes;
enlace05 = ['menupcn(10,5,'''',''largetext'')'];

% Figura 5:
[U,iter] = GS(-1,1,-1,1,0.25,0.25,'f5','g',1e-3,1000);
surf(U)
view(130,10)
axis off

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax05, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace05);

% Fin Problema 10.5

%====================================

% Problema 10.6:
cap = 8;
ax06 = axes;
enlace06 = ['menupcn(10, 6)'];

% Figura 6:
Uni = nicalor06(10,0,1,200,1,1,'f6');
plot(Uni')

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap)-sep/2 ancho_ejes alto_ejes];
set(ax06, ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace06, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace06);

% Fin Problema 10.6

%====================================


% Problema 10.7:
cap = 9;
ax07 = axes;
enlace07 = ['menupcn(10, 7)'];

% Figura 7
U = imponda07(20,0,1,20,0.5,'f7','g','g','g');
surf(U)
axis([1 41 1 41 0 1])
axis off

% Ejes
ejes_pos = [X_ejes(cap)-sep Y_ejes(cap) ancho_ejes+2*sep alto_ejes+sep];
set(ax07, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace07, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace07);

% Fin Problema 10.7

%====================================

% Problema 10.8:
cap = 10;
ax08 = axes;
enlace08 = ['menupcn(10, 8)'];

% Figura 8:
Uex = exponda(10,0,1,200,1,1,'f8','g','g','g');
x=0:0.1:1;
plot(x,Uex(:,1:10:200))

% Ejes
ejes_pos = [X_ejes(cap) Y_ejes(cap) ancho_ejes alto_ejes];
set(ax08, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace08, ...
    'Position', ejes_pos)

set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace08);

% Fin Problema 10.8

%====================================

% Problema 10.9:
cap = 11;
ax09 = axes;
enlace09 = ['menupcn(10, 9)'];

% Figura 9:
U = imponda09(29,0,1,24,1,'sin','g');
x=0:.1:1;
surf(U)
axis off
shading flat

% Ejes
ejes_pos = [X_ejes(cap)-sep/2 Y_ejes(cap) ancho_ejes+sep/2 alto_ejes+sep];
set(ax09, ...
    'XTickLabel', [], ...
    'Box', 'off', ...
    'Clipping', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'ButtonDownFcn', enlace09, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace09);

% Fin Problema 10.9

%====================================

% Problema 10.10:
cap = 12;
ax10 = axes;
enlace10 = ['menupcn(10, 10)'];

% Figura

Uim = impcalor(20,0,1,20,0.5,'f10','c1','c2');
surf(Uim)
%shading flat
view(150,30)
axis off

% Ejes
ejes_pos = [X_ejes(cap)-sep Y_ejes(cap)-sep ancho_ejes+sep alto_ejes+2*sep];

set(ax10, ...
    'ButtonDownFcn', enlace10, ...
    'XTickLabel', [], ...
    'YTickLabel', [], ...
    'Box', 'off', ...
    'Color', c_ejes, ...
    'XColor', c_ejes, ...
    'YColor', c_ejes, ...
    'ZColor', c_ejes, ...
    'Position', ejes_pos)


set(get(gca, 'Children'), ...
    'ButtonDownFcn', enlace10);

% Fin Problema 10.10

%====================================

% Funciones auxiliares

% Problema 1

function y=f01(x)
y=0.03*x.*(x<=20)+(0.8-0.01*x).*(x>20);


%problema 2

function y=f(x)

y=(1/8)*sin(pi*x);

function U = exponda(nx,a,b,nt,T,c,f,g,l,r)
% Sintaxis: U = exponda(nx,a,b,nt,T,c,'f','g','l','r')
% f,g: archivos .m con las condiciones iniciales
% l,r: archivos .m con las condiciones de contorno
% nx, nt: nmero de subintervalos espaciales y temporales
% a,b: extremos de la cuerda
% T: instante final
h = (b-a)/nx;   x = a:h:b;          % vector de nodos espaciales
k = T/nt;   t = 0:k:T;              % vector de nodos temporales
fx = feval(f,x);
fx = fx(:);
gx = feval(g,x);
gx = gx(:);
lt = feval(l,t);
rt = feval(r,t);
a2 = (c*k/h)^2;                    % parmetro de Courant
U = zeros(nx+1,nt+1);
U(:,1) = fx;
U(1,:) = lt;
U(nx+1,:) = rt;
L = 1:nx-1; C = 2:nx; R = 3:nx+1;   % rangos de ndices
U(C,2) = a2*(fx(L)+fx(R))/2+(1-a2)*fx(C)+k*gx(C);
for j = 2:nt
    U(C,j+1) = a2*(U(L,j)+U(R,j))+2*(1-a2)*U(C,j)-U(C,j-1);
end

function y=g(x)
y=0*x;

% problema 3
function y=f3(x)
y=sin((pi/4)*x).*(1+2*cos((pi/4)*x));

function U = expcalor03(nx,a,b,nt,T,c,f,c1,c2)
% Sintaxis: U = expcalor03(nx,a,b,nt,T,c,'f','c1','c2')
% nx: nmero de subintervalos espaciales
% nt: nmero de subintervalos temporales
% a,b: extremos del intervalo de variacin espacial
% T: instante final
% f: archivo .m con la condicin inicial
% c1,c2: archivos .m con las condiciones de contorno
h = (b-a)/nx;
k = T/nt;
alfa = c*k/h^2;                                 % parmetro de Courant
x = a:h:b;
t = 0:k:T;
U = zeros(nx+1,nt+1);                           % inicializacin matriz U
U(:,1) = feval(f,x);                            % solucin en t = 0
U(1,:) = feval(c1,t); U(nx+1,:) = feval(c2,t);  % condiciones de contorno
L = 1:nx-1; C = 2:nx; R = 3:nx+1;               % rangos de ndices
for j = 1:nt
    U(C,j+1) = alfa*(U(L,j) + U(R,j)) + (1-2*alfa)*U(C,j);
end


% Problema 5

function y=f5(x)
y=ones(1,length(x));


function [U,iter] = GS(a,b,c,d,h,k,f0,f1,tol,maxiter)
% Sintaxis: [U,iter] = GS(a,b,c,d,h,k,'f0','f1',tol,maxiter)
% a,b: extremos de variacin de la x
% c,d: extremos de variacin de la y
% h,k: pasos para la x e y
% f0,f1: archivos .m con las condiciones de Dirichlet
% tol: tolerancia
% maxiter: nmero mximo de iteraciones
x = a:h:b;
nx = (b-a)/h;
ny = (d-c)/k;
alfa = k/h;
alfa2 = alfa^2;
beta = 2*(1+alfa2);
beta2 = beta-2*h*alfa2;
f0x = feval(f0,x);
f1x = feval(f1,x);
g0 = f0x(1):-k/2:f1x(1);                            % estimada
g1 = f0x(nx+1):-k/2:f1x(nx+1);                      % estimada
u0 = (sum(f0x+f1x)/(nx+1)+sum(g0+g1)/(ny+1))/4;     % inicializacin
U = u0*ones(nx+1,ny+1);
U(1,:) = g0;
U(nx+1,:) = g1;
U(:,1) = f0x(:);
U(:,ny+1) = f1x(:);
incr = tol+1;
iter = 0;
while incr>tol & iter<maxiter
    incr = 0;
    for i = 2:nx
        for j = 2:ny
            U(1,j) = (2*alfa2*U(2,j)+U(1,j-1)+U(1,j+1))/(beta-h*alfa2);
            v = (alfa2*(U(i-1,j)+U(i+1,j))+U(i,j-1)+U(i,j+1))/beta;
            U(nx+1,j) = (2*alfa2*U(nx,j)+U(nx+1,j-1)+U(nx+1,j+1))/beta2;
            incr = max(incr,abs(U(i,j)-v));
            U(i,j) = v;
        end
    end
    iter = iter+1;
end


% Problema 6

function y=f6(x)
y=1-x;

function [U,iter] = Jacobi(a,b,c,d,nx,ny,f,f0,f1,g0,g1,tol,maxiter)
% Sintaxis:
% [U,iter] = Jacobi(a,b,c,d,nx,ny,'f','f0','f1','g0','g1',tol,maxiter)
% a,b,c,d: extremos de los intervalos de variacin de x e y
% nx,ny: nmero de subintervalos para x e y
% f: archivo.m con el trmino independiente de la ecuacin de Poisson
% f0,f1: archivos.m con la condicin de frontera en los puntos
% (x,c) y (x,d), respectivamente.
% g0,g1: archivos.m con la condicin de frontera en los puntos
% (a,y) y (b,y), respectivamente.
%
h = (b-a)/nx;
x = a:h:b;
k = (d-c)/ny;
y = c:k:d;
alfa = k/h;
alfa2 = alfa^2;
beta = 2*(1+alfa2);
f0x = feval(f0,x);
f1x = feval(f1,x);
g0y = feval(g0,y);
g1y = feval(g1,y);
U = zeros(nx+1,ny+1);                         % matriz U inicial
U(:,1) = f0x(:);                                % condiciones contorno
U(:,ny+1) = f1x(:);
U(1,:) = g0y;
U(nx+1,:) = g1y;

% Mtodo de Jacobi
incr = tol+1;       iter = 0;
v = U;
C = 2:nx; L = 1:nx-1; R = 3:nx+1;
while incr>tol & iter<maxiter
    for j = 2:ny
        for i=2:nx
            v(i,j) = (alfa2*(U(i-1,j)+U(i+1,j))+U(i,j-1)+U(i,j+1)-...
                k^2*feval(f,x(i),y(j)))/beta;
        end
    end
    incr = max(max(abs(U-v)));
    iter = iter+1;
    U = v;
end


%problema 6
function U = nicalor06(nx,a,b,nt,T,c,f)
% Sintaxis: U = expcalor06(nx,a,b,nt,T,c,'f')
% nx,nt: nmero de subintervalos espaciales y temporales
% a,b: extremos de variacin espacial
% T: instante final
% f: archivo.m con la condicin inicial
h = (b-a)/nx;
x = a:h:b;                          % vector de nodos espaciales
k = T/nt;
t = 0:k:T;                          % vector de nodos temporales
fx = feval(f,x);
fx = fx(:);
alfa = c*k/h^2;
U = zeros(nx+1,nt+1);
U(:,1) = fx;
L = 1:nx-1; C = 2:nx; R = 3:nx+1;   % rangos de ndices
d0 = [(1+alfa)*ones(1,nx) 1+alfa+alfa*h];
d1 = [-alfa -alfa/2*ones(1,nx-1)];
d2 = [-alfa/2*ones(1,nx-1) -alfa];

dp = [(1-alfa)*ones(1,nx) 1-alfa-alfa*h];
ds = [alfa alfa/2*ones(1,nx-1)];
di = [alfa/2*ones(1,nx-1) alfa];
B = diag(dp)+diag(ds,1)+diag(di,-1);
for j = 1:nt
    p = k/2*(exp(-t(j))+exp(-t(j+1)))*ones(nx+1,1);
    p = B*U(:,j)+p;
    U(:,j+1) = Crout(d0,d1,d2,p)';              % solucin del sistema
end

% Problema 7

function y = f7(x)

y = sin(pi*x);


function U = imponda07(nx,a,b,nt,T,f,g,l,r)

% Sintaxis: U=exponda07(nx,a,b,nt,T,'f','g','l','r')
% a,b: intervalo espacial
% nx,nt: nmero de subintervalos espaciales y temporales
% T: instante final
% f,g: archivos .m con la condicin inicial
% l,r: archivos .m con las condiciones de contorno
%
h = (b-a)/nx;
x = a:h:b;                          % vector de nodos espaciales
k = T/nt;
t = 0:k:T;                          % vector de nodos temporales
fx = feval(f,x);
fx = fx(:);
gx = feval(g,x);
gx = gx(:);
lt = feval(l,t);
rt = feval(r,t);
U = zeros(nx+1,nt+1);
U(:,1) = fx;
U(1,:) = lt;
U(nx+1,:) = rt;
L = 1:nx-1; C = 2:nx; R = 3:nx+1;   % rangos de ndices
U(C,2)=(k^2/(2*h^2))*(fx(L)+fx(R))+(k^2/2)*(2/k^2-2-2/h^2)*fx(C);  % Paso 1

d0 = (1/k^2+1/(2*k)+1/h^2)*ones(1,nx-1);
d1 = -1/(2*h^2)*ones(1,nx-2);

for j=2:nt                                           % pasos siguientes
    b = (2/k^2-2)*U(C,j)+(1/(2*k)-1/k^2-1/h^2)*U(C,j-1)+...
        1/(2*h^2)*(U(R,j-1)+U(L,j-1));
    b(1) = b(1)+1/(2*h^2)*U(1,j+1);
    b(nx-1) = b(nx-1)+1/(2*h^2)*U(nx,j+1);           % trminos indep.
    U(C,j+1) = Crout(d0,d1,d1,b)';                   % solucin del sistema
end


% problema 8
function y=f8(x)
y=sin(pi*x);


% Problema 9

function U = imponda09(nx,a,b,nt,T,f,l)

h = (b-a)/nx;   x = a:h:b;          % vector de nodos espaciales
k = T/nt;       t = 0:k:T;          % vector de nodos temporales

fx = feval(f,x);  fx = fx(:);
lt = feval(l,t);

U = zeros(nx+1,nt+1);

U(:,1) = fx;    U(1,:) = lt;

C = 2:nx+1;

a = 1/h^2+3/k^2;
b = 1/(2*h^2)+x/(2*h*k);
c = 1/(2*h^2)-x/(2*h*k);

dp = -2*a*ones(1,nx);
ds = b(C)+c(C);
di = ds;        di(nx) = 2*di(nx);
ti(1:nx)= -6/k^2*U(C,1)+cos(pi*x(C))';
ti(nx) = ti(nx)-4*h*t(2)*(b(nx+1)+c(nx+1));

U(C,2) = Crout(dp,ds,di,ti);

dpa = -a*ones(1,nx);
dsa = b(2:nx);
dia = [c(3:nx) b(nx+1)+c(nx+1)];

dpb = a*ones(1,nx);
dsb = -c(2:nx);
dib = [-b(3:nx) -b(nx+1)-c(nx+1)];

B = diag(dpb)+diag(dsb,1)+diag(dib,-1);

p = zeros(nx,1);
for j=2:nt                                           % pasos siguentes
    p(nx) = 4*h*(b(nx+1)*t(j+1)+c(nx+1)*t(j-1));
    d = -6/k^2*U(C,j)+B*U(C,j-1)+cos(pi*x(C))'-p;
    U(C,j+1) = Crout(dpa,dsa,dia,d)' ;
end


% Problema 10

function U = impcalor(nx,a,b,nt,T,f,c1,c2)
% Sintaxis: U = impcalor(nx,a,b,nt,T,'f','c1','c2')
% nx: nmero de subintervalos espaciales
% nt: nmero de subintervalos temporales
% a,b: extremos del intervalo de variacin espacial
% T: instante final
% f: archivo .m con la condicin inicial
% c1,c2: archivos .m con las condiciones de contorno
h = (b-a)/nx;
x = a:h:b;                              % vector de nodos espaciales
k = T/nt;
t = 0:k:T;                              % vector de nodos temporales
U = zeros(nx+1,nt+1);
U(:,1) = feval(f,x)';
U(1,:) = feval(c1,t);
U(nx+1,:) = feval(c2,t);
L = 1:nx-1; C = 2:nx; R = 3:nx+1;       % rangos de ndices
d0 = (1-k+2*k/h^2)*ones(1,nx-1);
d1 = -(k/h^2+k*x(C)/(2*h));
d2 = -(k/h^2-k*x(C)/(2*h));
for j = 2:nt+1
    b = U(C,j-1);
    b(1) = b(1) + (k/h^2-k*x(2)/(2*h))*U(1,j);
    b(nx-1) = b(nx-1) + (k/h^2+k*x(nx)/(2*h))*U(nx+1,j);
    U(C,j) = Crout(d0,d1,d2,b)';        % solucin del sistema
end


function y=c1(x)
y=2*x;
function x=Crout(a,b,c,d)
% a: diagonal principal de la matriz de coeficientes
% b: subdiagonal de la matriz de coeficientes
% c: superdiagonal de la matriz de coeficientes
% d: trminos independientes del sistema

% Obtencin de las matrices L y U tal que A=LU
n=length(d);
l(1)=a(1);
u(1)=b(1)/l(1);
for i=2:n-1
    l(i)=a(i)-c(i-1)*u(i-1);
    u(i)=b(i)/l(i);
end
l(n)=a(n)-c(n-1)*u(n-1);

% Solucin del sistema Lz=d
z(1)=d(1)/l(1);
for i=2:n
    z(i)=(1/l(i))*(d(i)-c(i-1)*z(i-1));
end

% Solucin del sistema Ux=z
x(n)=z(n);
for i=n-1:-1:1
    x(i)=z(i)-u(i)*x(i+1);
end


function y=c2(x)
y=x.^2/2;


function y=f10(x)
y=sin(x)+cos(x);