function U = expcalor03(nx,a,b,nt,T,c,f,c1,c2)
% Sintaxis: U = expcalor03(nx,a,b,nt,T,c,'f','c1','c2')
% nx: nmero de subintervalos espaciales
% nt: nmero de subintervalos temporales
% a,b: extremos del intervalo de variacin espacial
% T: instante final
% f: archivo .m con la condicin inicial
% c1,c2: archivos .m con las condiciones de contorno
h = (b-a)/nx;   
k = T/nt;
alfa = c*k/h^2;                                 % parmetro de Courant
x = a:h:b;      
t = 0:k:T;
U = zeros(nx+1,nt+1);                           % inicializacin matriz U
U(:,1) = feval(f,x);                            % solucin en t = 0
U(1,:) = feval(c1,t); U(nx+1,:) = feval(c2,t);  % condiciones de contorno
L = 1:nx-1; C = 2:nx; R = 3:nx+1;               % rangos de ndices
for j = 1:nt
    U(C,j+1) = alfa*(U(L,j) + U(R,j)) + (1-2*alfa)*U(C,j);
end