function U = nicalor(nx,a,b,nt,T,c,f,l,r)
% Sintaxis: U = nicalor(nx,a,b,nt,T,c,'f','l','r')
% nx: nmero de subintervalos espaciales
% a,b: extremos de variacin de la variable espacial
% nt: nmero de subintervalos temporales
% T: instante final
% f: archivo .m con la condicin inicial
% l,r: archivos .m con las condiciones de contorno
h = (b-a)/nx;   
x = a:h:b;                          % vector de nodos espaciales
k = T/nt;       
t = 0:k:T;                          % vector de nodos temporales
fx = feval(f,x);  
fx = fx(:);
lt = feval(l,t);  
rt = feval(r,t);
alfa = c*k/h^2;
U = zeros(nx+1,nt+1);
U(:,1) = fx;    
U(1,:) = lt;    
U(nx+1,:) = rt;
L = 1:nx-1; C = 2:nx; R = 3:nx+1;   % rangos de ndices
d0 = 2*(1+alfa)*ones(1,nx-1);
d1 = -alfa*ones(1,nx-2);
b = zeros(nx-1,1);
for j = 1:nt
    b = 2*(1-alfa)*U(C,j) + alfa*(U(L,j) + U(R,j));  % trminos indep.
    b(1) = b(1) + alfa*lt(j+1);        
    b(nx-1) = b(nx-1) + alfa*rt(j+1);
    U(C,j+1) = Crout(d0,d1,d1,b)';             % solucin del sistema
end
