function U = expcalor06(nx,a,b,nt,T,c,f)
% Sintaxis: U = expcalor06(nx,a,b,nt,T,c,'f')
% nx,nt: nmero de subintervalos espaciales y temporales
% a,b: extremos de variacin espacial
% T: instante final
% f: archivo.m con la condicin inicial
h = (b-a)/nx;   
k = T/nt
alfa = c*k/h^2;                       % parmetro de Courant
x = a:h:b;      
t = 0:k:T;
U = zeros(nx+1,nt+1);                 % inicializacin matriz U
U(:,1) = feval(f,x);                  % solucin en el instante t=0
L = 1:nx-1; C = 2:nx; R = 3:nx+1;     % rangos de ndices
for j = 1:nt
 U(1,j+1) = 2*alfa*U(2,j) + (1-2*alfa)*U(1,j) + k*exp(-t(j));
 U(C,j+1) = alfa*(U(L,j) + U(R,j)) + (1-2*alfa)*U(C,j)+k*exp(-t(j));
 U(nx+1,j+1) = 2*alfa*U(nx,j)+(1-2*alfa*(1+h))*U(nx+1,j)+k*exp(-t(j));
end