function U = nicalor06(nx,a,b,nt,T,c,f)
% Sintaxis: U = expcalor06(nx,a,b,nt,T,c,'f')
% nx,nt: nmero de subintervalos espaciales y temporales
% a,b: extremos de variacin espacial
% T: instante final
% f: archivo.m con la condicin inicial
h = (b-a)/nx;   
x = a:h:b;                          % vector de nodos espaciales
k = T/nt;   
t = 0:k:T;                          % vector de nodos temporales
fx = feval(f,x);  
fx = fx(:);
alfa = c*k/h^2;
U = zeros(nx+1,nt+1);
U(:,1) = fx;
L = 1:nx-1; C = 2:nx; R = 3:nx+1;   % rangos de ndices
d0 = [(1+alfa)*ones(1,nx) 1+alfa+alfa*h];
d1 = [-alfa -alfa/2*ones(1,nx-1)];
d2 = [-alfa/2*ones(1,nx-1) -alfa];

dp = [(1-alfa)*ones(1,nx) 1-alfa-alfa*h];
ds = [alfa alfa/2*ones(1,nx-1)];
di = [alfa/2*ones(1,nx-1) alfa];
B = diag(dp)+diag(ds,1)+diag(di,-1);
for j = 1:nt
    p = k/2*(exp(-t(j))+exp(-t(j+1)))*ones(nx+1,1);
    p = B*U(:,j)+p;
    U(:,j+1) = Crout(d0,d1,d2,p)';              % solucin del sistema
end
