function U = imponda(nx,a,b,nt,T,f,g,l,r)

% Sintaxis: U=exponda07(nx,a,b,nt,T,'f','g','l','r')
% a,b: intervalo espacial
% nx,nt: nmero de subintervalos espaciales y temporales
% T: instante final
% f,g: archivos .m con la condicin inicial 
% l,r: archivos .m con las condiciones de contorno
%
h = (b-a)/nx;   
x = a:h:b;                          % vector de nodos espaciales
k = T/nt;       
t = 0:k:T;                          % vector de nodos temporales
fx = feval(f,x);  
fx = fx(:);
gx = feval(g,x);  
gx = gx(:);
lt = feval(l,t);    
rt = feval(r,t);
U = zeros(nx+1,nt+1);
U(:,1) = fx;    
U(1,:) = lt;    
U(nx+1,:) = rt;
L = 1:nx-1; C = 2:nx; R = 3:nx+1;   % rangos de ndices
U(C,2)=(k^2/(2*h^2))*(fx(L)+fx(R))+(k^2/2)*(2/k^2-2-2/h^2)*fx(C);  % Paso 1

d0 = (1/k^2+1/(2*k)+1/h^2)*ones(1,nx-1);
d1 = -1/(2*h^2)*ones(1,nx-2);

for j=2:nt                                           % pasos siguientes
    b = (2/k^2-2)*U(C,j)+(1/(2*k)-1/k^2-1/h^2)*U(C,j-1)+...
        1/(2*h^2)*(U(R,j-1)+U(L,j-1));
    b(1) = b(1)+1/(2*h^2)*U(1,j+1);                     
    b(nx-1) = b(nx-1)+1/(2*h^2)*U(nx,j+1);           % trminos indep.
    U(C,j+1) = Crout(d0,d1,d1,b)';                   % solucin del sistema
end
