function U = imponda08(nx,a,b,nt,T,c,f,g,l,r)
% Sintaxis: U = imponda(nx,a,b,nt,T,c,'f','g','l','r')
% f,g: archivos .m con las condiciones iniciales
% l,r: archivos .m con las condiciones de contorno
% nx, nt: nmero de subintervalos espaciales y temporales
% a,b: extremos de la cuerda
% T: instante final
h = (b-a)/nx;   
x = a:h:b;                               % vector de nodos espaciales
k = T/nt;       
t = 0:k:T;                               % vector de nodos temporales
fx = feval(f,x);  
fx = fx(:);
gx = feval(g,x);  
gx = gx(:);
lt = feval(l,t);    
rt = feval(r,t);
a2 = (c*k/h)^2;                          % parmetro de Courant
U = zeros(nx+1,nt+1);
U(:,1) = fx;    
U(1,:) = lt;    
U(nx+1,:) = rt;
L = 1:nx-1; C = 2:nx; R = 3:nx+1;        % rangos de ndices
U(C,2) = a2*(fx(L)+fx(R))/2+(1-a2-k^2/2)*fx(C)+k*gx(C);
d0 = -(1+a2)*ones(1,nx-1);
d1 = a2/2*ones(1,nx-2);
B=-diag(d0)-diag(d1,1)-diag(d1,-1);
for j=2:nt                                          % pasos siguientes
    d=B*U(2:nx,j-1)+(k^2-2)*U(2:nx,j);              % trminos indep.    
    z=Crout(d0,d1,d1,d);
    U(C,j+1) = z';                                  % solucin del sistema
end