function U = imponda09(nx,a,b,nt,T,f,l)

h = (b-a)/nx;   x = a:h:b;          % vector de nodos espaciales
k = T/nt;       t = 0:k:T;          % vector de nodos temporales

fx = feval(f,x);  fx = fx(:);
lt = feval(l,t);    

U = zeros(nx+1,nt+1);

U(:,1) = fx;    U(1,:) = lt;    

C = 2:nx+1;

a = 1/h^2+3/k^2;
b = 1/(2*h^2)+x/(2*h*k); 
c = 1/(2*h^2)-x/(2*h*k); 

dp = -2*a*ones(1,nx);
ds = b(C)+c(C);
di = ds;        di(nx) = 2*di(nx);
ti(1:nx)= -6/k^2*U(C,1)+cos(pi*x(C))';
ti(nx) = ti(nx)-4*h*t(2)*(b(nx+1)+c(nx+1));

U(C,2) = Crout(dp,ds,di,ti);

dpa = -a*ones(1,nx);
dsa = b(2:nx);
dia = [c(3:nx) b(nx+1)+c(nx+1)];

dpb = a*ones(1,nx);
dsb = -c(2:nx);
dib = [-b(3:nx) -b(nx+1)-c(nx+1)];

B = diag(dpb)+diag(dsb,1)+diag(dib,-1);

p = zeros(nx,1);
for j=2:nt                                           % pasos siguentes
    p(nx) = 4*h*(b(nx+1)*t(j+1)+c(nx+1)*t(j-1));
    d = -6/k^2*U(C,j)+B*U(C,j-1)+cos(pi*x(C))'-p;
    U(C,j+1) = Crout(dpa,dsa,dia,d)' ;
end