function U = expcalor10(nx,a,b,nt,T,f,c1,c2)
% Sintaxis: U = expcalor10(nx,a,b,nt,T,'f','c1','c2')
% nx: nmero de subintervalos espaciales
% nt: nmero de subintervalos temporales
% a,b: extremos del intervalo de variacin espacial
% T: instante final
% f: archivo .m con la condicin inicial
% c1,c2: archivos .m con las condiciones de contorno
h = (b-a)/nx;   
k = T/nt;
alfa = k/h^2;                                   % parmetro de Courant
x = a:h:b;      
t = 0:k:T;
U = zeros(nx+1,nt+1);                           % inicializacin matriz U
U(:,1) = feval(f,x);                            % solucin en t = 0
U(1,:) = feval(c1,t);                           % condiciones de contorno
U(nx+1,:) = feval(c2,t);                      
L = 1:nx-1; C = 2:nx; R = 3:nx+1;               % rangos de ndices
for j = 1:nt
    U(C,j+1)=(alfa+k*x(C)/(2*h))'.*U(R,j)+(-2*alfa+k+1)*U(C,j)+(alfa-k*x(C)/(2*h))'.*U(L,j);
end