function U = impcalor10(nx,a,b,nt,T,f,c1,c2)
% Sintaxis: U = impcalor10(nx,a,b,nt,T,'f','c1','c2')
% nx: nmero de subintervalos espaciales
% nt: nmero de subintervalos temporales
% a,b: extremos del intervalo de variacin espacial
% T: instante final
% f: archivo .m con la condicin inicial
% c1,c2: archivos .m con las condiciones de contorno
h = (b-a)/nx;   
x = a:h:b;                              % vector de nodos espaciales
k = T/nt;       
t = 0:k:T;                              % vector de nodos temporales
U = zeros(nx+1,nt+1);
U(:,1) = feval(f,x)';
U(1,:) = feval(c1,t);    
U(nx+1,:) = feval(c2,t);
L = 1:nx-1; C = 2:nx; R = 3:nx+1;       % rangos de ndices
d0 = (1-k+2*k/h^2)*ones(1,nx-1);
d1 = -(k/h^2+k*x(C)/(2*h));
d2 = -(k/h^2-k*x(C)/(2*h));
for j = 2:nt+1
    b = U(C,j-1);
    b(1) = b(1) + (k/h^2-k*x(2)/(2*h))*U(1,j);
    b(nx-1) = b(nx-1) + (k/h^2+k*x(nx)/(2*h))*U(nx+1,j);
    U(C,j) = Crout(d0,d1,d2,b)';        % solucin del sistema
end
