function menupcn(tema, prob, apar, modo)

% Men de demos del libro 
%
% Problemas resueltos de Mtodos Numricos
% A. Cordero, J.L. Hueso, E. Martnez, J.R. Torregrosa
% Ed. Thomson
%
% MENUPCN abre el men grfico del libro, desde el que se accede al men de
% cada tema.
% 
% MENUPCN(TEMA) abre el men grfico del TEMA (del 1 al 10), desde el que
% se accede a la  demo de cada poblema.
%
% MENUPCN(TEMA, PROBLEMA) lanza directamente la demo del PROBLEMA (del 1 al
% 10) del TEMA (del 1 al 10).
%
% APAR se aplica en algn caso. Puede utilizarse para disponer de versiones
% distintas de un problema.
%
% MODO controla el aspecto de la ventana de la demo. La opcin por defecto
% es SMALLTEXT, en la que la grfica ocupa parte de la pantalla. La opcin
% LARGETEXT abre una ventana de slo texto.

% jlh, nov 2006

N = 1:10;
switch nargin 
    case 0
        menupcn(0)
    case 1
        if ismember(tema, [0, N])
            txtema = num2str(tema);
            if tema < 10
                txtema = ['0', txtema];
            end
            addpath(['.\dm',  txtema])
            eval(['dm', txtema])
        else
            error('Nmero de tema fuera del rango (de 0 a 10)')
        end
    case {2, 3, 4}
        if ismember(tema, N)
            txtema = num2str(tema);
            if tema < 10
                txtema = ['0', txtema];
            end
            addpath(['.\dm',  txtema])
        else
            error('Nmero de tema fuera del rango (de 1 a 10)')
        end
        if ismember(prob, N)
            txprob = num2str(prob);
            if prob<10
                txprob = ['0', txprob];
            end
            addpath(['.\dm', txtema, '\dm', txtema, txprob])
            % Lanzar la proyeccin
            if nargin <4
                modo = '';
                if nargin < 3
                    apar = '';
                end
            end
            eval(['playshow  dm',  txtema, txprob, apar, ' ', modo])
        else
            error('Nmero de problema fuera del rango (de 1 a 10)')
        end
    otherwise
        error('Demasiados argumentos de entrada')
end
